
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *
 * IBM Tivoli Access Manager for Operating Systems 6.0.0
 * 5698-PDO
 * Licensed Materials - Property of IBM
 * 
 * (C) Copyright IBM Corp. 2000,2006. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 *
*/

static char sccsid[]="@(#)07	1.83  src/oss/kazn/kazn/kazn_checkaccess.c, oss.kazn.src, oss600, 050722a  7/15/05  13:22:30";
#include <linux/kernel.h>

#include <linux/stddef.h>


#include <asm/string.h>

#include <asm/byteorder.h>






#include <linux/stat.h>


#include <linux/limits.h>

#include <linux/errno.h>

#include <asm/ptrace.h>

#include <asm/fcntl.h>
  typedef int intptr_t;


 typedef unsigned int uintptr_t;


typedef __kernel_uid32_t uid32_t;
typedef __kernel_gid32_t gid32_t;
typedef struct kail_vfs
{
    void *mnt;
    void *mnt_parent;
    char devname[64];
} kail_vfs_t;






typedef struct {
        long val[2];
} kail_fsid_t;

typedef struct kail_fid {
    uint32_t fid_ino;
    uint32_t fid_gen;
    uint16_t fid_flags;
    uint16_t fid_data_len;

    char fid_data[(sizeof(char) * 64)];
} kail_fid_t;

typedef mode_t kail_fmode_t;
typedef dev_t kail_dev_t;
typedef void * kail_vnodeH_t;
typedef struct _kail_rfid {
    uint32_t ctime;
    kail_fsid_t fsid;
    kail_fid_t fid;
} kail_rawFid_t;
typedef struct _kail_cred {

        uid_t uid,euid,suid,fsuid;
        gid_t gid,egid,sgid,fsgid;
        int ngroups;
        int cr_ref;
        gid_t groups[32 ];
} kail_cred_t;

typedef int64_t kail_authID_t;
enum kail_ftypes { KAIL_FTYPE_NONE, KAIL_FTYPE_FILE, KAIL_FTYPE_DIR,
             KAIL_FTYPE_BLKDEV, KAIL_FTYPE_CHARDEV, KAIL_FTYPE_LNK,
             KAIL_FTYPE_SOCK, KAIL_FTYPE_BAD, KAIL_FTYPE_FIFO,
             KAIL_FTYPE_MPC, KAIL_FTYPE_OTHER};
typedef enum kail_ftypes kail_ftypes_t;

typedef struct _kail_fattr {
    kail_authID_t uid;
    kail_authID_t gid;
    kail_ftypes_t ftype;
    kail_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    dev_t dev;
    kail_vfs_t check_vfsp;
} kail_fattr_t;




extern volatile struct timespec *kail_xtime;





extern asmlinkage int (*kail_printk)(const char *, ...);
extern asmlinkage int (*kail_sprintf)(char * buf, const char * fmt, ...);
extern asmlinkage int (*kail_do_fork)(unsigned long, unsigned long, struct pt_regs *, unsigned long);


extern asmlinkage int kail_kernel_thread(int (*)(void *), void *,unsigned long);
extern asmlinkage int kail_kill_proc(pid_t, int, int);
extern asmlinkage long kail_strncpy_from_user(char *, const char *, long);
extern asmlinkage long kail_strncpy_from_DND(char *, void *, long);
extern unsigned long FASTCALL(kail_copy_to_user(void *, const void *, unsigned long));
extern unsigned long FASTCALL(kail_copy_from_user(void *, const void *, unsigned long));

extern void FASTCALL(kail_kernel_free(void *,unsigned long));
extern void * FASTCALL(kail_kernel_malloc(unsigned long));





extern asmlinkage void kail_mutex_init(void **);
extern void FASTCALL(kail_mutex_lock(void **));
extern int FASTCALL(kail_mutex_trylock(void **));
extern void FASTCALL(kail_mutex_unlock(void **));
extern asmlinkage void kail_mutex_destroy(void **);

extern asmlinkage void kail_cond_init(void **);
extern void FASTCALL(kail_wake_up(void **));
extern void FASTCALL(kail_cond_wait(void **, void **));
extern int FASTCALL(kail_cond_wait_intr(void **, void **));
extern asmlinkage int kail_condTimedWait(void **, void **, int64_t, int);
extern asmlinkage void kail_cond_destroy(void **);

extern asmlinkage void kail_iclock_init(void **);
extern void FASTCALL(kail_iclock_lock(void **));
extern void FASTCALL(kail_iclock_unlock(void **));
extern int FASTCALL(kail_iclock_trylock(void **));
extern asmlinkage void kail_iclock_destroy(void **);

extern void FASTCALL(kail_iclock_cond_wait(void **,void **));

extern asmlinkage int kail_current_pid(void);
extern asmlinkage int kail_current_tid(void);
extern asmlinkage int kail_current_Ppid(void);
extern int FASTCALL(kail_tid_to_pid(int));

extern pid_t FASTCALL(kail_pid_get_epid(pid_t));
extern void FASTCALL(kail_pid_delete(pid_t));
extern void FASTCALL(kail_epid_delete(pid_t));
extern void FASTCALL(kail_pid_add(pid_t,pid_t));

extern asmlinkage int kail_current_uid(void);
extern asmlinkage int kail_current_euid(void);
extern asmlinkage int kail_current_suid(void);
extern asmlinkage int kail_current_gid(void);
extern asmlinkage int kail_current_egid(void);
extern int FASTCALL(kail_current_files_close_on_exec(int));

extern asmlinkage int kail_socket_protocol(void *);
extern asmlinkage int kail_socket_getname(void *,void *,int *,int);

extern int FASTCALL(kail_fd_to_dev(int, dev_t *));
extern int FASTCALL(kail_fd_to_name(int, char **, int *));
extern int FASTCALL(kail_fd_to_socket(int,void **));

extern int FASTCALL(kail_socket_shutdown(void *));




extern int FASTCALL(kail_check_pid(int));
extern int FASTCALL(kail_get_pid_pgrp(int,int *));
extern int FASTCALL(kail_get_pid_uid(int,int *,int *));
extern void FASTCALL(kail_scan_procs(void *));

extern asmlinkage void kail_daemonize(const char *);
extern asmlinkage int kail_total_ram_mb(void);
extern void FASTCALL(kail_atomic_add(int,void *));

extern asmlinkage int kail_kernel_address_mode(void);






extern asmlinkage int kail_decomposePath(char *, int, kail_rawFid_t *, int *, kail_rawFid_t *, int *, kail_fattr_t *, kail_vnodeH_t *);
extern asmlinkage int kail_LookupFidAndDir(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, int *);
extern asmlinkage int kail_lookupFidsAndInfo(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, kail_vnodeH_t *, kail_vnodeH_t *, int *);
extern asmlinkage int kail_dirFidToPathFids( kail_rawFid_t *, kail_rawFid_t **, int *);
extern asmlinkage int kail_unixDescToRawFid( int , kail_rawFid_t *);
extern asmlinkage int kail_vnodesToFids( kail_vnodeH_t, kail_vnodeH_t, kail_rawFid_t *, kail_rawFid_t *, kail_rawFid_t **, int *, kail_fattr_t *);
extern asmlinkage int kail_makeFidChain(void *, kail_rawFid_t *, int *, const kail_cred_t *, int );




struct kail_register_chrdev_parameters {
        unsigned int dev_number;
        char *name;
        void *ownerp;
        void *readp;
        void *writep;
        void *ioctlp;
        void *openp;
        void *releasep;
        unsigned int ioctl_cnt;
        unsigned int *ioctl_cmds;
} ;

extern asmlinkage int kail_register_chrdev(struct kail_register_chrdev_parameters *, void **);
extern asmlinkage int kail_unregister_chrdev(struct kail_register_chrdev_parameters *, void *);
extern int FASTCALL(kail_minor(void *));

extern asmlinkage int kail_file_read(char *, kail_vnodeH_t *,char *, long, long);
extern asmlinkage void kail_write_log(const char *,const char *, int, int);
extern asmlinkage void kail_log_init(const char *);

extern asmlinkage int kail_pathToFullPath( char *, int , char **, char *,int);
extern void * FASTCALL(kail_unixDescToVnode(int));
extern void FASTCALL(kail_releVnode(void *));
extern void FASTCALL(kail_holdVnode(void *));
extern asmlinkage char * kail_readSymLink(char *, int *);



extern asmlinkage int kail_vfs_mounted(kail_vfs_t *);
extern asmlinkage int kail_vfs_check(kail_vfs_t *);


typedef struct {
        void *alloc;
        void *free;
        void *fcc_find;
        void *fcc_add;
} kail_call_back_t;

extern asmlinkage void kail_call_backs(kail_call_back_t *);
extern asmlinkage void kail_kernel_interface(void);
extern asmlinkage void kail_kernel_interface_shutdown(void);

typedef asmlinkage long (* sys_call_fn)();
struct kail_syscall_prepost {
        int call_index;
        sys_call_fn call_pre;
        sys_call_fn call_post;
};

extern int struct_cppath_size;

extern asmlinkage int kail_trap_syscalls(struct kail_syscall_prepost *);



extern asmlinkage void kail_restore_syscalls(void);

struct nameidata;
struct kail_datanameidata {
        char cdata[4];
        char *path;
        struct nameidata *nd;
};
#define KAIL_LOOKUP_BIT 0x40000000
#ifdef LINUX_RHEL4
#define SET_LOOKUP_FLAG(n) (n)->intent.open.flags = KAIL_LOOKUP_BIT;
#define CLEAR_LOOKUP_FLAG(n) (n)->intent.open.flags &= ~KAIL_LOOKUP_BIT;
#define CHECK_LOOKUP_FLAG(n) ((n)->intent.open.flags == KAIL_LOOKUP_BIT)
#endif 
#ifdef LINUX_SLES9
#define SET_LOOKUP_FLAG(n)
#define CLEAR_LOOKUP_FLAG(n)
#define CHECK_LOOKUP_FLAG(n)
#endif 
typedef unsigned char byte_t;





typedef int64_t oss_uid_t;
typedef int64_t oss_gid_t;
typedef struct {
    int ipV6:1;
    int ipV6V4Mapped:1;
    int ipV6V4Compat:1;
    union {
        uint32_t a32[4];
        uint16_t a16[8];
        uint8_t a8[16];
        struct {
            uint32_t pad[3];
            uint32_t addr;
        } addrClassic;
    } addr;
} oss_nwIP_t;





typedef struct {
    uint16_t protocol;
    uint16_t port;
} oss_nwService_t;

typedef struct {
    oss_nwIP_t ip;
    oss_nwService_t service;
} oss_nwAddr_t;

typedef struct {
    uint32_t count;
    oss_nwIP_t* ip;
} oss_nwIPList_t;

typedef struct {
    uint32_t count;
    char** name;
} oss_nwNameList_t;
typedef pid_t tid_t;



typedef pid_t pal_pid_t;
typedef tid_t pal_tid_t;




typedef unsigned long pal_scall_parm_t;


typedef void * pal_caller_t;



typedef kail_fmode_t pal_fmode_t;
typedef kail_dev_t pal_dev_t;
typedef kail_vnodeH_t pal_vnodeH_t;
typedef kail_vfs_t pal_vfs_val_t;



typedef kail_fsid_t pal_fsid_t;
typedef kail_fid_t pal_fid_t;
typedef kail_cred_t cred_t;

static inline int pal_pinMem(void *mem, size_t size)
{ return 0; }

static inline int pal_unpinMem(void *mem, size_t size)
{ return 0; }
static inline int pal_copyin(char *uaddr, char *kaddr, size_t count)
{
    return (int)kail_copy_from_user(kaddr, uaddr, count);
}
static inline int pal_copyout(char *kaddr, char *uaddr, size_t count)
{
    return (int)kail_copy_to_user(uaddr, kaddr, count);
}
static inline int
pal_copyinstr(char *uaddr, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_user(kaddr, uaddr, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int
pal_copyinstr_LSM(void *dnd, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_DND(kaddr, dnd, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int pal_suser(void)
{
    return (kail_current_euid() == 0);
}
static inline int
pal_unixDescIsCOE(int fd)
{
        return kail_current_files_close_on_exec(fd);
}
static inline void
pal_releVnode(pal_vnodeH_t vnh)
{
    ;
    kail_releVnode((void *)vnh);
}
static inline void
pal_holdVnode(pal_vnodeH_t vnh)
{
    ;
    kail_holdVnode((void *)vnh);
}





typedef void * pal_mutex_t;
typedef void * pal_cond_t;
typedef void * pal_icLock_t;
static inline int
pal_file_read(char *path, pal_vnodeH_t vnodeH, char *buffer, long offset, long len)
{
        return kail_file_read(path,vnodeH,buffer,offset,len);
}
extern char *pal_immunePrograms[];

extern char *pal_loginPrograms[];






extern void pal_machInit(void);
extern void pal_machShutdown(void);
extern int pal_mapOpenFlags(int);
extern void pal_fccInit(void);
extern void pal_fccShutdown(void);
extern void pal_fccFlush(void);
extern int pal_checkLoginBypassMach(char *, int, void *,void *, int32_t *);

extern void pal_errLogInit(void);
typedef oss_nwAddr_t pal_nwAddr_t;







typedef struct _pal_time {
    uint32_t secs;
    int32_t usecs;
} pal_timestruct_t;




typedef int64_t pal_time_t;
typedef oss_uid_t pal_uid_t;
typedef oss_gid_t pal_gid_t;

typedef pal_uid_t pal_authID_t;


typedef uint32_t pal_ptr32_t;
typedef struct _ids {
    pal_authID_t idVal;
    int setMask;
} pal_idSet_t;
typedef struct _idlist {
    pal_authID_t realId;
    pal_authID_t effId;
    pal_authID_t accId;


} pal_idList_t;
enum pal_ftypes { PAL_FTYPE_NONE, PAL_FTYPE_FILE, PAL_FTYPE_DIR,
             PAL_FTYPE_BLKDEV, PAL_FTYPE_CHARDEV, PAL_FTYPE_LNK,
             PAL_FTYPE_SOCK, PAL_FTYPE_BAD, PAL_FTYPE_FIFO,
             PAL_FTYPE_MPC, PAL_FTYPE_OTHER};
typedef enum pal_ftypes pal_ftypes_t;
typedef struct _fattr {
    pal_authID_t uid;
    pal_authID_t gid;
    pal_ftypes_t ftype;
    pal_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    pal_dev_t dev;
    pal_vfs_val_t check_vfsp;
} pal_fattr_t;
typedef struct _rfid {
    uint32_t ctime;
    pal_fsid_t fsid;
    pal_fid_t fid;
} pal_rawFid_t;
typedef struct pal_ph {
    char *path;
    char *pbuf;
    int pathLen;
    int pbLen;
    int flags;
} pal_pathBuf_t;
extern int pal_sysMemMB;
typedef char * pal_pathMemInfo_t;
extern char *pal_readSymLink(char *, int *);





extern void pal_delay(int);
extern int pal_kthreadCreate(void (*)(), void *, char *);
extern pal_authID_t pal_getEGid(void);







extern void pal_logErrMach(char *, int);
typedef char * sharedMemPtr_t;
extern char *pal_alloc(size_t);
extern void pal_free(void *, size_t);



extern void pal_getAllocInfo(int *, size_t *);
extern void pal_logErr(int, char *);
extern int pal_copyin(char *, char *, size_t);
extern int pal_copyinstr(char *, char *, size_t, size_t *);
extern int pal_copyout(char *, char *, size_t);
extern int pal_decomposePath(char *, int, pal_rawFid_t *, int *,
                        pal_rawFid_t *, int *, pal_fattr_t *, pal_vnodeH_t *);
extern int pal_LookupFidAndDir(char *, int, pal_rawFid_t *,
                               pal_rawFid_t *, pal_fattr_t *, int *);
extern int pal_vnodesToFids(pal_vnodeH_t, pal_vnodeH_t,
                            pal_rawFid_t *, pal_rawFid_t *, pal_rawFid_t **,
                            int *, pal_fattr_t *);
extern int pal_pathToFullPath(char *, int, pal_pathBuf_t *);
extern int pal_dirFidToPathFids(pal_rawFid_t *, pal_rawFid_t **, int *);
extern int pal_unixDescToRawFid(int, pal_rawFid_t *);
extern pal_vnodeH_t pal_unixDescToVnode(int);
extern int pal_unixDescToBaseName(int, pal_vnodeH_t, pal_pathBuf_t *);
extern int pal_unixDescIsCOE(int);



extern int pal_suser(void);
extern pal_authID_t pal_getEuid(void);
extern void pal_getREUids(pal_idList_t *);
extern void pal_holdVnode(pal_vnodeH_t);
extern void pal_releVnode(pal_vnodeH_t);
extern int pal_pinMem(void *, size_t);
extern int pal_unpinMem(void *, size_t);
extern int pal_getLocalTermDevice(char *, int, pal_dev_t *);
int pal_checkInheritLoginState(char *, uint32_t, int32_t, int32_t *);
int pal_execChecking(char *, int32_t *, uint32_t *, uint32_t *);
void pal_loginOriginWasReset(int32_t *);
extern int pal_checkLoginBypass(char *, int,
                                pal_idSet_t *, pal_idList_t *, int32_t *);
extern int32_t pal_devToInt32(pal_dev_t);
extern int pal_isImmunePath(char *);
extern int pal_expandExecArgs(void *, char *, int, int);


extern int pal_lookupFidsAndInfo(char *, int, pal_rawFid_t *,
        pal_rawFid_t *, pal_fattr_t *, pal_vnodeH_t *, pal_vnodeH_t *, int *);
extern int pal_pathFidsFromDirVnh(pal_vnodeH_t, pal_rawFid_t *, int *);
extern int pal_file_read(char *,pal_vnodeH_t,char *, long, long);





extern void pal_init(void);
extern void pal_shutdown(void);
typedef struct kutil_q {
    struct kutil_q *next;
    struct kutil_q *prev;
} kutil_q_t, kutil_qHead_t;
typedef void * kenv_pathReqHandle_t;







typedef struct kenv_pathMemInfo {
    kenv_pathReqHandle_t handle;
    uint16_t pathFlags, palFlags;
    uint32_t memSerial;
    pal_pathMemInfo_t palInfo;
} kenv_pathMemInfo_t;

extern int kenv_pathMemInit(int, uint32_t, uint32_t);
extern int kenv_pathMemFini(void);

extern uint32_t kenv_pathGetMemSerial(void);
extern int kenv_pathMemCurrent(uint32_t serial);
extern int kenv_pathMemService(void);
extern int kenv_pathMemHelper(int, uint32_t *);
extern void kenv_pathMemStop(int shutdown);

extern int kenv_pathMemGet(char *, int, kenv_pathMemInfo_t *);
extern int kenv_pathMemWaitReady(kenv_pathMemInfo_t *);
extern void kenv_pathMemCancel(kenv_pathReqHandle_t);
extern int kenv_pathMemPut(void *, kenv_pathMemInfo_t *);
extern uint32_t kenv_pathMemOffset(kenv_pathReqHandle_t);


extern int kenv_pathGetShmid(void);



extern int kenv_pathDebug;
typedef uint32_t kenv_procFlags_t;
typedef struct kenv_procPidList {
    pal_pid_t *pids;
    int listAllocSize;
} kenv_procPidList_t;

typedef struct procStats {
    uint32_t procAdds;
    uint32_t activeProcs;
    uint32_t fdTableGrows;
    uint32_t hashBoosts;
} kenv_procStats_t;



extern kenv_procStats_t kenv_procStats;

extern void kenv_procAdd(pal_pid_t, pal_pid_t, int);
extern int kenv_procConditionalAdd(pal_pid_t, pal_pid_t, int);
extern int kenv_procDelete(pal_pid_t);
extern int kenv_procSetProgramData(pal_pid_t, pal_rawFid_t *, pal_rawFid_t *,
                                   pal_fattr_t *, char *, kenv_procFlags_t *,
                                   int);
extern int kenv_procGetProgramInfo(pal_pid_t, char *,
                                   int *, pal_rawFid_t *,
                                   pal_fattr_t *,
                                   pal_rawFid_t *, int *);
extern int kenv_procRegisterPid(pal_pid_t);
extern int kenv_procIsPrivPid(pal_pid_t);
extern int kenv_procGetInfo(pal_pid_t, kenv_procFlags_t *,
                            pal_idList_t *, pal_rawFid_t *);
extern int kenv_procGetInfoExt(pal_pid_t, kenv_procFlags_t *,
                               pal_idList_t *, void **);
extern int kenv_procGetProcPPid(pal_pid_t, pal_pid_t *);
extern int kenv_procGetInfoNotPar(pal_pid_t, void *, kenv_procFlags_t *,
                                  pal_idList_t *, pal_rawFid_t *);
extern pal_pid_t kenv_procGetFlagsAndIds(kenv_procFlags_t *, pal_idList_t *);
extern pal_pid_t kenv_procGetFlagsAndIdsExt(kenv_procFlags_t *, pal_idList_t *,
                                            void **);
extern int kenv_procGetProgramFid(pal_pid_t,
                            pal_rawFid_t *, pal_rawFid_t *, pal_fattr_t *);
extern int kenv_procAddProcFlags(pal_pid_t, kenv_procFlags_t *);
extern int kenv_procDelProcFlags(pal_pid_t, kenv_procFlags_t, int);
extern int kenv_procSetImpId(pal_pid_t, pal_authID_t);
extern int kenv_procAddFd(pal_pid_t, int, void *);
extern void kenv_procCloseFd(pal_pid_t, int);
extern void kenv_procLazyCloseFd(pal_pid_t, int);
extern pal_vnodeH_t kenv_procGetFdDirVnode(pal_pid_t, int);
extern void kenv_procCloseAllFdesc(pal_pid_t, int);
extern void kenv_procSetFdFlags(pal_pid_t, int, int);
extern void kenv_procDupFd(pal_pid_t, int, int);
extern int kenv_procGetRterm(pal_pid_t, pal_nwAddr_t *);
extern int kenv_procCheckSetRterm(pal_pid_t, pal_nwAddr_t *);
extern int kenv_procCheckGetRterm(pal_pid_t, pal_nwAddr_t *);
extern void kenv_procPurgeStale(int);
extern void kenv_procUpdateAccId(pal_pid_t, pal_authID_t);

extern int kenv_procAddProcFlagsByName(char *, pal_rawFid_t *,
                                       kenv_procFlags_t, int);
extern int kenv_procGetRegisteredCount(void);
extern void kenv_procFdCloseAll(void);
extern int32_t kenv_procGetLoginState(pal_pid_t);
extern void kenv_procSetLoginState(pal_pid_t, int32_t);
extern void kenv_procSetDirectLoginID(pal_pid_t, pal_authID_t);
extern int kenv_procGetDirectLoginID(pal_pid_t, pal_authID_t *);
extern int kenv_procSetLocalTerm(pal_pid_t, char *, int);
extern int kenv_procGetTrueAccId(pal_pid_t, pal_authID_t *);
extern int kenv_procGetPidList(kenv_procPidList_t **, kenv_procFlags_t);
extern void kenv_procFreePidList(kenv_procPidList_t *);
extern void kenv_procFreeAllLazyCloses(void);
extern int kenv_procIncStreamCount(pal_pid_t);
extern int kenv_procDecStreamCount(pal_pid_t, void *);




extern int kenv_procClearExecData(pal_pid_t);
extern void kenv_procClearExecMem(void *);
extern void kenv_procSavePutMemInfo(kenv_pathMemInfo_t *);
extern void kenv_procResetSharedMem(pal_pid_t);
extern sharedMemPtr_t kenv_procGetPathMem(char *,int,kenv_pathMemInfo_t *,
                                          int *);
extern void kenv_procPutPathMem(void *, kenv_pathMemInfo_t *);
extern int kenv_procCheckShmat(void *, kenv_pathMemInfo_t *);
extern int kenv_procIsCopyShmid(int);

extern void kenv_procInit(void);
extern void kenv_procShutdown(void);
typedef struct kpc_resFlags {






    int isLoginPgm:1;

    int isSecPgm:1;


    int isSecFile:1;

    int isXdmPgm:1;

    int isImpersonator:1;




    int hasAcl:1;


    int isTCB:1;



    int hasCond:1;






    int isWC:1;







    int isPrivPgm:1;


    int isTerminal:1;




    int defToNWTerm:1;
    int hasViaPgm:1;

    int hasTod:1;

    int condOther:1;



    int isRootDir:1;

    int isImSurPgm:1;


    int isVia:1;


    int hasPop:1;

    int hasAuthz:1;
} kpc_resFlags_t;
extern uint32_t kutil_kossInitTime;

extern void kutil_freeStringWithLocal(char *, char *, int);
extern int kutil_setStringWithLocal(char *, int *, char *, int, char **);
extern char *kutil_prefixString(char *, int, char *, int *, int);

extern void kutil_pathBaseName(char *);
extern char * kutil_pathExtractBaseName(char *);
extern void kutil_pathToDotPath(char *, int);

extern char* kutil_pathToDotPathAndLeaf(char *, int);

extern void kutil_pathToDotDotPath(char *, int);
extern int kutil_pathCleanupTail(char *, int *);
extern int kutil_commonInit(void);
extern int kutil_commonShutdown(void);




extern void kutil_privInit(void);
extern void kutil_privShutdown(void);
extern int kutil_privCheck(int, pal_authID_t);
extern int kutil_isPrivUid(pal_authID_t);
typedef void (*kpc_res_rele_func_t)(void *);
typedef struct kpcInfo {
    struct kpcInfo *next;
    struct kpcInfo *prev;
    char *resName;
    kpc_resFlags_t resFlags;
    uint32_t kpcFlags;
    uint32_t branchId;
    byte_t *extData;
    uint16_t resNameLen;
    uint16_t extDataLen;
    union {
        struct __f {
            pal_rawFid_t *poFid;
            pal_ftypes_t poFtype;
            int32_t kpcFileAddGen;
            pal_rawFid_t __poFid;
        } f;
        struct __nw {
            int64_t policyVersion;
            pal_ptr32_t pUserRes;
            void *pRes;
            kpc_res_rele_func_t relef;
        } nw;
    } resData;

    char __resName[48];
} kenv_kpcInfo_t;
typedef struct filetgt {
    char *trappedNameRef;
    char *baseName;
    pal_pathBuf_t *fullSrnRef;
    pal_rawFid_t *dir_rfidp;
    pal_rawFid_t *pathFids;
    pal_vnodeH_t dir_vnh;
    pal_vnodeH_t vnh;
    struct filetgt *auxFile;
    int tnLen;
    int pathFidsCount;
    int pathFidsAlloced;
    pal_rawFid_t rfid;
    pal_fattr_t fattrs;
    pal_pid_t killPid;


    void *tgt_nd;
    void *aux_tgt_nd;


    pal_rawFid_t _fids[5];
} kenv_fileTgt_t;






typedef struct pgmInfo {
    kenv_procFlags_t procFlags;
    char *pgmSRN;
    char *pgmKPON;
    pal_rawFid_t pgmFid;
    pal_rawFid_t pgmDFid;
    pal_fattr_t pgmFattrs;
    struct pgmInfo *saveArea;
    int16_t __srnLen;
    int16_t __kponLen;
    char __srn[32];
    char __kpon[32];
} pgmInfo_t;
typedef void * kenv_envHandle_t;

typedef struct kenv_env {
    int magic;
    uint32_t flags;
    pal_pid_t pid;
    int envError;



    union {



        struct {
            kenv_fileTgt_t f;
            pal_idSet_t idSet;
            pal_dev_t termDev;
            char *localTermName;
            pal_nwAddr_t nwTermAddr;
            byte_t *termExtData;
            int termExtDataLen;
        } fs;



        struct {
            pal_nwAddr_t addrRemote;
            pal_nwAddr_t addrLocal;
        } nw;
    } tgt;




    pal_idList_t idList;




    pgmInfo_t accPgm;




    int kpcInfoCount;
    kenv_kpcInfo_t *kpcInfoHead;
    kenv_kpcInfo_t *curKPCInfo;
    kenv_kpcInfo_t _kpcInfo;



    void *auxDatap1;
} kenv_env_t;
extern pal_authID_t kenv_envGetAuthID(kenv_envHandle_t);
extern pal_idList_t *kenv_envGetIdListRef(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetRawFid(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetPathFids(kenv_envHandle_t, int *);
extern void kenv_envSetPathFids(kenv_envHandle_t, int, pal_rawFid_t *);
extern void kenv_envSetRfid(kenv_envHandle_t, pal_rawFid_t *, pal_fattr_t *);
extern void kenv_envSetFattr(kenv_envHandle_t, pal_fattr_t *);
extern pal_fattr_t *kenv_envGetFattr(kenv_envHandle_t);
extern void kenv_envSetKPCInfo(kenv_envHandle_t , kenv_kpcInfo_t *);
extern kenv_kpcInfo_t * kenv_envGetKPCInfo(kenv_envHandle_t);
extern void kenv_envResetKPCInfo(kenv_envHandle_t);
extern void kenv_envSetNextKPCInfo(kenv_envHandle_t);
extern void kenv_envSetFirstKPCInfo(kenv_envHandle_t);
extern void kenv_envResetKPCInfoResName(kenv_envHandle_t,
                                        kenv_kpcInfo_t *, char *, int);
extern char * kenv_envGetProgram(kenv_envHandle_t);
extern pal_rawFid_t *
        kenv_envGetPgmFidAndDirFid(kenv_envHandle_t,
                                   pal_rawFid_t **, pal_fattr_t **);
extern char *kenv_envSetPgmResource(kenv_envHandle_t, char *, int);
extern char *kenv_envGetPgmResource(kenv_envHandle_t);
extern void kenv_envSetAuxFileActive(kenv_envHandle_t, int);
extern char *kenv_envGetTrappedName(kenv_envHandle_t, int *);
extern char *kenv_envGetBaseName(kenv_envHandle_t);
extern void kenv_envSetImpProcAccId(kenv_envHandle_t, pal_authID_t);
extern void kenv_envProgramExecUpdate(kenv_envHandle_t);
extern void kenv_envSaveProgramState(kenv_envHandle_t);
extern void kenv_envRestoreProgramState(kenv_envHandle_t);
extern void kenv_envTrackOpenFd(kenv_envHandle_t, int, int);
extern int kenv_envGetFdInfo(kenv_envHandle_t, int);
extern void kenv_envGetTerminals(kenv_envHandle_t,
                                 pal_dev_t **, pal_nwAddr_t **);
extern pal_dev_t *kenv_envGetTermDev(kenv_envHandle_t);
extern char *kenv_envSetLocalTermName(kenv_envHandle_t, char *);
extern byte_t *kenv_envSetTermExtData(kenv_envHandle_t, int, byte_t *);
extern byte_t *kenv_envGetTermExtData(kenv_envHandle_t, int *);
extern pal_nwAddr_t *kenv_envGetNWTerm(kenv_envHandle_t);
extern void kenv_envResetTargetData(kenv_envHandle_t, int);
extern char *kenv_envFdToBname(kenv_envHandle_t);
extern pal_pathBuf_t *kenv_envGetFullSrnRef(kenv_envHandle_t);
extern void kenv_envSetFullSrnRef(kenv_envHandle_t, pal_pathBuf_t *);
extern pal_rawFid_t *kenv_envBuildPathFids(kenv_envHandle_t, int *);
extern pal_rawFid_t *kenv_envGetDirRawFid(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetFidsAndFattrs(kenv_envHandle_t,
                                              pal_rawFid_t **, pal_fattr_t **);

extern int kenv_envSetKPCCurrent(kenv_envHandle_t, char *);




extern void kenv_envSetTrappedNameRef(kenv_env_t *, char *, int);
extern void kenv_envInit(kenv_env_t *);
extern void kenv_envClean(kenv_env_t *);
extern int kenv_envProcessTrappedPath(kenv_env_t *, int);
extern int kenv_envProcessAuxPath(kenv_env_t *, char *, int, int);
extern void kenv_envUpdateACLInfo(kenv_env_t *);
extern void kenv_envInitialize(void);
extern void kenv_envShutdown(void);
extern kenv_env_t *kenv_envAllocEnv(void);
extern void kenv_envFreeEnv(kenv_env_t *);
typedef void *kt_chanID_t;

typedef struct _kt_chan {
    uint32_t active;
    pal_mutex_t lock;
    char name[40];
} kt_channel_t;
extern kt_channel_t kt_defChannels[];

extern void kt_logString(int, char *);
extern void kt_Event0(kt_chanID_t, int, unsigned int);
extern void kt_Event1(kt_chanID_t, int, unsigned int, long);
extern void kt_Event2(kt_chanID_t, int, unsigned int, long, long);
extern void kt_Event3(kt_chanID_t, int, unsigned int, long, long, long);
extern void kt_Event4(kt_chanID_t, int, unsigned int, long, long, long, long);
extern void kt_Event5(kt_chanID_t, int, unsigned int,
                      long, long, long, long, long);
extern void kt_zeroLog(void);
extern void kt_setChannelActive(char *, int);
extern void kt_intError(int, int, int, int);
extern void kt_init(void);
extern void kt_shutdown(void);
enum kt_msgs {
    KT_TRACE_DUMMY = 1024,
    KT_TRACE_STR,
    KT_TRACE_INT,
    KT_TRACE_LKUPNAME,
    KT_TRACE_PROCESS_PATH,
    KT_TRACE_NOFID,
    KT_TRACE_TRACK_OPEN,
    KT_TRACE_KAZN_PATH_ACCESS,
    KT_TRACE_KAZN_PATH_ACCESS_RTN,
    KT_TRACE_KPC_NOTIFY,
    KT_TRACE_KPC_NOTIFY_RTN,
    KT_TRACE_KPC_GETATTR,
    KT_TRACE_KPC_GETATTR_RTN,
    KT_TRACE_KPC_SETVERSION,
    KT_TRACE_KPC_SETVERSION_RTN,
    KT_TRACE_KPC_SETEPOCH,
    KT_TRACE_KPC_SETEPOCH_RTN,
    KT_TRACE_KOSS_SYSCALL,
    KT_TRACE_KOSS_SYSCALL_RTN,
    KT_TRACE_KOSS_REGISTER,
    KT_TRACE_KOSS_REGISTER_RTN,
    KT_TRACE_KOSS_SET_PRIVID,
    KT_TRACE_KOSS_SET_PRIVPID,
    KT_TRACE_KOSS_ALLOC_FAIL,
    KT_TRACE_KOSS_INT_ERR,
    KT_TRACE_KAUD_SETLEVEL,
    KT_TRACE_KAUD_SETLEVEL_RTN,
    KT_TRACE_KAUD_AUD_SERVICE,
    KT_TRACE_KAUD_AUD_SERVICE_RTN,
    KT_TRACE_CSC_SETGROUPS,
    KT_TRACE_KOSS_PRIVCHECK,
    KT_TRACE_KOSS_PRIVCHECK_IDS,
    KT_TRACE_KOSS_PRIVCHECK_RTN,
    KT_TRACE_CSC_SUID,
    KT_TRACE_CSC_SUID2,
    KT_TRACE_CSC_SGID,
    KT_TRACE_CSC_SUID_BYPASS,
    KT_TRACE_CSC_SGID_BYPASS,
    KT_TRACE_KOSS_SET_ACTIVE,
    KT_TRACE_KOSS_SET_INACTIVE,
    KT_TRACE_KOSS_SET_STATE,
    KT_TRACE_NCT_OCREAT_CK_LINK_TGT,
    KT_TRACE_CSC_LOGIN_DIRECT_BP,
    KT_TRACE_KUTIL_GET_LOGIN_DATA,
    KT_TRACE_KUTIL_GET_LOGIN_DATA_EXIT,
    KT_TRACE_KAUD_LOG_USER_EVENT,
    KT_TRACE_KAUD_LOG_USER_EVENT_EXIT,
    KT_TRACE_KAUD_TRACE_EVENT,
    KT_TRACE_KAUD_TRACE_EVENT_EXIT,
    KT_TRACE_KAUD_LOGOUT_NOTERM,
    KT_TRACE_KAUD_LOGOUT_LOCTERM,
    KT_TRACE_KAUD_LOGOUT_REMTERM,
    KT_TRACE_KAUD_LOGOUT_EXIT,
    KT_TRACE_KAUD_TRACE_PID_EXEMPT,
    KT_TRACE_KAUD_TRACE_UID_EXEMPT,
    KT_TRACE_KOSS_INIT_PROC_RGY,
    KT_TRACE_KOSS_ASYNC_LU_START,
    KT_TRACE_KOSS_ASYNC_LU_STOP,
    KT_TRACE_KOSS_ASYNC_LU_TIMEOUT,
    KT_TRACE_KOSS_ASYNC_LU_STATE,
    KT_TRACE_KPCF_TRIG_REF,
    KT_TRACE_KPCF_SCAN_TIME,
    KT_TRACE_SHMEM_REINIT,
    KT_TRACE_SHMEM_REINITERR,
    KT_TRACE_SHMEM_INIT,
    KT_TRACE_SHMEM_FINI_ENT,
    KT_TRACE_SHMEM_FINI_WAITUSED,
    KT_TRACE_SHMEM_FINI_FAILUSED,
    KT_TRACE_SHMEM_FINI_FAILWAITERS,
    KT_TRACE_SHMEM_SRVT_START,
    KT_TRACE_SHMEM_SRVT_INVNODE,
    KT_TRACE_SHMEM_SRVT_ERRCOPY,
    KT_TRACE_SHMEM_SRVT_STOP,
    KT_TRACE_SHMEM_SRVT_WAIT,
    KT_TRACE_SHMEM_SRVT_WAITERR,
    KT_TRACE_SHMEM_STOP,
    KT_TRACE_GETMEM_NONE,
    KT_TRACE_SHBANG_TOOBIG,
    KT_TRACE_SHBANG_CHECK_READ,
    KT_TRACE_SHMEM_HELPER_START,
    KT_TRACE_SHMEM_HELPER_RESTART,
    KT_TRACE_SHMEM_HELPER_RETURN,
    KT_TRACE_SHMEM_CHECK_FAIL,
    KT_TRACE_SHMEM_NODE_RECLAIM,
    KT_TRACE_FDPATH_FAILURE,
    KT_TRACE_SHMEM_OLDPOOL_DEC
};
enum kt_kazn_msgs {
    KT_TRACE_KAZN_DUMMY = 2048,
    KT_TRACE_KAZN_ACC_ALLOWED_FI,
    KT_TRACE_KAZN_ACC_ALLOWED_ID,
    KT_TRACE_KAZN_ACC_ALLOWED_NW,
    KT_TRACE_KAZN_CFR,
    KT_TRACE_KAZN_CFR_HIT,
    KT_TRACE_KAZN_CFR_MISS,
    KT_TRACE_KAZN_KPCF_ADD,
    KT_TRACE_KAZN_KPCF_UPDATE,
    KT_TRACE_KAZN_KPCF_DEL,
    KT_TRACE_KPCF_DINS,
    KT_TRACE_KPCF_REFRES,
    KT_TRACE_KPCF_REFRES_RTN,
    KT_TRACE_KPCF_REF_FR,
    KT_TRACE_KPCF_NCADD,
    KT_TRACE_KPCF_NCHIT,
    KT_TRACE_KPCF_NCFLUSH,
    KT_TRACE_KPCF_DIR_NOTIFY,
    KT_TRACE_KPCF_EPOCH_DEL,
    KT_TRACE_KPCF_HIT_WC,
    KT_TRACE_KAZN_LOGIN_SUSKIP,
    KT_TRACE_KAZN_SECPGM_SUSKIP,
    KT_TRACE_KAZN_PRIVPGM_PERMIT,
    KT_TRACE_KPCF_HIT_LOCALTERM,
    KT_TRACE_KAZN_ACC_ALLOWED_EFLAGS,
    KT_TRACE_KAZN_RES_NOAZN,
    KT_TRACE_KPCF_KPCI_ADD_PO,
    KT_TRACE_KAZN_CHECKACCESS,
    KT_TRACE_KAZN_CHECKACCESS_GRANT,
    KT_TRACE_KAZN_CHECKACCESS_DENY,
    KT_TRACE_KAZN_CHECKACCESS_DENY_MORE,
    KT_TRACE_KPCF_REFRESH_NOTIFY,
    KT_TRACE_KPCF_CHECKPATH,
    KT_TRACE_KPCF_CKPATH_RTN,
    KT_TRACE_KPCF_CKPATH_FAST_RTN,
    KT_TRACE_KPCF_REF_DHASH,
    KT_TRACE_KPCF_REF_DHASH_RTN,
    KT_TRACE_RCF_ADD_GRANT,
    KT_TRACE_RCF_ADD_GRANT_RES,
    KT_TRACE_RCF_CHECK,
    KT_TRACE_RCF_CHECK_GRANT,
    KT_TRACE_RCF_CHECK_NOGRANT,
    KT_TRACE_RCF_FLUSH,
    KT_TRACE_RCF_COND_INFO,
    KT_TRACE_KAZN_DAEMON_EBUSY,
    KT_TRACE_KPCF_BKG_SLEEP,
    KT_TRACE_KPCF_BKG_RUN,
    KT_TRACE_KPCF_EPOCH_NOT,
    KT_TRACE_KPCF_EPOCH_NOT_COMMIT,
    KT_TRACE_KAZN_RES_NOTIFY,
    KT_TRACE_KPC_GET_NEWEPOCH,
    KT_TRACE_KPC_COMMIT_EPOCH,
    KT_TRACE_CSC_OPEN,
    KT_TRACE_CSC_KILL_ERR,
    KT_TRACE_KPCF_GENFID_ERR,
    KT_TRACE_KPCF_NOFID_REFRESH,
    KT_TRACE_KPCF_ADD_IMMUNE,
    KT_TRACE_KPCF_UPDATE_IMMUNE,
    KT_TRACE_KAZN_ERR_GRANT,
    KT_TRACE_KAZN_FIND_PGM_KPON,
    KT_TRACE_KAZN_FIND_PGM_KPON_FOUND,
    KT_TRACE_KAZN_FIND_PGM_KPON_NONE,
    KT_TRACE_KAZN_FIND_PGM_KPON_AMBIG,
    KT_TRACE_KAZN_KPC_QFILE,
    KT_TRACE_KAZN_KPC_QFILE_RTN,
    KT_TRACE_KAZN_KPC_QPGM,
    KT_TRACE_KAZN_KPC_QPGM_RTN,
    KT_TRACE_KAZN_KPC_DHASHFID_EXIT,
    KT_TRACE_KAZN_KPC_DHASHNAME_EXIT,
    KT_TRACE_KAZN_KPC_CREATE_NOTIFY,
    KT_TRACE_RCID_ADD_GRANT,
    KT_TRACE_RCID_ADD_GRANT_RES,
    KT_TRACE_RCID_CHECK,
    KT_TRACE_RCID_CHECK_GRANT,
    KT_TRACE_RCID_CHECK_NOGRANT,
    KT_TRACE_RCID_FLUSH,
    KT_TRACE_KAZN_AZNCALL_REMAP_TO,
    KT_TRACE_KPCF_EXCEPTION_ADD,
    KT_TRACE_KAZN_AZND_TOUT,
    KT_TRACE_KAZN_EXPAND_PATH,
    KT_TRACE_KAZN_EXPAND_PATH_ERR,
    KT_TRACE_KAZN_EXPAND_PATH_SKIP,
    KT_TRACE_KAZN_UFILE_HIT,
    KT_TRACE_KAZN_UFILE_ADD,
    KT_TRACE_KAZN_UFILE_MISS,
    KT_TRACE_KAZN_UFILE_FLUSH,
    KT_TRACE_KPCF_REF_DH_BYFID,
    KT_TRACE_KPCF_REF_DH_BYFID_END,
    KT_TRACE_EXEC_SETUSER,
    KT_TRACE_EXEC_SETGROUP,
    KT_TRACE_KAZN_CHECK_FID_ONLY,
    KT_TRACE_KAZN_EXEMPT_PID_PERMIT,
    KT_TRACE_KAZN_PFC_HIT,
    KT_TRACE_KAZN_PFC_ADD,
    KT_TRACE_KAZN_PFC_MISS,
    KT_TRACE_KAZN_PFC_FLUSH,
    KT_TRACE_KAZN_PFC_FLUSHBYRES,
    KT_TRACE_KAZN_PFC_PROTRES_RELE,
    KT_TRACE_KAZN_ACC_ALLOWED_PERMIT,
    KT_TRACE_KAZN_ACC_ALLOWED_DENY,

    KT_TRACE_KAZN_AUTOFS_NOREF,

    KT_TRACE_KAZN_NW_ADDR_BADFAM,
    KT_TRACE_KAZN_RES_TRY_AGAIN,
    KT_TRACE_KAZN_KPC_QNW,
    KT_TRACE_KAZN_KPC_QNW_RTN,
    KT_TRACE_KAZN_IMSURPGM_SUSKIP,
    KT_TRACE_KAZN_USER_AUDIT_LOGOUT,
    KT_TRACE_KAZN_ALWAYS_SET_KPON,
    KT_TRACE_KAZN_FILTER_RES,
    KT_TRACE_KAZN_KPCFT_DELAY,
    KT_TRACE_KAZN_IPV6_ADDR,
    KT_TRACE_KAZN_DHANAL_FRL_CLR,
    KT_TRACE_KAZN_SET_ALIAS,
    KT_TRACE_KAZN_HAS_ALIAS,
    KT_TRACE_KAZN_RES_WAIT,
    KT_TRACE_KAZN_RES_REFD,
    KT_TRACE_KAZN_RES_BROADCAST,
    KT_TRACE_KAZN_DHASH_REF_LOOP,
    KT_TRACE_KAZN_USE_COPY,
    KT_TRACE_KAZN_NO_COPY,
    KT_TRACE_KAZN_DENY_SHMCTL_OP,
    KT_TRACE_KAZN_DHASH_SEARCH_STALE
};







enum kt_kmsg_msgs {
    KT_TRACE_KMSG_DUMMY = 3072,
    KT_TRACE_KMSG_INIT,
    KT_TRACE_KMSG_FINISH,
    KT_TRACE_KMSG_OPEN,
    KT_TRACE_KMSG_CLOSE,
    KT_TRACE_KMSG_IOCTL,
    KT_TRACE_KMSG_READ_ENTRY,
    KT_TRACE_KMSG_READ_EXIT,
    KT_TRACE_KMSG_READ_WAIT,
    KT_TRACE_KMSG_READ_WORK,
    KT_TRACE_KMSG_WRITE_ENTRY,
    KT_TRACE_KMSG_WRITE_EXIT,
    KT_TRACE_KMSG_WRITE_ID,
    KT_TRACE_KMSG_WRITE_LEN,
    KT_TRACE_KMSG_SEND_REQ,
    KT_TRACE_KMSG_GET_RESP,
    KT_TRACE_KMSG_RECV_RESP,
    KT_TRACE_KMSG_GET_HAND,
    KT_TRACE_KMSG_FREE_HAND,
    KT_TRACE_KMSG_WAIT_MSG,

    KT_TRACE_KMSG_BADTRANID,
    KT_TRACE_KMSG_BADSIZE,
    KT_TRACE_KMSG_TOOBIG,
    KT_TRACE_KMSG_CHANCLOSED,
    KT_TRACE_KMSG_ERR_GET_HAND,
    KT_TRACE_KMSG_GET_RESP_ERR,
    KT_TRACE_KMSG_CHAN_DOWN,
    KT_TRACE_KMSG_CHAN_RETRY,
    KT_TRACE_KMSG_WAIT_TO,
    KT_TRACE_KMSG_HARD_TO,
    KT_TRACE_KMSG_TO_RETRY,
    KT_TRACE_KMSG_DOWN_TO_TOUT
};







enum kt_kenv_msgs {
    KT_TRACE_KENV_DUMMY = 4096,
    KT_TRACE_KENV_NEW_PROC_INFO,
    KT_TRACE_KENV_PR_ADD_FD,
    KT_TRACE_KENV_PR_CLOSE_FD,
    KT_TRACE_KENV_PR_RET_FDINFO,
    KT_TRACE_KENV_PR_GROW_FDTABLE,
    KT_TRACE_KENV_PR_ADD_FLAGS,
    KT_TRACE_KENV_PR_DEL_FLAGS,
    KT_TRACE_KENV_PR_SET_IMP_ID,
    KT_TRACE_KENV_E_NW_TERM,
    KT_TRACE_KENV_E_DEV_TERM,
    KT_TRACE_KENV_E_NO_TERM,
    KT_TRACE_KENV_PR_ADD_FLAGS_BNAME,
    KT_TRACE_KENV_PTP_E2BIG,
    KT_TRACE_KENV_PTP_E2BIG_RETRY,
    KT_TRACE_KENV_PR_GET_TRUE_ACCID,
    KT_TRACE_KENV_PR_SET_ACC_ID,
    KT_TRACE_KENV_PR_ADD_NO_FORK,
    KT_TRACE_KENV_PR_ADD_REMT_TERM,
    KT_TRACE_KENV_PR_GET_REMT_TERM,
    KT_TRACE_KENV_BUMP_STREAM_COUNT,
    KT_TRACE_KENV_DELAY_PROC_DEL,
    KT_TRACE_KENV_PROC_INFO_NOTPAR,
    KT_TRACE_KENV_E_NW_TERM_IPV6,
    KT_TRACE_KENV_IPV6_ADDR,
    KT_TRACE_KENV_PR_NOSET_REMT,
    KT_TRACE_KENV_SHMEM_TOOBIG,
    KT_TRACE_KENV_SHMEM_WAIT,
    KT_TRACE_KENV_SHMEM_STOPPED,
    KT_TRACE_KENV_SHMEM_NOFREE,
    KT_TRACE_KENV_SHMEM_INVNODE,
    KT_TRACE_KENV_SHMEM_RQWAIT,
    KT_TRACE_KENV_SHMEM_RQDONE,
    KT_TRACE_KENV_SHMEM_PUTERR,
    KT_TRACE_KENV_SHMEM_PUT,
    KT_TRACE_KENV_GETMEM_REL,
    KT_TRACE_KENV_GETMEM_NEVER,
    KT_TRACE_KENV_GETMEM_OK,
    KT_TRACE_KENV_GETMEM_OFF,
    KT_TRACE_KENV_GETMEM_ERR,
    KT_TRACE_KENV_PUTMEM,
    KT_TRACE_KENV_SHMAT_RESET,
    KT_TRACE_KENV_SHMREQ_SCAN_DELAY,
    KT_TRACE_KENV_SHMREQ_SCAN_NOW,
    KT_TRACE_KENV_SHMREQ_REC_NOPID,
    KT_TRACE_KENV_SHMREQ_REC_EXP,
    KT_TRACE_KENV_SHMREQ_SCAN_RET,
    KT_TRACE_KENV_SHMEM_RESET_EXEC,
    KT_TRACE_KENV_PROC_FORK_CHILD,
    KT_TRACE_KENV_PROC_FORK_PAR,
    KT_TRACE_KENV_PROC_ALREADY,
    KT_TRACE_KENV_PROC_CONDADD,
    KT_TRACE_KENV_PROC_EXISTS,
    KT_TRACE_KENV_PR_ADD_NO_PAR,
    KT_TRACE_KENV_PROC_ADD,
    KT_TRACE_KENV_PROC_ADD_PPID,
    KT_TRACE_KENV_PROC_TERM,
    KT_TRACE_KENV_PROC_USE_DEAD
};







enum kt_dbg_msgs {
    KT_TRACE_DBG_DUMMY = 8192,
    KT_TRACE_DBG_NCT_Q_AREQ,
    KT_TRACE_DBG_NCT_START_AREQ,
    KT_TRACE_DBG_NCT_END_AREQ,
    KT_TRACE_DBG_PAL_NO_FID,
    KT_TRACE_DBG_PAL_LKUP_ERR,
    KT_TRACE_DBG_PAL_DCOMP_ERR,
    KT_TRACE_DBG_PAL_LU_FID_DIR,
    KT_TRACE_DBG_TLI_SVC_PRIM_PEND,
    KT_TRACE_DBG_TLI_SVC_PRIM_NOPEND,
    KT_TRACE_DBG_NCT_PATH_OP_RESULT,
    KT_TRACE_DBG_NCT_FD_OP_RESULT,
    KT_TRACE_DBG_NCT_KILL_COMMON,
    KT_TRACE_DBG_NCT_KILL_TRAP,
    KT_TRACE_DBG_NCT_KILL_FILTER_PGRP,
    KT_TRACE_DBG_NCT_KILL_FILTER_USER,

    KT_TRACE_DBG_PAL_FILE_COUNT,
    KT_TRACE_DBG_PAL_FILE_LOOKUP22,
    KT_TRACE_DBG_PAL_FILE_LOOKUP24,

    KT_TRACE_DBG_KAZN_AUTOFS_NOVFSP,
    KT_TRACE_DBG_RFID_FL_VFSP,
    KT_TRACE_DBG_AUTO_FS_MOUNTED,
    KT_TRACE_DBG_DEFER_UMOUNT,
    KT_TRACE_DBG_CHECK_VFS_MOUNTED,
    KT_TRACE_DBG_MOUNTED_YES,
    KT_TRACE_DBG_MOUNTED_NO,
    KT_TRACE_DBG_VFS_DATA_SET,
    KT_TRACE_DBG_FURTHER_LKUP_REQ,
    KT_TRACE_DBG_NEXT_LOOKUP,
    KT_TRACE_DBG_GEN_RES_FIDS,
    KT_TRACE_DBG_CHECK_FID_PATH,

    KT_TRACE_DBG_RESET_VFS_DATA,
    KT_TRACE_DBG_FAILED_VFS_SEARCH,
    KT_TRACE_DBG_ASYNC_LU_START,
    KT_TRACE_DBG_DEFER_UNAVAIL,
    KT_TRACE_DBG_REFRESH_FSID_EQ,
    KT_TRACE_DBG_REFRESH_FSID_NOFID,
    KT_TRACE_DBG_REFRESH_EPOCH,

    KT_TRACE_DBG_KPCF_ADD_RES,
    KT_TRACE_DBG_KPCF_AZN_FLAGS,
    KT_TRACE_DBG_NCT_FORK_TRAP,
    KT_TRACE_DBG_EXIT_CHECK_LEAF,

    KT_TRACE_DBG_SHMEM_SRVT_WAIT,
    KT_TRACE_DBG_SHMEM_SRVT_PROC,
    KT_TRACE_DBG_SHMEM_SRVT_RECLAIM,
    KT_TRACE_DBG_SHBANG_EXEC,
    KT_TRACE_DBG_SHMEM_HELPER_CHECK,
    KT_TRACE_DBG_FDPATH_BUILT,
    KT_TRACE_DBG_BYPASS_ENTRY1,
    KT_TRACE_DBG_BYPASS_ENTRY2,
    KT_TRACE_DBG_BYPASS_EXIT
};
enum kt_ffdc_msgs {
    KT_TRACE_FFDC_DUMMY = 5120,
    KT_TRACE_FFDC_STR,
    KT_TRACE_FFDC_AZNCALL_FILE,
    KT_TRACE_FFDC_AZNCALL_IDSET,
    KT_TRACE_FFDC_AZNCALL_NWOUT,
    KT_TRACE_FFDC_AZNCALL_NWIN,
    KT_TRACE_FFDC_AZNCALL_RACC_ADDR,
    KT_TRACE_FFDC_AZNCALL_CONT,
    KT_TRACE_FFDC_AZNCALL_RES_PERMIT,
    KT_TRACE_FFDC_AZNCALL_RES_DENY,
    KT_TRACE_FFDC_ERR_GRANT,
    KT_TRACE_FFDC_AZNCALL_SLOW,
    KT_TRACE_FFDC_CSC_LOGIN,
    KT_TRACE_FFDC_CKLOGIN,
    KT_TRACE_FFDC_CKLOGIN_EXIT,
    KT_TRACE_FFDC_CKLOGIN_DOAZN,
    KT_TRACE_FFDC_EXEC_PGM,
    KT_TRACE_FFDC_EXEC_PGM_LINK,
    KT_TRACE_FFDC_EXEC_SUPGM,
    KT_TRACE_FFDC_EXEC_SGPGM,
    KT_TRACE_FFDC_EXEC_SUGPGM,
    KT_TRACE_FFDC_EXEC_DENIED,
    KT_TRACE_FFDC_EXEC_ALLOWED,
    KT_TRACE_FFDC_LOGOUT_LOC,
    KT_TRACE_FFDC_LOGOUT_REM,
    KT_TRACE_FFDC_PROC_ADD,
    KT_TRACE_FFDC_PROC_ADD_PPID,
    KT_TRACE_FFDC_PROC_TERM,
    KT_TRACE_FFDC_NPC_FREE,
    KT_TRACE_FFDC_HOST_RULE_BAD,
    KT_TRACE_FFDC_CSC_V6TERM,
    KT_TRACE_FFDC_IPV6_ADDR
};




enum kt_knpc_msgs {
    KT_TRACE_KNPC_DUMMY = 6144,
    KT_TRACE_KNPC_STR,
    KT_TRACE_KNPC_SEARCH_SERVICE,
    KT_TRACE_KNPC_SEARCH_HOSTIP,
    KT_TRACE_KNPC_SEARCH_HOSTNAME,
    KT_TRACE_KNPC_SEARCH_PROTOCOL,
    KT_TRACE_KNPC_NET_UPD_ENTRY,
    KT_TRACE_KNPC_NET_UPD_ENTRY2,
    KT_TRACE_KNPC_KPCRES_ATTACH,
    KT_TRACE_KNPC_NET_ALREADY,
    KT_TRACE_KNPC_NETIN_ADD_NODE,
    KT_TRACE_KNPC_NETIN_DEL_ERR,
    KT_TRACE_KNPC_NETIN_DEL,
    KT_TRACE_KNPC_NETOUT_ADD_NODE,
    KT_TRACE_KNPC_NETOUT_DEL_ERR,
    KT_TRACE_KNPC_NETOUT_DEL,
    KT_TRACE_KNPC_NETIN_MATCH,
    KT_TRACE_KNPC_NETOUT_MATCH,
    KT_TRACE_KNPC_DUMP_HEADER,
    KT_TRACE_KNPC_DUMP_ELEM,
    KT_TRACE_KNPC_CUR_INIT,
    KT_TRACE_KNPC_CUR_FINI,
    KT_TRACE_KNPC_CHECK_RES,

    KT_TRACE_KNPCD_SERV_NODE_ALLOC,
    KT_TRACE_KNPCD_SERV_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_SERV_NODE_FREE,
    KT_TRACE_KNPCD_HOSTIP_NODE_ALLOC,
    KT_TRACE_KNPCD_HOST_NODE_ALLOC,
    KT_TRACE_KNPCD_HOST_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_HOSTIP_NODE_FREE,
    KT_TRACE_KNPCD_HOST_NODE_FREE,
    KT_TRACE_KNPCD_PROT_NODE_ALLOC,
    KT_TRACE_KNPCD_PROT_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_PROT_NODE_FREE,
    KT_TRACE_KNPCD_MATCH_SERVICE,
    KT_TRACE_KNPCD_MATCH_HOSTIP,
    KT_TRACE_KNPCD_MATCH_PROTOCOL,
    KT_TRACE_KNPCD_KPON_FREE,
    KT_TRACE_KNPCD_WAIT_LOCK,
    KT_TRACE_KNPCD_SEARCH_SERV_ENTRY,
    KT_TRACE_KNPCD_SEARCH_NODE_CMP,
    KT_TRACE_KNPCD_FREE_NODE_REF,
    KT_TRACE_KNPCD_MATCH_HOSTNAME,
    KT_TRACE_KNPC_NETIN_SETRES,
    KT_TRACE_KNPC_NETOUT_SETRES,
    KT_TRACE_KNPC_ENV_SETRES,
    KT_TRACE_KNPCD_HOSTIPV6_NODE_ALLOC,
    KT_TRACE_KNPCD_HOSTIPV6_ADDR,
    KT_TRACE_KNPCD_HOSTIPV6_MASK,
    KT_TRACE_KNPCD_HOSTIPV6_NODE_FREE,
    KT_TRACE_KNPCD_HOSTIPV6_HIT_V4,
    KT_TRACE_KNPCD_HOSTIPV6_CMP,
    KT_TRACE_KNPC_SEARCH_HOSTIPV6,
    KT_TRACE_KNPCD_SEARCH_HOSTIPV6_QELEM,
    KT_TRACE_KNPCD_MATCH_HOSTIPV6,
    KT_TRACE_KNPC_BRANCH_CHANGE
};



enum kt_knrc_msgs {
    KT_TRACE_KNRC_DUMMY = 7168,
    KT_TRACE_KNRC_STR,
    KT_TRACE_KNRC_INIT_ERR,
    KT_TRACE_KNRC_INIT_CACHE,
    KT_TRACE_KNRC_FINI_FREE,
    KT_TRACE_KNRC_CHECK_GROW,
    KT_TRACE_KNRC_RECYCLE_ELEM,
    KT_TRACE_KNRC_NEW_POOL_ALLOC,
    KT_TRACE_KNRC_FLUSH,
    KT_TRACE_KNRC_ADD_EXACT,
    KT_TRACE_KNRC_ADD_GRANT_EXACT,
    KT_TRACE_KNRC_ADD_AMBIG,
    KT_TRACE_KNRC_AMBIG_HASH,
    KT_TRACE_KNRC_ADD_GRANT_AMBIG,
    KT_TRACE_KNRC_HAS_VIA,
    KT_TRACE_KNRC_ADD_STATS,
    KT_TRACE_KNRC_CHECK_EXACT,
    KT_TRACE_KNRC_RECLAIM_EXACT,
    KT_TRACE_KNRC_FID_NOMATCH,
    KT_TRACE_KNRC_HIT_EXACT,
    KT_TRACE_KNRC_NOMATCH_EXACT,
    KT_TRACE_KNRC_CHECK_STATS,
    KT_TRACE_KNRC_CHECK_AMBIG,
    KT_TRACE_KNRC_CHECK_HASHQ,
    KT_TRACE_KNRC_RECLAIM_AMBIG,
    KT_TRACE_KNRC_HIT_AMBIG,
    KT_TRACE_KNRC_NOMATCH_AMBIG,
    KT_TRACE_KNRC_RECLAIM,
    KT_TRACE_KNRC_RECLAIM_ELEM
};
typedef struct kaznStats {
    int32_t accAllowedCalls;
    int32_t checkAccessCalls;
    int32_t totalGrants;
    int32_t totalDenies;
    int32_t rcGrants;
    int32_t privGrants;
    int32_t padA;
    int32_t loginIdSets;
    int32_t secIdSets;
    int32_t noTrustDenies;
    int32_t impSetId;
    int32_t padB;
    int32_t pdosdCalls;
    int32_t pdosdActiveCalls;
    int32_t pdosdFileCalls;
    int32_t pdosdIdCalls;
    int32_t pdosdNetCalls;
    int32_t pdosdLoginCalls;
    int32_t pdosdFail;
    int32_t pdosdGrantError;
    int32_t pdosdDenyError;
    int32_t pdosdGrantAudit;
    int32_t pdosdDenyAudit;
    int32_t pdosdSlowCalls;
    int32_t pdosdTimeOuts;
    int32_t pdosdBusy;
    int32_t pdosdInWarning;
} kaznStats_t;




extern kazn_expandSRN;
typedef int kazn_aznResult_t;
extern kaznStats_t kaznStats;

extern char *kazn_grantStr;
extern char *kazn_denyStr;

extern int kazn_accessAllowed(kenv_envHandle_t, int, int, int);
extern kazn_aznResult_t kazn_checkAccess(kenv_envHandle_t, int, int, int);
extern void kazn_kpcUpdateLastNotify(void);
extern int kazn_setGrantSuserOnError(int);
extern void kazn_expandTrappedFilePath(kenv_envHandle_t, kenv_kpcInfo_t *,
                                       int, pal_pathBuf_t *);
extern void kazn_init(void);
extern void kazn_shutdown(void);
typedef struct amsg_hdr_t {
    uint32_t class_id;
    uint32_t class_fmt_vers;
    uint32_t message_id;
    uint32_t msg_fmt_vers;
} amsg_hdr_t;
typedef struct amsg_common {
    uint32_t sys_obj_type;
    uint32_t cflags;
    int64_t accessor_id ;
    uint64_t action ;
    int64_t accessor_euid ;
    int64_t accessor_ruid ;
    uint32_t accessing_pid;
    uint32_t runng_prog_kpon_len;
    uint32_t runng_prog_srn_len;
    uint32_t branchId;
    kpc_resFlags_t resource_flags;

    kpc_resFlags_t runng_prog_kpon_resource_flags;
    uint32_t extended_data_len;
} amsg_common_t;
typedef struct amsg_ois_file {
    uint32_t fflags;
    uint32_t file_kpon_len;
    uint32_t file_srn_len;
    uint32_t alt_kpon_cnt;
} amsg_ois_file_t;
typedef struct amsg_ois_id_mod {
    uint32_t id_mask;
    int64_t new_ID ;
    uint32_t local_term_kpon_len;
    uint32_t local_term_extdata_len;
    uint32_t remote_term_cand_cnt;
} amsg_ois_id_mod_t;
typedef struct amsg_rem_term_cand {
    oss_nwAddr_t term_loc;
    uint32_t term_kpon_len;

} amsg_rem_term_cand_t;
typedef struct amsg_ois_network {
    uint32_t nwflags;
    oss_nwAddr_t local_conn;
    oss_nwAddr_t remote_conn;
    uint32_t network_kpon_len;
    uint32_t alt_kpon_cnt;
    int64_t policyVersion ;

    pal_ptr32_t pHost;



} amsg_ois_network_t;

typedef struct amsg_ois_network_alt {
    int64_t policyVersion ;

    pal_ptr32_t pHost;



    uint32_t network_kpon_len;
} amsg_ois_network_alt_t;
typedef uint32_t amsg_response_result_t;

typedef struct amsg_response {
    amsg_hdr_t header;
    amsg_response_result_t result;
} amsg_response_t;
typedef enum kpc_notifyOp {
    kpc_opAdd, kpc_opDelete
} kpc_notifyOp_t;

typedef enum kpc_objType {
    kpc_objFile,
    kpc_objNetwork,
    kpc_objIdset,
    kpc_objMyProgram

} kpc_objType_t;


typedef struct _addrType {
    int addrClassic:1;
    int addrV6:1;
    int noProto:1;
    int noServ:1;
    int noHostIP:1;
    int noHostName:1;
    int hostInline:1;
    int nwIn:1;
    int nwOut:1;
    int pad:23;
} kpc_nwAddrType_t;





typedef struct idInfo {
    int64_t idValue ;
    int isGroupId:1;
} kpc_idInfo_t;







typedef oss_nwAddr_t kpc_nwAddr_t;


typedef struct _portrange {
    uint16_t portLow;
    uint16_t portHigh;
} kpc_portrange_t;
typedef struct _nwdesc {
    kpc_nwAddrType_t addrType;
    oss_nwIP_t ipaddr;
    oss_nwIP_t mask;
    uint16_t protocol;
    uint16_t hostDataLen;
    uint16_t significantBits;
    uint16_t numPortRanges;
    uint32_t totalPorts;
    int64_t policyVersion ;



    pal_ptr32_t pHost;

    char wcHostInline[32];
    union {
        kpc_portrange_t one;
        kpc_portrange_t *setp;
    } portRange;
    char *wcHostData;
} kpc_nwDesc_t;




typedef struct _resInfo {



    kpc_notifyOp_t op;
    kpc_objType_t objType;
    kpc_resFlags_t flags;
    int32_t extDataLen;
    uint32_t branchId;



    union {
        kpc_idInfo_t idInfo;
        kpc_nwDesc_t *nwDesc;


    } resDesc;





    char *resourceName;


    byte_t *extData;


} kpc_resourceInfo_t;
typedef struct kpcRecord {
    kpc_resFlags_t flags;
    int32_t extDataLen;
    int32_t howFound;
    uint32_t branchId;
    int32_t reserved[4];
    char kpon[1024];
    byte_t extData[6144];
} kpc_record_t;
typedef struct _nwdesc32 {
    kpc_nwAddrType_t addrType;
    oss_nwIP_t ipaddr;
    oss_nwIP_t mask;
    uint16_t protocol;
    uint16_t hostDataLen;
    uint16_t significantBits;
    uint16_t numPortRanges;
    uint32_t totalPorts;
    int64_t policyVersion ;
    pal_ptr32_t pHost;
    char wcHostInline[32];
    union {
        kpc_portrange_t one;
        pal_ptr32_t set;
    } portRange;
    pal_ptr32_t wcHostData;
} kpc_nwDesc32_t;





typedef struct _resInfo32 {



    kpc_notifyOp_t op;
    kpc_objType_t objType;
    kpc_resFlags_t flags;
    int32_t extDataLen;
    uint32_t branchId;



    union {
        kpc_idInfo_t idInfo;
        pal_ptr32_t pnwDesc;


    } resDesc;





    pal_ptr32_t resourceName;


    pal_ptr32_t extData;


} kpc_resourceInfo32_t;



typedef struct kpcattr {
    int64_t kpcEpoch ;

    int64_t lastNotify ;
    int64_t policyVersion ;
    int64_t policyEpoch ;




    int32_t resourceCount;
} kpc_attr_t;
typedef struct kpc_info {
    kpc_attr_t attrs;
    uint32_t resourceChecks;
    uint32_t doEvals;
    uint32_t resourceAdds;
    uint32_t resourceDeletes;
    uint32_t setVersionCalls;
    uint32_t startEpochCalls;
    uint32_t commitEpochCalls;
} kpc_info_t;

extern kpc_info_t kpcInfo;
typedef struct kpc_kptr
{
    uint32_t high;
    uint32_t low;
} kpc_kptr_t;

typedef struct kpc_fdumpRec {
    uint32_t resFlags;
    uint32_t intResFlags;
    uint32_t pointerSize;
    uint32_t branchId;
    kpc_kptr_t resPtr;
    kpc_kptr_t rfidPtr;
    kpc_kptr_t dfidPtr;
    char resName[156];
} kpc_fdumpRec_t;



typedef struct kpc_fdumpBlock {
    int32_t count;
    uint32_t cookie;
    kpc_fdumpRec_t frecs[3072];
} kpc_fdumpBlock_t;



typedef struct kpc_ndumpRec
{
    kpc_nwAddrType_t addrType;
    uint32_t pointerSize;
    uint32_t branchId;
    int64_t policyVersion ;
    kpc_kptr_t protPtr;
    kpc_kptr_t servPtr;
    kpc_kptr_t hostPtr;
    char resName[156];
} kpc_ndumpRec_t;



typedef struct kpc_ndumpBlock {
    int32_t count;
    uint32_t cookie;
    kpc_ndumpRec_t nrecs[128];
} kpc_ndumpBlock_t;




extern kpc_info_t kpcInfo;
extern void kazn_kpcNetSetActive(int);
extern int kazn_kpcNetGetActive(void);

extern void kazn_kpcInit(void);
extern int kazn_kpcCheckResource(kenv_envHandle_t, int, int, int);
extern int kazn_kpcFileCheckResource(kenv_envHandle_t, int, int);
extern int kazn_kpcNetCheckResource(kenv_envHandle_t, int, int);
extern char *kazn_kpcFileFindPgmResource(kenv_envHandle_t, kpc_resFlags_t *);
extern void kazn_kpcFileDirNotify(char *);
extern char *kazn_kpcFileFindTerminal(kenv_envHandle_t, int *, byte_t **);
extern void kazn_kpcFileInit(void);
extern void kazn_kpcFileShutdown(void);
extern void kazn_kpcFileEpochNotify(int64_t, int);
extern void kazn_kpcNetInit(void);
extern void kazn_kpcNetShutdown(void);
extern void kazn_kpcFileRefreshNotify(kenv_envHandle_t);
extern void kazn_kpcFileCreateNotify(kenv_envHandle_t);
extern int kazn_kpcfRunAsync(void);
extern void kpcf_asyncLUThread(void);
extern int kpcf_asyncStopLookup(void);




void kazn_kpcfTriggerAsyncRefresh(int);

extern void kazn_kpcfStopAsync(void);
extern int64_t kazn_kpcStartNewPolicyEpoch(void);
extern int kazn_kpcCommitPolicyEpoch(int64_t);
extern void kazn_kpcfFlushNegCache(void);


extern void kazn_kpcSetPolicyVersion(int64_t);
extern void kazn_kpcGetAttr(kpc_attr_t *);
extern int kazn_kpcAddResource(kpc_resourceInfo_t *);
extern int kazn_kpcDelResource(kpc_resourceInfo_t *);
extern int kazn_kpcFileAddResource(kpc_resourceInfo_t *);
extern int kazn_kpcFileDelResource(kpc_resourceInfo_t *);
extern int kazn_kpcNetAddResource(kpc_resourceInfo_t *);
extern int kazn_kpcNetDelResource(kpc_resourceInfo_t *);
extern void kazn_kpcNetSetResource(int, kenv_envHandle_t, char *);
struct uio {
        char *uio_base;
        char *uio_current;
        int32_t uio_left;
} ;
typedef struct uio uio_t;
typedef struct uio pal_uio_t;
static inline int
pal_uio_read(const char * const kaddr, const size_t count, pal_uio_t *const uiop)
{

        if (count < uiop->uio_left) {

                memcpy(uiop->uio_current,kaddr,count);


                uiop->uio_current += count;
                uiop->uio_left -= count;
                return 0;
        }
        else
        {




                return EFAULT;
        }
}
static inline int
pal_uio_write(char * const kaddr, const size_t count, pal_uio_t * const uiop)
{
    int rc = EFAULT;

        if (count <= uiop->uio_left) {

            memcpy(kaddr,uiop->uio_current,count);


            uiop->uio_current += count;
            uiop->uio_left -= count;
            return 0;
        }
        else
        {




                return EFAULT;
        }
}
#include <linux/ioctl.h>
static char KMSG_DEVICE[][14] = {
    "/dev/kossazn",
    "/dev/kossaud"
};




extern int kmsgDebug;
typedef struct chStatus {
    uint32_t opens;
    uint32_t msgs;
    uint32_t downCount;
    uint32_t rwCount;
    uint32_t gt1sec;
    uint32_t gt10sec;
    uint32_t waitTouts;
    uint32_t toRetries;
    uint32_t timeOutErrs;
    uint32_t downErrs;
    uint32_t downToToutErrs;
    uint32_t nobufs;
    uint32_t badTranID;
    uint32_t noDev;
    pal_time_t lastRead;
    pal_time_t lastResponse;
    pal_time_t downTime;
} kmsg_chanStats_t;


typedef struct chanInfo {
    int devStates;
    int chanId;
    kmsg_chanStats_t cs;
} kmsg_chanInfo_t;
extern kmsg_chanInfo_t kmsg_devData[];

extern void kmsg_Init(void);
extern void *kmsg_kGetMsgHandle(int, int, int *);
extern void kmsg_kPutMsgHandle(void *);
extern int kmsg_kAppendData(void *, char *, int);
extern int kmsg_kGetResponse(void *, char *, int, int *);
extern void kmsg_kSetTimeout(void *, int);
extern int kmsg_read(int, pal_uio_t *);
extern int kmsg_write(int, pal_uio_t *);
extern int kmsg_ioctl(int, int, char *);
extern int kmsg_open(int);
extern int kmsg_close(int);
typedef struct kaud_auditEventInfo {
    uint32_t flags;



    uint32_t kaud_magic;
    uint32_t event_id;
    uint32_t aud_fail_status;
    uint32_t aud_report_flags;
    uint32_t aud_qualifier;
    uint32_t aud_permissions;
    uint16_t aud_view;
    uint16_t aud_action;
    uint16_t aud_reason;
    uint16_t aud_outcome;
    uint16_t aud_resource_type;
    int64_t aud_accessor_uid ;
    int64_t aud_target_id ;
    int64_t aud_accessor_pid ;
    int64_t aud_accessor_eff_id ;
    int64_t aud_accessor_real_id ;




    uint32_t aud_nw_flags;
    oss_nwAddr_t aud_local_conn;
    oss_nwAddr_t aud_remote_conn;
    oss_nwAddr_t aud_remote_login_term;



    char aud_target_pon[256];
    char aud_target_srn[256];
    char aud_branch_name[80];
    char aud_local_term[80];
    char aud_accessor_name[24];
    char aud_program_name[256];




} kaud_auditEventInfo_t;
extern int kaud_syscall(pal_scall_parm_t, pal_scall_parm_t,
                        pal_scall_parm_t, pal_scall_parm_t,
                        pal_scall_parm_t, int *);


extern int kaud_setAuditLevel(int32_t);




extern int kaud_intTraceFlags;
extern int kaud_checkTrace;
extern int kaud_doLogoutAudit;
extern int kaud_eucTraceUsers;
typedef struct kaud_auditServInfo {
   uint32_t event_id;
   uint32_t aud_view;
   uint64_t aud_action;
   uint32_t aud_reason;
   uint32_t aud_outcome;
   uint32_t aud_fail_status;
   uint32_t aud_resr_type;
   uint32_t pol_flags;
   uint64_t pol_epoch;
   uint64_t pol_version;
} kaud_auditServInfo_t;
extern int kaud_expandSRN;
extern int32_t kaud_audit_level;
extern int32_t kaud_warning_mode;

extern int kaud_auditService(kaud_auditServInfo_t*);
extern int kaud_logUserAuditEvent(kaud_auditEventInfo_t *);
extern int kaud_auditTraceEvent(kenv_envHandle_t, int, int, int);
extern int kaud_eucAdd(pal_authID_t uid, uint32_t states);
extern int kaud_eucDel(pal_authID_t uid);
extern int kaud_eucDump(pal_authID_t *, uint32_t *, int);
extern void kaud_auditLogout(pal_authID_t,pal_pid_t,int,char *,pal_nwAddr_t *);

extern void kaud_init(void);
extern void kaud_shutdown(void);
struct sockaddr {
        unsigned short sa_family;
        char sa_data[14];
} ;
struct in_addr {
        uint s_addr;
};

struct sockaddr_in {
  unsigned short sin_family;
  unsigned short int sin_port;
  struct in_addr sin_addr;


  unsigned char __pad[16 - sizeof(short int) -
                        sizeof(unsigned short int) - sizeof(struct in_addr)];
};
struct in6_addr
{
        union
        {
                unsigned char u6_addr8[16];
                unsigned short u6_addr16[8];
                unsigned int u6_addr32[4];
        } in6_u;



};
struct sockaddr_in6 {
        unsigned short int sin6_family;
        unsigned short sin6_port;
        unsigned int sin6_flowinfo;
        struct in6_addr sin6_addr;
        unsigned int sin6_scope_id;
};


typedef struct sockaddr pal_sockaddr_t;
extern int pal_netSockFdToAddrInfo(int, int *, pal_nwAddr_t *, pal_nwAddr_t *);
extern int pal_netSaddrToNwAddr(pal_sockaddr_t *, pal_nwAddr_t *);
typedef uint32_t audmsg_response_result_t;




typedef struct audmsg_response {
    amsg_hdr_t header;
    audmsg_response_result_t result;
} audmsg_response_t;



typedef struct audit_header_section
{
    uint32_t class_id;
    uint32_t class_format_version;
    uint32_t messageID;
    uint32_t message_format_version;
} audit_header_t;
typedef struct string_param
{
    int len;
    char* str_param;
} str_param_t;

typedef struct nw_param
{
    uint32_t nw_flags;
    oss_nwAddr_t addr;
} nw_param_t;

typedef union data
{
    int64_t int_param;
    str_param_t str_param;
    nw_param_t nw_param;
} data_t;


typedef uint8_t data_type_e;
typedef struct audit_param_data
{
    data_type_e data_type;
    data_t data;
} param_t;
typedef uint8_t orig_proc_id_e;
typedef uint8_t audit_view_e;
typedef uint8_t audit_action_e;
typedef uint8_t audit_reason_e;
typedef uint8_t audit_outcome_e;
typedef uint8_t audit_resr_type_e;
typedef struct cmn_event_fixed
{
    uint32_t prod_id;
    uint32_t record_version;
    int64_t time_stamp;
    uint32_t unique_id;
    uint32_t event_id;
    uint16_t record_len;
    uint16_t prod_record_version;
    orig_proc_id_e orig_pid;
    uint32_t event_flags;

    audit_view_e audit_view;
    audit_reason_e audit_reason;
    audit_outcome_e audit_outcome;
    audit_resr_type_e audit_resource_type;
    audit_action_e audit_action;
    uint16_t audit_param_count;
    uint32_t audit_fail_status;
    uint32_t audit_qualifier;
    uint32_t audit_permissions;
    uint32_t audit_report_flags;
    uint16_t len_audit_param;
    uint16_t time_stamp_uniq;
    uint32_t orig_loc_addr[4];
} cmn_event_fixed_t;






typedef struct oss41_and_oss51_cmn_event_fixed
{
    uint32_t prod_id;
    uint32_t record_version;
    int64_t time_stamp;
    uint32_t unique_id;
    uint32_t event_id;
    uint16_t record_len;
    uint16_t prod_record_version;
    orig_proc_id_e orig_pid;
    uint32_t orig_loc_v4addr;
    audit_view_e audit_view;
    audit_reason_e audit_reason;
    audit_outcome_e audit_outcome;
    audit_resr_type_e audit_resource_type;
    audit_action_e audit_action;
    uint16_t audit_param_count;
    uint32_t audit_fail_status;
    uint32_t audit_qualifier;
    uint32_t audit_permissions;
    uint32_t audit_report_flags;
    uint16_t len_audit_param;
    uint16_t time_stamp_uniq;
} oss41_and_oss51_cmn_event_fixed_t;



typedef struct cmn_event_variable
{
    param_t* audit_param;
} cmn_event_variable_t;
typedef struct cmn_data_fixed
{
    int64_t accessor_uid;
    int64_t accessor_ruid;
    int64_t accessor_euid;
    int64_t accessor_pid;
    uint16_t len_accessor_creds;
    uint16_t accessor_flags;
    uint16_t data_ext_flags;
    uint16_t len_accessor_name;
    uint16_t len_accessor_eff_name;
    uint16_t len_run_pon;
    uint16_t len_run_srn;
    uint16_t len_target_pon;
    uint16_t len_target_srn;
    uint16_t len_branch_name;
    uint16_t len_local_term_name;
    uint16_t len_local_domain;
} cmn_data_fixed_t;


typedef struct cmn_data_variable
{

    uint32_t creds_h;
    char* local_domain;
    char* acc_name;
    char* acc_eff_name;
    char* run_pon;
    char* run_srn;
    char* target_pon;
    char* target_srn;
    char* branch_name;
    char* local_term_name;
    int64_t sid_or_len_sname;
    char* sname;
    oss_nwAddr_t remote_term_spec;
 } cmn_data_variable_t;
typedef struct network_info
{
    uint32_t nw_flags;
    oss_nwAddr_t local_conn;
    oss_nwAddr_t remote_conn;
} nw_info_t;





typedef struct sudo_info
{
    uint32_t sudo_flags;
    uint32_t executableLen;
    uint32_t targetUserLen;
    uint32_t cmd_args_len;
    char * executable;
    char * targetUser;
    char * cmd_args;
} sudo_info_t;


typedef uint8_t chg_data_attr_flags_e;





typedef struct tcb_info
{
    chg_data_attr_flags_e chg_attr_flags;
} tcb_info_t;



typedef uint8_t policy_flags_e;




typedef struct policy_info
{
    policy_flags_e policy_flags ;
    int64_t policy_epoch ;
    int64_t policy_version ;
} policy_info_t;
int kazn_grantSuserOnError = 1;






static pal_time_t kazn_lost_contact = 0;
int
kazn_setGrantSuserOnError(int doGrant)
{
    int oldState = kazn_grantSuserOnError;

    kazn_grantSuserOnError = (doGrant? 1: 0);

    return oldState;
}
static uint32_t
map_setmask(int setMask)
{
    uint32_t idMask;

    idMask = 0;

    if (setMask & 0x1)
        idMask = idMask | 0x1;

    if (setMask & 0x2)
        idMask = idMask | 0x2;

    if (setMask & 0x4)
        idMask = idMask | 0x4;

    if (setMask & 0x8)
        idMask = idMask | 0x8;

    return(idMask);
}
static uint32_t
map_kpc_flags(int kpcFlags)
{
    uint32_t fflags = 0;

    if (kpcFlags & 0x1) {
        fflags = fflags | 0x1;
    } else if (kpcFlags & 0x2) {
        fflags = fflags | 0x2;
    }

    if (kpcFlags & 0x4)
        fflags = fflags | 0x4;

    if (kpcFlags & 0x1000) {
        fflags = fflags | (0x8 | 0x10);
    }

    if (kpcFlags & 0x2000) {
        fflags = fflags | 0x20;
    }

    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[1], KT_TRACE_DBG_KPCF_AZN_FLAGS, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(kpcFlags), (long)fflags),0) : 0);

    return(fflags);
}
static void
kmsg_err(char *trace_msg, int err_code)
{
    char msgbuf[256];
    pal_time_t currTime, old_lost_contact;
    kaud_auditServInfo_t *auditInfop;
    int didTrace = 0;

    if ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) || (((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active)) {
        if (err_code) {
            kail_sprintf((msgbuf), (trace_msg), (err_code));
        } else {
            kail_sprintf((msgbuf), (trace_msg));
        }

        if ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active)) {
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[4], KT_TRACE_STR, (((1)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(msgbuf)),0) : 0);
            didTrace = 1;
        }
    }





    old_lost_contact = kazn_lost_contact;
    currTime = ((pal_time_t)(kail_xtime->tv_sec));
    if(currTime - kazn_lost_contact > 60) {
        kazn_lost_contact = currTime;
    }
    else {
        return;
    }

    if ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) && !didTrace) {
        kt_logString(0, msgbuf);
    }

    kail_sprintf((msgbuf), ("%d"), (err_code));
    if (!old_lost_contact) {
        pal_logErr(0x340b4004, msgbuf);
    } else {
        pal_logErr(0x340b4005, msgbuf);
    }





    if ((kaud_audit_level & (0x4))) {
        auditInfop = (kaud_auditServInfo_t *)pal_alloc(
                        sizeof(kaud_auditServInfo_t));
        if (auditInfop) {
            auditInfop->event_id = 0x35a50020;
            auditInfop->aud_view = 3;
            auditInfop->aud_action = 1;
            auditInfop->aud_reason = 1;
            auditInfop->aud_outcome = 2;
            auditInfop->aud_fail_status = err_code;
            auditInfop->aud_resr_type = 2;
            kaud_auditService(auditInfop);
            pal_free(auditInfop, sizeof(kaud_auditServInfo_t));
        }
    }
    return;
}


typedef struct _msgStart {
    amsg_hdr_t h;
    amsg_common_t c;
} msgStart_t;
static int
call_aznDaemon(
    kenv_envHandle_t envH,
    int objType,
    int action,
    kazn_aznResult_t *result)
{
    static char append_tmsg[] =
                "call_aznDaemon(): err from kmsg_kAppendData() = %d";

    int i, rc, length, resp_len, resNameLen, isLgn=0, isSuser, extResp=0;
    uint32_t len;
    kazn_aznResult_t accOk = 0x2;
    kenv_kpcInfo_t *kpcInfo;
    pal_idList_t *idListp;
    pal_idSet_t *suId;
    pal_authID_t errCheckId;
    pal_dev_t *localDev;
    pal_nwAddr_t *nwa;
    pal_time_t tstamp;
    void * pmsg;
    byte_t *extData;
    kenv_procFlags_t procFlags;
    amsg_response_result_t pdosdResult;
    msgStart_t msgS;
    amsg_ois_file_t mFile;
    amsg_ois_id_mod_t mIdmod;
    amsg_ois_network_t mIdnw;
    amsg_response_t mResponse;
    kaud_auditServInfo_t *auditInfop;
    char *resName, *srnName, *runngProgKPON, *runngProgSRN, *localTerm;
    pal_pathBuf_t *pbp;


    kail_atomic_add((int)(1),(void *)(&kaznStats.pdosdCalls));
    kpcInfo = kenv_envGetKPCInfo(envH);
    idListp = kenv_envGetIdListRef(envH);
    procFlags = (((kenv_env_t *)(envH))->accPgm.procFlags);


    msgS.h.class_id = 1;
    msgS.h.class_fmt_vers = 1;

    switch(objType) {
        case 1:
            kail_atomic_add((int)(1),(void *)(&kaznStats.pdosdFileCalls));
            msgS.h.message_id = 1;
            msgS.h.msg_fmt_vers = 1;
            break;

        case 2:

            msgS.h.message_id = 2;
            msgS.h.msg_fmt_vers = 1;
            break;

        case 3:
        kail_atomic_add((int)(1),(void *)(&kaznStats.pdosdNetCalls));
            msgS.h.message_id = 3;
            msgS.h.msg_fmt_vers = 1;
            break;

        default:
        {
            ;
            rc = EINVAL;
            kt_intError(6,
                        2, 336, rc);

            goto fexit2;
        }
    }


    pmsg = kmsg_kGetMsgHandle(0, 0, &rc);
    if (!pmsg) {
        kmsg_err("call_aznDaemon(): can't get msg handle %d", rc);
        goto fexit2;
    }
    kmsg_kSetTimeout(pmsg, 300);


    msgS.c.sys_obj_type = objType;
    msgS.c.accessor_id = idListp->accId;
    msgS.c.action = action;
    msgS.c.accessing_pid = (((kenv_env_t *)(envH))->pid);
    msgS.c.accessor_euid = idListp->effId;
    msgS.c.accessor_ruid = idListp->realId;
    msgS.c.runng_prog_kpon_len = 0;
    (*((int *)&msgS.c.runng_prog_kpon_resource_flags) = 0);

    if (kpcInfo) {
        msgS.c.resource_flags = kpcInfo->resFlags;
        msgS.c.extended_data_len = kpcInfo->extDataLen;
        msgS.c.branchId = kpcInfo->branchId;
    } else {
        (*((int *)&msgS.c.resource_flags) = 0);
        msgS.c.extended_data_len = 0;
        msgS.c.branchId = 0;
    }

    msgS.c.cflags = 0x2;
    if (procFlags & 0x4) {
        msgS.c.cflags |= 0x1;
    }
    if (procFlags & 0x20) {
        msgS.c.cflags |= 0x4;
    }

    if ((objType != 1) || (msgS.c.resource_flags.hasViaPgm)) {
        runngProgKPON = kazn_kpcFileFindPgmResource(envH,
                                &msgS.c.runng_prog_kpon_resource_flags);
        if (runngProgKPON) {
            msgS.c.runng_prog_kpon_len = strlen(runngProgKPON) + 1;
        }
    }

    runngProgSRN = kenv_envGetProgram(envH);
    if (runngProgSRN && (*runngProgSRN != '\0')) {
        msgS.c.runng_prog_srn_len = (((kenv_env_t *)(envH))->accPgm.__srnLen) + 1;
    } else {
        msgS.c.runng_prog_srn_len = 0;
    }




    rc = kmsg_kAppendData(pmsg, (char *)&msgS, sizeof(msgS));
    if (rc) {
        kmsg_err(append_tmsg, rc);
        goto fexit;
    }


    if (msgS.c.runng_prog_kpon_len) {
        rc = kmsg_kAppendData(pmsg, runngProgKPON, msgS.c.runng_prog_kpon_len);
        if (rc) {
            kmsg_err(append_tmsg, rc);
            goto fexit;
        }
    }


    if (msgS.c.runng_prog_srn_len) {
        rc = kmsg_kAppendData(pmsg, runngProgSRN, msgS.c.runng_prog_srn_len);
        if (rc) {
            kmsg_err(append_tmsg, rc);
            goto fexit;
        }
    }


    if (msgS.c.extended_data_len) {
        rc = kmsg_kAppendData(pmsg, (char *)kpcInfo->extData,
                              msgS.c.extended_data_len);
        if (rc) {
            kmsg_err(append_tmsg, rc);
            goto fexit;
        }
    }



    if (kpcInfo) {
        resName = kpcInfo->resName;
        resNameLen = kpcInfo->resNameLen;
    } else {
        resName = NULL;
        resNameLen = 0;
    }

    switch(objType) {
    case 1:
    {
        ;
        if (kpcInfo) {
            mFile.fflags = map_kpc_flags(kpcInfo->kpcFlags);
        } else {
            goto fexit;
        }
        mFile.alt_kpon_cnt = 0;
        mFile.file_kpon_len = resNameLen + 1;




        if (pbp = kenv_envGetFullSrnRef(envH)) {
            mFile.file_srn_len = pbp->pathLen + 1;
            srnName = pbp->path;
        } else if (kpcInfo->kpcFlags & 0x200) {
            mFile.file_srn_len = kpcInfo->resNameLen + 1;
            srnName = kpcInfo->resName;
        } else if (srnName = kenv_envGetTrappedName(envH, &i)) {
            mFile.file_srn_len = i + 1;
        } else if (srnName = kenv_envFdToBname(envH)) {

            mFile.file_srn_len = strlen(srnName) + 1;
        } else {
            mFile.file_srn_len = 0;
            srnName = "<>";
        }

        rc = kmsg_kAppendData(pmsg, (char *)&mFile, sizeof(mFile));
        if (rc) {
            kmsg_err(append_tmsg, rc);
            goto fexit;
        }

        if (mFile.file_kpon_len) {
            rc = kmsg_kAppendData(pmsg, resName, mFile.file_kpon_len);
            if (rc) {
                kmsg_err(append_tmsg, rc);
                goto fexit;
            }
        }

        if (mFile.file_srn_len) {
            rc = kmsg_kAppendData(pmsg, srnName, mFile.file_srn_len);
            if (rc) {
                kmsg_err(append_tmsg, rc);
                goto fexit;
            }
        }



        break;
    }

    case 2:
    {
        if (action & 0x4) {
            kail_atomic_add((int)(1),(void *)(&kaznStats.pdosdLoginCalls));
            isLgn = 1;
        } else {
            kail_atomic_add((int)(1),(void *)(&kaznStats.pdosdIdCalls));
        }
        suId = &(((kenv_env_t *)(envH))->tgt.fs.idSet);
        mIdmod.new_ID = suId->idVal;
        mIdmod.id_mask = map_setmask(suId->setMask);
        mIdmod.local_term_kpon_len = 0;
        mIdmod.local_term_extdata_len = 0;
        mIdmod.remote_term_cand_cnt = 0;

        if (isLgn) {
            kenv_envGetTerminals(envH, &localDev, &nwa);
            if (localDev) {
                localTerm = kazn_kpcFileFindTerminal(envH, &length, &extData);
                if (localTerm) {
                    len = strlen(localTerm);
                    mIdmod.local_term_kpon_len = len + 1;



                    (void)kenv_procSetLocalTerm((((kenv_env_t *)(envH))->pid),
                                                localTerm, len);
                    if (length)
                        mIdmod.local_term_extdata_len = length;
                }
            } else if (nwa) {
                mIdmod.remote_term_cand_cnt = 1;
            }
        }

        rc = kmsg_kAppendData(pmsg, (char *)&mIdmod, sizeof(mIdmod));
        if (rc) {
            kmsg_err(append_tmsg, rc);
            goto fexit;
        }

        if (mIdmod.local_term_kpon_len) {
            rc = kmsg_kAppendData(pmsg, localTerm, mIdmod.local_term_kpon_len);
            if (rc) {
                kmsg_err(append_tmsg, rc);
                goto fexit;
            }
        }

        if (mIdmod.local_term_extdata_len) {
            rc = kmsg_kAppendData(pmsg, (char *)extData,
                                  mIdmod.local_term_extdata_len);
            if (rc) {
                kmsg_err(append_tmsg, rc);
                goto fexit;
            }
        }

        if (mIdmod.remote_term_cand_cnt) {



            rc = kmsg_kAppendData(pmsg, (char *)nwa, sizeof(pal_nwAddr_t));
            if (rc) {
                kmsg_err(append_tmsg, rc);
                goto fexit;
            }
            len = 0;
            rc = kmsg_kAppendData(pmsg, (char *)&len, sizeof(uint32_t));
            if (rc) {
                kmsg_err(append_tmsg, rc);
                goto fexit;
            }
        }

        break;
    }

    case 3:
    {
        if ( !(kazn_kpcNetGetActive()) ) {
            mIdnw.network_kpon_len = 0;
            mIdnw.nwflags = 0;

            do { kenv_env_t *ep = (kenv_env_t *)envH; nwa = (ep->flags & 0x00004000)? &ep->tgt.nw.addrRemote: NULL; } while ( 0);
            if (nwa) {
                mIdnw.nwflags = 0x2;
                mIdnw.remote_conn = *nwa;
            }

            do { kenv_env_t *ep = (kenv_env_t *)envH; nwa = (ep->flags & 0x00008000)? &ep->tgt.nw.addrLocal: NULL; } while ( 0);
            if (nwa) {
                mIdnw.nwflags |= 0x1;
                mIdnw.local_conn = *nwa;
            }

            rc = kmsg_kAppendData(pmsg, (char *)&mIdnw, sizeof(mIdnw));
            if (rc) {
                kmsg_err(append_tmsg, rc);
                goto fexit;
            }
            break;
        }

        mIdnw.network_kpon_len = resNameLen + 1;
        if (kpcInfo && (kpcInfo->kpcFlags & 0x1000)) {
            mIdnw.nwflags = 0x8;
            extResp = 1;
        } else if (kpcInfo && (kpcInfo->kpcFlags & 0x100)) {
            mIdnw.nwflags = 0x4;
        } else {
            mIdnw.nwflags = 0;
        }

        do { kenv_env_t *ep = (kenv_env_t *)envH; nwa = (ep->flags & 0x00004000)? &ep->tgt.nw.addrRemote: NULL; } while ( 0);
        if (nwa) {
            mIdnw.nwflags |= 0x2;
            mIdnw.remote_conn = *nwa;
        }

        do { kenv_env_t *ep = (kenv_env_t *)envH; nwa = (ep->flags & 0x00008000)? &ep->tgt.nw.addrLocal: NULL; } while ( 0);
        if (nwa) {
            mIdnw.nwflags |= 0x1;
            mIdnw.local_conn = *nwa;
        }


        mIdnw.alt_kpon_cnt = ((((kenv_env_t *)(envH))->kpcInfoCount) - 1);
        if (mIdnw.alt_kpon_cnt && kpcInfo) {

            mIdnw.policyVersion = kpcInfo->resData.nw.policyVersion;
            mIdnw.pHost = kpcInfo->resData.nw.pUserRes;
        }

        rc = kmsg_kAppendData(pmsg, (char *)&mIdnw, sizeof(mIdnw));
        if (rc) {
            kmsg_err(append_tmsg, rc);
            goto fexit;
        }

        rc = kmsg_kAppendData(pmsg, resName, mIdnw.network_kpon_len);
        if (rc) {
            kmsg_err(append_tmsg, rc);
            goto fexit;
        }



        if (mIdnw.alt_kpon_cnt > 0) {
            mIdnw.alt_kpon_cnt = 0;
        }
        for (i=0; i < mIdnw.alt_kpon_cnt; i++) {
            amsg_ois_network_alt_t altNet;


            kenv_envSetNextKPCInfo(envH);
            kpcInfo = kenv_envGetKPCInfo(envH);
            if (kpcInfo) {

                altNet.policyVersion = kpcInfo->resData.nw.policyVersion;
                altNet.pHost = kpcInfo->resData.nw.pUserRes;
                resName = kpcInfo->resName;
                resNameLen = kpcInfo->resNameLen;
            } else {
                resName = NULL;
                resNameLen = 0;
            }
            altNet.network_kpon_len = resNameLen + 1;
            rc = kmsg_kAppendData(pmsg, (char *)&altNet, sizeof(altNet));
            if (rc) {
                kmsg_err(append_tmsg, rc);
                goto fexit;
            }
            rc = kmsg_kAppendData(pmsg, resName, altNet.network_kpon_len);
            if (rc) {
                kmsg_err(append_tmsg, rc);
                goto fexit;
            }

        }
        break;
    }

    default:
    {
        ;
        rc = EINVAL;
        kt_intError(6, 2, 685, rc);
        goto fexit;
    }

    }

    if ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active)) {
        if (objType == 1) {
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[7], KT_TRACE_FFDC_AZNCALL_FILE, (((1)<<28) + ((1)<<24) + ((2)<<20) + ((5)<<16)), (long)(resName), (long)srnName, (long)(int)kenv_envGetAuthID(envH), (long)action),0) : 0);




        } else if (objType == 2) {
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[7], KT_TRACE_FFDC_AZNCALL_IDSET, (((2)<<28) + ((2)<<24) + ((5)<<20) + ((0)<<16)), (long)((int)(suId->idVal)), (long)(int)kenv_envGetAuthID(envH), (long)action),0) : 0);



        } else {
            if (action & 0x10) {
                nwa = &mIdnw.remote_conn;
                ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[7], KT_TRACE_FFDC_AZNCALL_NWOUT, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)((int)(ntohl(nwa->ip.addr.addrClassic.addr))), (long)(int)kenv_envGetAuthID(envH), (long)(uint32_t)nwa->service.protocol, (long)ntohs(nwa->service.port)),0) : 0);





                if (nwa->ip.ipV6) {
                    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[7], KT_TRACE_FFDC_IPV6_ADDR, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)((int)ntohl(nwa->ip.addr.a32[0])), (long)(int)ntohl(nwa->ip.addr.a32[1]), (long)(int)ntohl(nwa->ip.addr.a32[2]), (long)(int)ntohl(nwa->ip.addr.a32[3])),0) : 0);




                }
            } else if (action & 0x20) {
                nwa = &mIdnw.local_conn;
                ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[7], KT_TRACE_FFDC_AZNCALL_NWIN, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)((int)(ntohl(nwa->ip.addr.addrClassic.addr))), (long)(int)kenv_envGetAuthID(envH), (long)(uint32_t)nwa->service.protocol, (long)(uint32_t)ntohs(nwa->service.port)),0) : 0);




                if (nwa->ip.ipV6) {
                    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[7], KT_TRACE_FFDC_IPV6_ADDR, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)((int)ntohl(nwa->ip.addr.a32[0])), (long)(int)ntohl(nwa->ip.addr.a32[1]), (long)(int)ntohl(nwa->ip.addr.a32[2]), (long)(int)ntohl(nwa->ip.addr.a32[3])),0) : 0);




                }

                nwa = &mIdnw.remote_conn;
                ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[7], KT_TRACE_FFDC_AZNCALL_RACC_ADDR, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)((int)(ntohl(nwa->ip.addr.addrClassic.addr))), (long)ntohs(nwa->service.port)),0) : 0);



            } else {
                nwa = &mIdnw.local_conn;
                kt_logString(0, "Unexpected n/w action");
            }
        }


        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[7], KT_TRACE_FFDC_AZNCALL_CONT, (((2)<<28) + ((2)<<24) + ((1)<<20) + ((6)<<16)), (long)((int)idListp->effId), (long)(int)idListp->realId, (long)runngProgSRN, (long)(int)procFlags),0) : 0);




    }



    mResponse.header.message_id = 9999;
    mResponse.result = 0;
    tstamp = ((pal_time_t)(kail_xtime->tv_sec));
    kail_atomic_add((int)(1),(void *)(&kaznStats.pdosdActiveCalls));

    rc = kmsg_kGetResponse(pmsg, (char *)&mResponse, sizeof(mResponse),
                           &resp_len);

    kail_atomic_add((int)(-1),(void *)(&kaznStats.pdosdActiveCalls));
    pdosdResult = mResponse.result;


    if (pdosdResult & 0x1) {
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[7], KT_TRACE_FFDC_AZNCALL_RES_PERMIT, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)((int)pdosdResult)),0) : 0);


        if (pdosdResult & 0x100) {

            uint32_t name_len;
            int rc2;
            char lResName[128], *pResName=NULL;


            rc2 = kmsg_kGetResponse(pmsg, (char *)&name_len, sizeof(name_len),
                           &resp_len);
            if (rc2 == 0) {
                if (name_len <= 128) {
                    pResName = lResName;
                } else {
                    pResName = pal_alloc(name_len);
                }
                if (pResName) {
                    rc2=kmsg_kGetResponse(pmsg, pResName, name_len,&resp_len);
                    if (rc2 == 0) {

                        kazn_kpcNetSetResource(action, envH, pResName);

                    }
                    if (pResName != lResName) {
                        pal_free(pResName, name_len);
                    }
                } else {
                    rc2 = ENOMEM;
                }
            }

        }
    } else {
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[7], KT_TRACE_FFDC_AZNCALL_RES_DENY, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(rc), (long)resp_len, (long)(int)pdosdResult),0) : 0);



    }

    if (rc) {
        if (rc == ETIMEDOUT) {
            kail_atomic_add((int)(1),(void *)(&kaznStats.pdosdTimeOuts));
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[0], KT_TRACE_KAZN_AZND_TOUT, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)((int)(((pal_time_t)(kail_xtime->tv_sec)) - tstamp)), (long)objType, (long)action, (long)kaznStats.pdosdActiveCalls),0) : 0);




        }

        if (rc != EBUSY) {

            kmsg_err("call_aznDaemon(): kmsg_kGetResponse() err = %d", rc);
        }
        goto fexit;
    } else {
        if (((((pal_time_t)(kail_xtime->tv_sec)) - tstamp) > 1) &&
            (!isLgn || ((((pal_time_t)(kail_xtime->tv_sec)) - tstamp) > 5))) {
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[7], KT_TRACE_FFDC_AZNCALL_SLOW, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)((int)(((pal_time_t)(kail_xtime->tv_sec)) - tstamp))),0) : 0);

            kail_atomic_add((int)(1),(void *)(&kaznStats.pdosdSlowCalls));
        }
    }


    if (((resp_len != sizeof(mResponse)) && (!extResp)) ||
        (mResponse.header.message_id != 4)) {

        rc = EINVAL;
        kmsg_err("call_aznDaemon(): bad AZN response msg %d", resp_len);
        goto fexit;
    }


    if (pdosdResult & 0x1) {
        accOk = 0x1;
    } else if (pdosdResult & 0x2) {
        accOk = 0x2;
    } else if (pdosdResult == 0x20) {
        rc = EBUSY;
    } else {

        rc = EINVAL;
        kmsg_err("call_aznDaemon(): received invalid AZN result: 0x%x",
                 pdosdResult);
        goto fexit;
    }

    if (pdosdResult != 0x1) {

        if (pdosdResult & 0x4) {
            accOk |= 0x8;
            if (pdosdResult & 0x1) {
                kail_atomic_add((int)(1),(void *)(&kaznStats.pdosdGrantAudit));


                if (action & 0x4) {
                    kenv_procFlags_t pf;

                    pf = 0x00200000;
                    if (pdosdResult & 0x200) {
                        pf |= 0x01000000;
                        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) >= 3) ? (kt_Event2((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_USER_AUDIT_LOGOUT, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(pdosdResult), (long)((((kenv_env_t *)(envH))->pid))),0) : 0);



                    }
                    kenv_procAddProcFlags((((kenv_env_t *)(envH))->pid), &pf);
                }
            } else {
                kail_atomic_add((int)(1),(void *)(&kaznStats.pdosdDenyAudit));
            }
        }

        if (pdosdResult & 0x8) {
            accOk |= 0x4;
            if (pdosdResult & 0x1) {
                kail_atomic_add((int)(1),(void *)(&kaznStats.pdosdGrantError));
            } else {
                kail_atomic_add((int)(1),(void *)(&kaznStats.pdosdDenyError));
            }
        }

        if (pdosdResult & 0x10) {
            accOk |= 0x10;
            kail_atomic_add((int)(1),(void *)(&kaznStats.pdosdInWarning));
        }
    }

    if (kazn_lost_contact && (rc == 0)) {
        kazn_lost_contact = 0;



        if ((kaud_audit_level & (0x4))) {
            auditInfop = (kaud_auditServInfo_t *)pal_alloc(
                        sizeof(kaud_auditServInfo_t));
            if (auditInfop) {
                auditInfop->event_id = 0x35a50021;
                auditInfop->aud_view = 3;
                auditInfop->aud_action = 1;
                auditInfop->aud_reason = 1;
                auditInfop->aud_outcome = 1;
                auditInfop->aud_resr_type = 2;
                kaud_auditService(auditInfop);
                pal_free(auditInfop, sizeof(kaud_auditServInfo_t));
            }
        }
        pal_logErr(0x340b4006, NULL);
        kt_logString(0, "regained contact with aznDaemon");
    }

fexit:
    kmsg_kPutMsgHandle(pmsg);

fexit2:
    if (rc && (rc != EBUSY)) {
        kail_atomic_add((int)(1),(void *)(&kaznStats.pdosdFail));
        accOk |= 0x4;
        if (action & 0x4) {



            errCheckId = (&(((kenv_env_t *)(envH))->tgt.fs.idSet))->idVal;
            isSuser = (errCheckId == (pal_authID_t)0);
        } else {
            errCheckId = idListp->accId;
            isSuser = (pal_suser() && (errCheckId == (pal_authID_t)0));
        }
        if (kutil_isPrivUid(errCheckId) ||
            kaud_warning_mode ||
            (isSuser && kazn_grantSuserOnError)) {
            accOk = 0x1 | 0x4;
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[7], KT_TRACE_FFDC_ERR_GRANT, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(rc), (long)(int)errCheckId, (long)isSuser, (long)(int)idListp->realId),0) : 0);




        }
    }

    *result = accOk;
    return(rc);
}
kazn_aznResult_t
kazn_checkAccess(kenv_envHandle_t envH, int objType, int action, int eflags)
{
    int rc, busyLoops = 0;
    kazn_aznResult_t aznResult;
    pal_idList_t *idListp;
    kenv_procFlags_t procFlags;


    for (;;) {
        rc = call_aznDaemon(envH, objType, action, &aznResult);
        if (rc != EBUSY) {
            break;
        }

        busyLoops++;
        kail_atomic_add((int)(1),(void *)(&kaznStats.pdosdBusy));
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_DAEMON_EBUSY, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(busyLoops), (long)kaznStats.pdosdBusy),0) : 0);

        pal_delay(500);
        if (busyLoops > 7200) {



            rc = ETIMEDOUT;
            kail_atomic_add((int)(1),(void *)(&kaznStats.pdosdTimeOuts));
            kmsg_err("call_aznDaemon(): too many busy waits", busyLoops);
            aznResult = (0x2 | 0x4);
            kt_intError(6,
                        2, 1007, rc);
            break;
        }
    }


    if (!(aznResult & 0x1)) {
        idListp = kenv_envGetIdListRef(envH);
        procFlags = (((kenv_env_t *)(envH))->accPgm.procFlags);
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_CHECKACCESS_DENY, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(rc), (long)aznResult),0) : 0);


        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_CHECKACCESS_DENY_MORE, (((2)<<28) + ((2)<<24) + ((6)<<20) + ((0)<<16)), (long)(idListp->realId), (long)idListp->effId, (long)procFlags),0) : 0);



    }

    return aznResult;
}
