
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *
 * IBM Tivoli Access Manager for Operating Systems 6.0.0
 * 5698-PDO
 * Licensed Materials - Property of IBM
 * 
 * (C) Copyright IBM Corp. 2000,2006. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 *
*/

static char sccsid[] = "@(#)87       1.34  src/oss/kazn/kdriver/x86_linux_2/kazn_entry.c, oss.kazn.src, oss600, 070720c 8/9/07 13:35:21";
#include <linux/kernel.h>

#include <linux/module.h>

#include <linux/ioctl.h>
#include <linux/kernel.h>

#include <linux/stddef.h>


#include <asm/string.h>

#include <asm/byteorder.h>






#include <linux/stat.h>


#include <linux/limits.h>

#include <linux/errno.h>

#include <asm/ptrace.h>

#include <asm/fcntl.h>
  typedef int intptr_t;


 typedef unsigned int uintptr_t;


typedef __kernel_uid32_t uid32_t;
typedef __kernel_gid32_t gid32_t;
typedef struct kail_vfs
{
    void *mnt;
    void *mnt_parent;
    char devname[64];
} kail_vfs_t;






typedef struct {
        long val[2];
} kail_fsid_t;

typedef struct kail_fid {
    uint32_t fid_ino;
    uint32_t fid_gen;
    uint16_t fid_flags;
    uint16_t fid_data_len;

    char fid_data[(sizeof(char) * 64)];
} kail_fid_t;

typedef mode_t kail_fmode_t;
typedef dev_t kail_dev_t;
typedef void * kail_vnodeH_t;
typedef struct _kail_rfid {
    uint32_t ctime;
    kail_fsid_t fsid;
    kail_fid_t fid;
} kail_rawFid_t;
typedef struct _kail_cred {

        uid_t uid,euid,suid,fsuid;
        gid_t gid,egid,sgid,fsgid;
        int ngroups;
        int cr_ref;
        gid_t groups[32 ];
} kail_cred_t;

typedef int64_t kail_authID_t;
enum kail_ftypes { KAIL_FTYPE_NONE, KAIL_FTYPE_FILE, KAIL_FTYPE_DIR,
             KAIL_FTYPE_BLKDEV, KAIL_FTYPE_CHARDEV, KAIL_FTYPE_LNK,
             KAIL_FTYPE_SOCK, KAIL_FTYPE_BAD, KAIL_FTYPE_FIFO,
             KAIL_FTYPE_MPC, KAIL_FTYPE_OTHER};
typedef enum kail_ftypes kail_ftypes_t;

typedef struct _kail_fattr {
    kail_authID_t uid;
    kail_authID_t gid;
    kail_ftypes_t ftype;
    kail_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    dev_t dev;
    kail_vfs_t check_vfsp;
} kail_fattr_t;




extern volatile struct timespec *kail_xtime;





extern asmlinkage int (*kail_printk)(const char *, ...);
extern asmlinkage int (*kail_sprintf)(char * buf, const char * fmt, ...);
extern asmlinkage int (*kail_do_fork)(unsigned long, unsigned long, struct pt_regs *, unsigned long);


extern asmlinkage int kail_kernel_thread(int (*)(void *), void *,unsigned long);
extern asmlinkage int kail_kill_proc(pid_t, int, int);
extern asmlinkage long kail_strncpy_from_user(char *, const char *, long);
extern asmlinkage long kail_strncpy_from_DND(char *, void *, long);
extern unsigned long FASTCALL(kail_copy_to_user(void *, const void *, unsigned long));
extern unsigned long FASTCALL(kail_copy_from_user(void *, const void *, unsigned long));

extern void FASTCALL(kail_kernel_free(void *,unsigned long));
extern void * FASTCALL(kail_kernel_malloc(unsigned long));





extern asmlinkage void kail_mutex_init(void **);
extern void FASTCALL(kail_mutex_lock(void **));
extern int FASTCALL(kail_mutex_trylock(void **));
extern void FASTCALL(kail_mutex_unlock(void **));
extern asmlinkage void kail_mutex_destroy(void **);

extern asmlinkage void kail_cond_init(void **);
extern void FASTCALL(kail_wake_up(void **));
extern void FASTCALL(kail_cond_wait(void **, void **));
extern int FASTCALL(kail_cond_wait_intr(void **, void **));
extern asmlinkage int kail_condTimedWait(void **, void **, int64_t, int);
extern asmlinkage void kail_cond_destroy(void **);

extern asmlinkage void kail_iclock_init(void **);
extern void FASTCALL(kail_iclock_lock(void **));
extern void FASTCALL(kail_iclock_unlock(void **));
extern int FASTCALL(kail_iclock_trylock(void **));
extern asmlinkage void kail_iclock_destroy(void **);

extern void FASTCALL(kail_iclock_cond_wait(void **,void **));

extern asmlinkage int kail_current_pid(void);
extern asmlinkage int kail_current_tid(void);
extern asmlinkage int kail_current_Ppid(void);
extern int FASTCALL(kail_tid_to_pid(int));
extern pid_t FASTCALL(kail_pid_get_epid(pid_t));
extern void FASTCALL(kail_pid_delete(pid_t));
extern void FASTCALL(kail_epid_delete(pid_t));
extern void FASTCALL(kail_pid_add(pid_t,pid_t));


extern asmlinkage int kail_current_uid(void);
extern asmlinkage int kail_current_euid(void);
extern asmlinkage int kail_current_suid(void);
extern asmlinkage int kail_current_gid(void);
extern asmlinkage int kail_current_egid(void);
extern int FASTCALL(kail_current_files_close_on_exec(int));

extern asmlinkage int kail_socket_protocol(void *);
extern asmlinkage int kail_socket_getname(void *,void *,int *,int);

extern int FASTCALL(kail_fd_to_dev(int, dev_t *));
extern int FASTCALL(kail_fd_to_name(int, char **, int *));
extern int FASTCALL(kail_fd_to_socket(int,void **));

extern int FASTCALL(kail_socket_shutdown(void *));




extern int FASTCALL(kail_check_pid(int));
extern int FASTCALL(kail_get_pid_pgrp(int,int *));
extern int FASTCALL(kail_get_pid_uid(int,int *,int *));
extern void FASTCALL(kail_scan_procs(void *));

extern asmlinkage void kail_daemonize(const char *);
extern asmlinkage int kail_total_ram_mb(void);
extern void FASTCALL(kail_atomic_add(int,void *));

extern asmlinkage int kail_kernel_address_mode(void);






extern asmlinkage int kail_decomposePath(char *, int, kail_rawFid_t *, int *, kail_rawFid_t *, int *, kail_fattr_t *, kail_vnodeH_t *);
extern asmlinkage int kail_LookupFidAndDir(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, int *);
extern asmlinkage int kail_lookupFidsAndInfo(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, kail_vnodeH_t *, kail_vnodeH_t *, int *);
extern asmlinkage int kail_dirFidToPathFids( kail_rawFid_t *, kail_rawFid_t **, int *);
extern asmlinkage int kail_unixDescToRawFid( int , kail_rawFid_t *);
extern asmlinkage int kail_vnodesToFids( kail_vnodeH_t, kail_vnodeH_t, kail_rawFid_t *, kail_rawFid_t *, kail_rawFid_t **, int *, kail_fattr_t *);
extern asmlinkage int kail_makeFidChain(void *, kail_rawFid_t *, int *, const kail_cred_t *, int );

extern asmlinkage int kail_copy_exec_argv(void *, char *, int);


struct group_info;
extern gid_t * FASTCALL(kail_groups_blocks(struct group_info *,int));
extern int FASTCALL(kail_groups_ngroups(struct group_info *));
extern int FASTCALL(kail_groups_nblocks(struct group_info *));







struct kail_register_chrdev_parameters {
        unsigned int dev_number;
        char *name;
        void *ownerp;
        void *readp;
        void *writep;
        void *ioctlp;



        void *openp;
        void *releasep;
        unsigned int ioctl_cnt;
        unsigned int *ioctl_cmds;
} ;

extern asmlinkage int kail_register_chrdev(struct kail_register_chrdev_parameters *, void **);
extern asmlinkage int kail_unregister_chrdev(struct kail_register_chrdev_parameters *, void *);
extern int FASTCALL(kail_minor(void *));

extern asmlinkage int kail_file_read(char *, kail_vnodeH_t *,char *, long, long);
extern asmlinkage void kail_write_log(const char *,const char *, int, int);
extern asmlinkage void kail_log_init(const char *);

extern asmlinkage int kail_pathToFullPath( char *, int , char **, char *,int);
extern void * FASTCALL(kail_unixDescToVnode(int));
extern void FASTCALL(kail_releVnode(void *));
extern void FASTCALL(kail_holdVnode(void *));
extern asmlinkage char * kail_readSymLink(char *, int *);



extern asmlinkage int kail_vfs_mounted(kail_vfs_t *);
extern asmlinkage int kail_vfs_check(kail_vfs_t *);


typedef struct {
        void *alloc;
        void *free;
        void *fcc_find;
        void *fcc_add;
} kail_call_back_t;

extern asmlinkage void kail_call_backs(kail_call_back_t *);
extern asmlinkage void kail_kernel_interface(void);
extern asmlinkage void kail_kernel_interface_shutdown(void);

typedef asmlinkage long (* sys_call_fn)();
struct kail_syscall_prepost {
        int call_index;
        sys_call_fn call_pre;
        sys_call_fn call_post;
};

extern int struct_cppath_size;

struct kail_lsmhooks {
        int lsmhook_index;
        sys_call_fn lsmhook_pre;
        sys_call_fn lsmhook_post;
};
extern asmlinkage int kail_trap_syscalls(struct kail_syscall_prepost *,struct kail_lsmhooks *);



extern asmlinkage void kail_restore_syscalls(void);

extern int change_KailPerm2ro(void);

struct nameidata;
struct kail_datanameidata {
        char cdata[4];
        char *path;
        struct nameidata *nd;
};
#define KAIL_LOOKUP_BIT 0x40000000
#if defined(LINUX_RHEL4) || defined(LINUX_SLES10) || defined(LINUX_RHEL5)
#define SET_LOOKUP_FLAG(n) (n)->intent.open.flags = KAIL_LOOKUP_BIT;
#define CLEAR_LOOKUP_FLAG(n) (n)->intent.open.flags &= ~KAIL_LOOKUP_BIT;
#define CHECK_LOOKUP_FLAG(n) ((n)->intent.open.flags == KAIL_LOOKUP_BIT)
#endif 
#ifdef LINUX_SLES9
#define SET_LOOKUP_FLAG(n)
#define CLEAR_LOOKUP_FLAG(n)
#define CHECK_LOOKUP_FLAG(n)
#endif 
typedef unsigned char byte_t;





typedef int64_t oss_uid_t;
typedef int64_t oss_gid_t;
typedef struct {
    int ipV6:1;
    int ipV6V4Mapped:1;
    int ipV6V4Compat:1;
    union {
        uint32_t a32[4];
        uint16_t a16[8];
        uint8_t a8[16];
        struct {
            uint32_t pad[3];
            uint32_t addr;
        } addrClassic;
    } addr;
} oss_nwIP_t;





typedef struct {
    uint16_t protocol;
    uint16_t port;
} oss_nwService_t;

typedef struct {
    oss_nwIP_t ip;
    oss_nwService_t service;
} oss_nwAddr_t;

typedef struct {
    uint32_t count;
    oss_nwIP_t* ip;
} oss_nwIPList_t;

typedef struct {
    uint32_t count;
    char** name;
} oss_nwNameList_t;
typedef pid_t tid_t;



typedef pid_t pal_pid_t;
typedef tid_t pal_tid_t;




typedef unsigned long pal_scall_parm_t;


typedef void * pal_caller_t;



typedef kail_fmode_t pal_fmode_t;
typedef kail_dev_t pal_dev_t;
typedef kail_vnodeH_t pal_vnodeH_t;
typedef kail_vfs_t pal_vfs_val_t;



typedef kail_fsid_t pal_fsid_t;
typedef kail_fid_t pal_fid_t;
typedef kail_cred_t cred_t;

static inline int pal_pinMem(void *mem, size_t size)
{ return 0; }

static inline int pal_unpinMem(void *mem, size_t size)
{ return 0; }
static inline int pal_copyin(char *uaddr, char *kaddr, size_t count)
{
    return (int)kail_copy_from_user(kaddr, uaddr, count);
}
static inline int pal_copyout(char *kaddr, char *uaddr, size_t count)
{
    return (int)kail_copy_to_user(uaddr, kaddr, count);
}
static inline int
pal_copyinstr(char *uaddr, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_user(kaddr, uaddr, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int
pal_copyinstr_LSM(void *dnd, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_DND(kaddr, dnd, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int pal_suser(void)
{
    return (kail_current_euid() == 0);
}
static inline int
pal_unixDescIsCOE(int fd)
{
        return kail_current_files_close_on_exec(fd);
}
static inline void
pal_releVnode(pal_vnodeH_t vnh)
{
    ;
    kail_releVnode((void *)vnh);
}
static inline void
pal_holdVnode(pal_vnodeH_t vnh)
{
    ;
    kail_holdVnode((void *)vnh);
}





typedef void * pal_mutex_t;
typedef void * pal_cond_t;
typedef void * pal_icLock_t;
static inline int
pal_file_read(char *path, pal_vnodeH_t vnodeH, char *buffer, long offset, long len)
{
        return kail_file_read(path,vnodeH,buffer,offset,len);
}
extern char *pal_immunePrograms[];

extern char *pal_loginPrograms[];






extern void pal_machInit(void);
extern void pal_machShutdown(void);
extern int pal_mapOpenFlags(int);
extern void pal_fccInit(void);
extern void pal_fccShutdown(void);
extern void pal_fccFlush(void);
extern int pal_checkLoginBypassMach(char *, int, void *,void *, int32_t *);

extern void pal_errLogInit(void);
typedef oss_nwAddr_t pal_nwAddr_t;







typedef struct _pal_time {
    uint32_t secs;
    int32_t usecs;
} pal_timestruct_t;




typedef int64_t pal_time_t;
typedef oss_uid_t pal_uid_t;
typedef oss_gid_t pal_gid_t;

typedef pal_uid_t pal_authID_t;


typedef uint32_t pal_ptr32_t;
typedef struct _ids {
    pal_authID_t idVal;
    int setMask;
} pal_idSet_t;
typedef struct _idlist {
    pal_authID_t realId;
    pal_authID_t effId;
    pal_authID_t accId;


} pal_idList_t;
enum pal_ftypes { PAL_FTYPE_NONE, PAL_FTYPE_FILE, PAL_FTYPE_DIR,
             PAL_FTYPE_BLKDEV, PAL_FTYPE_CHARDEV, PAL_FTYPE_LNK,
             PAL_FTYPE_SOCK, PAL_FTYPE_BAD, PAL_FTYPE_FIFO,
             PAL_FTYPE_MPC, PAL_FTYPE_OTHER};
typedef enum pal_ftypes pal_ftypes_t;
typedef struct _fattr {
    pal_authID_t uid;
    pal_authID_t gid;
    pal_ftypes_t ftype;
    pal_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    pal_dev_t dev;
    pal_vfs_val_t check_vfsp;
} pal_fattr_t;
typedef struct _rfid {
    uint32_t ctime;
    pal_fsid_t fsid;
    pal_fid_t fid;
} pal_rawFid_t;
typedef struct pal_ph {
    char *path;
    char *pbuf;
    int pathLen;
    int pbLen;
    int flags;
} pal_pathBuf_t;
extern int pal_sysMemMB;
typedef char * pal_pathMemInfo_t;
extern char *pal_readSymLink(char *, int *);





extern void pal_delay(int);
extern int pal_kthreadCreate(void (*)(), void *, char *);
extern pal_authID_t pal_getEGid(void);







extern void pal_logErrMach(char *, int);
typedef char * sharedMemPtr_t;
extern char *pal_alloc(size_t);
extern void pal_free(void *, size_t);



extern void pal_getAllocInfo(int *, size_t *);
extern void pal_logErr(int, char *);
extern int pal_copyin(char *, char *, size_t);
extern int pal_copyinstr(char *, char *, size_t, size_t *);
extern int pal_copyout(char *, char *, size_t);
extern int pal_decomposePath(char *, int, pal_rawFid_t *, int *,
                        pal_rawFid_t *, int *, pal_fattr_t *, pal_vnodeH_t *);
extern int pal_LookupFidAndDir(char *, int, pal_rawFid_t *,
                               pal_rawFid_t *, pal_fattr_t *, int *);
extern int pal_vnodesToFids(pal_vnodeH_t, pal_vnodeH_t,
                            pal_rawFid_t *, pal_rawFid_t *, pal_rawFid_t **,
                            int *, pal_fattr_t *);
extern int pal_pathToFullPath(char *, int, pal_pathBuf_t *);
extern int pal_dirFidToPathFids(pal_rawFid_t *, pal_rawFid_t **, int *);
extern int pal_unixDescToRawFid(int, pal_rawFid_t *);
extern pal_vnodeH_t pal_unixDescToVnode(int);
extern int pal_unixDescToBaseName(int, pal_vnodeH_t, pal_pathBuf_t *);
extern int pal_unixDescIsCOE(int);



extern int pal_suser(void);
extern pal_authID_t pal_getEuid(void);
extern void pal_getREUids(pal_idList_t *);
extern void pal_holdVnode(pal_vnodeH_t);
extern void pal_releVnode(pal_vnodeH_t);
extern int pal_pinMem(void *, size_t);
extern int pal_unpinMem(void *, size_t);
extern int pal_getLocalTermDevice(char *, int, pal_dev_t *);
int pal_checkInheritLoginState(char *, uint32_t, int32_t, int32_t *);
int pal_execChecking(char *, int32_t *, uint32_t *, uint32_t *);
void pal_loginOriginWasReset(int32_t *);
extern int pal_checkLoginBypass(char *, int,
                                pal_idSet_t *, pal_idList_t *, int32_t *);
extern int32_t pal_devToInt32(pal_dev_t);
extern int pal_isImmunePath(char *);
extern int pal_expandExecArgs(void *, char *, int, int);


extern int pal_lookupFidsAndInfo(char *, int, pal_rawFid_t *,
        pal_rawFid_t *, pal_fattr_t *, pal_vnodeH_t *, pal_vnodeH_t *, int *);
extern int pal_pathFidsFromDirVnh(pal_vnodeH_t, pal_rawFid_t *, int *);
extern int pal_file_read(char *,pal_vnodeH_t,char *, long, long);





extern void pal_init(void);
extern void pal_shutdown(void);
struct uio {
        char *uio_base;
        char *uio_current;
        int32_t uio_left;
} ;
typedef struct uio uio_t;
typedef struct uio pal_uio_t;
static inline int
pal_uio_read(const char * const kaddr, const size_t count, pal_uio_t *const uiop)
{

        if (count < uiop->uio_left) {

                memcpy(uiop->uio_current,kaddr,count);


                uiop->uio_current += count;
                uiop->uio_left -= count;
                return 0;
        }
        else
        {




                return EFAULT;
        }
}
static inline int
pal_uio_write(char * const kaddr, const size_t count, pal_uio_t * const uiop)
{
    int rc = EFAULT;

        if (count <= uiop->uio_left) {

            memcpy(kaddr,uiop->uio_current,count);


            uiop->uio_current += count;
            uiop->uio_left -= count;
            return 0;
        }
        else
        {




                return EFAULT;
        }
}
typedef struct kazndrv_sysargs
{
    int arg_subcall;
    pal_scall_parm_t arg_p1;
    pal_scall_parm_t arg_p2;
    pal_scall_parm_t arg_p3;
    pal_scall_parm_t arg_p4;
    pal_scall_parm_t arg_p5;
    int arg_rc;
} kazndrv_sysargs_t;


typedef unsigned long long pal_scall_parm64_t;
typedef struct kazndrv_sysargs64
{
    int arg_subcall;
    pal_scall_parm64_t arg_p1 ;
    pal_scall_parm64_t arg_p2 ;
    pal_scall_parm64_t arg_p3 ;
    pal_scall_parm64_t arg_p4 ;
    pal_scall_parm64_t arg_p5 ;
    int arg_rc;
} kazndrv_sysargs64_t;
extern kosseal_syscall(int, pal_scall_parm_t, pal_scall_parm_t,
                       pal_scall_parm_t, pal_scall_parm_t, pal_scall_parm_t,
                       int *);
#include <linux/ioctl.h>
static char KMSG_DEVICE[][14] = {
    "/dev/kossazn",
    "/dev/kossaud"
};




extern int kmsgDebug;
int kazn_base_configured = 0;
static int Major;

MODULE_AUTHOR("IBM / Tivoli Systems");
MODULE_DESCRIPTION("IBM / Tivoli Policy Director for Operating Systems");

 MODULE_LICENSE("GPL");






#include <linux/vermagic.h>

#include <linux/compiler.h>

struct module __this_module
__attribute__((section(".gnu.linkonce.this_module"))) = {





 .name = __stringify(kaznmod),

 .init = init_module,



};



MODULE_VERSION("6.0");

static const char __module_depends[]
__attribute_used__
__attribute__((section(".modinfo"))) =
"depends=";
int kazndrv_open(void *inode, void *file)
{
  const int minor = kail_minor(file);

    ;

    if ((minor == 2)) {
            return 0;
    }
    else
            return KMSG_open(minor);

}


int kazndrv_close(void *inode, void *file)
{
  const int minor = kail_minor(file);

    ;

    if ((minor == 2)) {



            return 0;
    }
    else
            return KMSG_close(minor);

}

int kazndrv_ioctl(void *unused_inode, void *file, unsigned int cmd, unsigned long data)
{
  const int minor = kail_minor(file);

    ;

    if ((minor == 2)) {




       if (cmd == _IOWR('X', 3, kazndrv_sysargs_t))

       {
          kazndrv_sysargs_t * u_sparms = (kazndrv_sysargs_t *)data;
          kazndrv_sysargs_t k_sparms;
          int rc;


          kail_copy_from_user(&k_sparms,u_sparms,sizeof(kazndrv_sysargs_t));

          rc = kosseal_syscall(k_sparms.arg_subcall, k_sparms.arg_p1,
                          k_sparms.arg_p2, k_sparms.arg_p3,
                          k_sparms.arg_p4, k_sparms.arg_p5, &k_sparms.arg_rc);


          kail_copy_to_user(&(u_sparms->arg_rc),&k_sparms.arg_rc,sizeof k_sparms.arg_rc);

          return rc;
       }
       else


               return 0;
    }
    else
            return KMSG_ioctl(minor, cmd, data);

}
char tmp_space[24];

ssize_t kazndrv_read (void *file, char *ptr, size_t size, loff_t *offset)
{
  const int minor = kail_minor(file);

    ;


    if ((minor == 2)) {
            if (size > 23) size=23;
            kail_copy_to_user(ptr,tmp_space,size);
            return size;
    }
    else
            return KMSG_read(minor, ptr, size, offset);

}


ssize_t kazndrv_write (void *file, const char *ptr, size_t size, loff_t *offset)
{
  const int minor = kail_minor(file);

    ;


    if ((minor == 2)) {
            if (size > 23) size=23;
            kail_copy_from_user(tmp_space,ptr,size);

            if ((tmp_space[0] == '5') && !strncmp(tmp_space,"541529_",7)) {
            }
            return size;
    }
    else
            return KMSG_write(minor, ptr, size, offset);

}

static void *Fops = NULL;


#include <linux/init.h>

extern void fccAdd(pal_rawFid_t *, int);
extern int fccFind(pal_rawFid_t *, pal_rawFid_t *, int *);






static int __init kazn_init_module( void )
{
    int err = 0;

    {
            kail_call_back_t call_backs;
            call_backs.alloc = (void *)(&pal_alloc);
            call_backs.free = (void *)(&pal_free);
            call_backs.fcc_find = (void *)(&fccFind);
            call_backs.fcc_add = (void *)(&fccAdd);
            kail_call_backs(&call_backs);
    }

    ;


    if (kazn_base_configured) {
            ;
            return 0;
    } else {
            kazn_base_configured = 1;
    }
    if (!err) {

        pal_init();
        kutil_commonInit();
        kmsg_Init();
        if (nct_init()) {

                ;

                nct_shutdown();
                kmsg_shutdown();
                kutil_commonShutdown();
                pal_shutdown();

                err = -1;


                kail_kernel_interface_shutdown();

        }
    }

    if (!err) {
        struct kail_register_chrdev_parameters *krcp;







        krcp = (struct kail_register_chrdev_parameters *)__builtin_alloca (sizeof(*krcp));

        krcp->dev_number = 0;
        krcp->name = "kazndrv";
        krcp->ownerp = (void *)&__this_module;
        krcp->readp = (void *)&kazndrv_read;
        krcp->writep = (void *)&kazndrv_write;
        krcp->ioctlp = (void *)&kazndrv_ioctl;



        krcp->openp = (void *)&kazndrv_open;
        krcp->releasep = (void *)&kazndrv_close;
        krcp->ioctl_cnt = 0;
        krcp->ioctl_cmds = NULL;


        Major = kail_register_chrdev(krcp, (void **)&Fops);

        if (Major < 0) {
                ;




                err = Major;
        } else {
                ;
        }
    }

    ;


    if (err) {



        kazn_base_configured = 0;
    }

    return( err );

}






static void kazn_cleanup_module(void)
{
    int err=0;

    ;

    if (!kutil_privCheck(0,0)) {
        err = -EPERM;
        goto out;
    }

    if (!kazn_base_configured) {
        err = -1;
        kail_printk( "KAZNMOD is NOT currently configured!\n" );
    } else {
        kazn_base_configured = 0;
    }





        {
                struct kail_register_chrdev_parameters *krcp;






                krcp = (struct kail_register_chrdev_parameters *)__builtin_alloca (sizeof(*krcp));

                krcp->dev_number = Major;
                krcp->name = "kazndrv";
                krcp->ioctl_cnt = 0;
                krcp->ioctl_cmds = NULL;

                err = kail_unregister_chrdev(krcp,Fops);
        }


        nct_shutdown();
        kmsg_shutdown();
        kutil_commonShutdown();
        pal_shutdown();


        kail_kernel_interface_shutdown();

        ;

    if (err) {
        err = 0;
        kazn_base_configured = 1;
        goto out;
    }

 out:

    return;
}

module_init(kazn_init_module);
module_exit(kazn_cleanup_module);
