
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *
 * IBM Tivoli Access Manager for Operating Systems 6.0.0
 * 5698-PDO
 * Licensed Materials - Property of IBM
 * 
 * (C) Copyright IBM Corp. 2000,2006. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 *
*/

static char sccsid[]="@(#)72	1.42  src/oss/kazn/kmsg/kmsg.c, oss.kazn.src, oss600, 050722a  7/15/05  15:48:49";
#include <linux/kernel.h>

#include <linux/stddef.h>


#include <asm/string.h>

#include <asm/byteorder.h>






#include <linux/stat.h>


#include <linux/limits.h>

#include <linux/errno.h>

#include <asm/ptrace.h>

#include <asm/fcntl.h>
  typedef int intptr_t;


 typedef unsigned int uintptr_t;


typedef __kernel_uid32_t uid32_t;
typedef __kernel_gid32_t gid32_t;
typedef struct kail_vfs
{
    void *mnt;
    void *mnt_parent;
    char devname[64];
} kail_vfs_t;






typedef struct {
        long val[2];
} kail_fsid_t;

typedef struct kail_fid {
    uint32_t fid_ino;
    uint32_t fid_gen;
    uint16_t fid_flags;
    uint16_t fid_data_len;

    char fid_data[(sizeof(char) * 64)];
} kail_fid_t;

typedef mode_t kail_fmode_t;
typedef dev_t kail_dev_t;
typedef void * kail_vnodeH_t;
typedef struct _kail_rfid {
    uint32_t ctime;
    kail_fsid_t fsid;
    kail_fid_t fid;
} kail_rawFid_t;
typedef struct _kail_cred {

        uid_t uid,euid,suid,fsuid;
        gid_t gid,egid,sgid,fsgid;
        int ngroups;
        int cr_ref;
        gid_t groups[32 ];
} kail_cred_t;

typedef int64_t kail_authID_t;
enum kail_ftypes { KAIL_FTYPE_NONE, KAIL_FTYPE_FILE, KAIL_FTYPE_DIR,
             KAIL_FTYPE_BLKDEV, KAIL_FTYPE_CHARDEV, KAIL_FTYPE_LNK,
             KAIL_FTYPE_SOCK, KAIL_FTYPE_BAD, KAIL_FTYPE_FIFO,
             KAIL_FTYPE_MPC, KAIL_FTYPE_OTHER};
typedef enum kail_ftypes kail_ftypes_t;

typedef struct _kail_fattr {
    kail_authID_t uid;
    kail_authID_t gid;
    kail_ftypes_t ftype;
    kail_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    dev_t dev;
    kail_vfs_t check_vfsp;
} kail_fattr_t;




extern volatile struct timespec *kail_xtime;





extern asmlinkage int (*kail_printk)(const char *, ...);
extern asmlinkage int (*kail_sprintf)(char * buf, const char * fmt, ...);
extern asmlinkage int (*kail_do_fork)(unsigned long, unsigned long, struct pt_regs *, unsigned long);


extern asmlinkage int kail_kernel_thread(int (*)(void *), void *,unsigned long);
extern asmlinkage int kail_kill_proc(pid_t, int, int);
extern asmlinkage long kail_strncpy_from_user(char *, const char *, long);
extern asmlinkage long kail_strncpy_from_DND(char *, void *, long);
extern unsigned long FASTCALL(kail_copy_to_user(void *, const void *, unsigned long));
extern unsigned long FASTCALL(kail_copy_from_user(void *, const void *, unsigned long));

extern void FASTCALL(kail_kernel_free(void *,unsigned long));
extern void * FASTCALL(kail_kernel_malloc(unsigned long));





extern asmlinkage void kail_mutex_init(void **);
extern void FASTCALL(kail_mutex_lock(void **));
extern int FASTCALL(kail_mutex_trylock(void **));
extern void FASTCALL(kail_mutex_unlock(void **));
extern asmlinkage void kail_mutex_destroy(void **);

extern asmlinkage void kail_cond_init(void **);
extern void FASTCALL(kail_wake_up(void **));
extern void FASTCALL(kail_cond_wait(void **, void **));
extern int FASTCALL(kail_cond_wait_intr(void **, void **));
extern asmlinkage int kail_condTimedWait(void **, void **, int64_t, int);
extern asmlinkage void kail_cond_destroy(void **);

extern asmlinkage void kail_iclock_init(void **);
extern void FASTCALL(kail_iclock_lock(void **));
extern void FASTCALL(kail_iclock_unlock(void **));
extern int FASTCALL(kail_iclock_trylock(void **));
extern asmlinkage void kail_iclock_destroy(void **);

extern void FASTCALL(kail_iclock_cond_wait(void **,void **));

extern asmlinkage int kail_current_pid(void);
extern asmlinkage int kail_current_tid(void);
extern asmlinkage int kail_current_Ppid(void);
extern int FASTCALL(kail_tid_to_pid(int));

extern pid_t FASTCALL(kail_pid_get_epid(pid_t));
extern void FASTCALL(kail_pid_delete(pid_t));
extern void FASTCALL(kail_epid_delete(pid_t));
extern void FASTCALL(kail_pid_add(pid_t,pid_t));

extern asmlinkage int kail_current_uid(void);
extern asmlinkage int kail_current_euid(void);
extern asmlinkage int kail_current_suid(void);
extern asmlinkage int kail_current_gid(void);
extern asmlinkage int kail_current_egid(void);
extern int FASTCALL(kail_current_files_close_on_exec(int));

extern asmlinkage int kail_socket_protocol(void *);
extern asmlinkage int kail_socket_getname(void *,void *,int *,int);

extern int FASTCALL(kail_fd_to_dev(int, dev_t *));
extern int FASTCALL(kail_fd_to_name(int, char **, int *));
extern int FASTCALL(kail_fd_to_socket(int,void **));

extern int FASTCALL(kail_socket_shutdown(void *));




extern int FASTCALL(kail_check_pid(int));
extern int FASTCALL(kail_get_pid_pgrp(int,int *));
extern int FASTCALL(kail_get_pid_uid(int,int *,int *));
extern void FASTCALL(kail_scan_procs(void *));

extern asmlinkage void kail_daemonize(const char *);
extern asmlinkage int kail_total_ram_mb(void);
extern void FASTCALL(kail_atomic_add(int,void *));

extern asmlinkage int kail_kernel_address_mode(void);






extern asmlinkage int kail_decomposePath(char *, int, kail_rawFid_t *, int *, kail_rawFid_t *, int *, kail_fattr_t *, kail_vnodeH_t *);
extern asmlinkage int kail_LookupFidAndDir(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, int *);
extern asmlinkage int kail_lookupFidsAndInfo(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, kail_vnodeH_t *, kail_vnodeH_t *, int *);
extern asmlinkage int kail_dirFidToPathFids( kail_rawFid_t *, kail_rawFid_t **, int *);
extern asmlinkage int kail_unixDescToRawFid( int , kail_rawFid_t *);
extern asmlinkage int kail_vnodesToFids( kail_vnodeH_t, kail_vnodeH_t, kail_rawFid_t *, kail_rawFid_t *, kail_rawFid_t **, int *, kail_fattr_t *);
extern asmlinkage int kail_makeFidChain(void *, kail_rawFid_t *, int *, const kail_cred_t *, int );




struct kail_register_chrdev_parameters {
        unsigned int dev_number;
        char *name;
        void *ownerp;
        void *readp;
        void *writep;
        void *ioctlp;
        void *openp;
        void *releasep;
        unsigned int ioctl_cnt;
        unsigned int *ioctl_cmds;
} ;

extern asmlinkage int kail_register_chrdev(struct kail_register_chrdev_parameters *, void **);
extern asmlinkage int kail_unregister_chrdev(struct kail_register_chrdev_parameters *, void *);
extern int FASTCALL(kail_minor(void *));

extern asmlinkage int kail_file_read(char *, kail_vnodeH_t *,char *, long, long);
extern asmlinkage void kail_write_log(const char *,const char *, int, int);
extern asmlinkage void kail_log_init(const char *);

extern asmlinkage int kail_pathToFullPath( char *, int , char **, char *,int);
extern void * FASTCALL(kail_unixDescToVnode(int));
extern void FASTCALL(kail_releVnode(void *));
extern void FASTCALL(kail_holdVnode(void *));
extern asmlinkage char * kail_readSymLink(char *, int *);



extern asmlinkage int kail_vfs_mounted(kail_vfs_t *);
extern asmlinkage int kail_vfs_check(kail_vfs_t *);


typedef struct {
        void *alloc;
        void *free;
        void *fcc_find;
        void *fcc_add;
} kail_call_back_t;

extern asmlinkage void kail_call_backs(kail_call_back_t *);
extern asmlinkage void kail_kernel_interface(void);
extern asmlinkage void kail_kernel_interface_shutdown(void);

typedef asmlinkage long (* sys_call_fn)();
struct kail_syscall_prepost {
        int call_index;
        sys_call_fn call_pre;
        sys_call_fn call_post;
};

extern int struct_cppath_size;

extern asmlinkage int kail_trap_syscalls(struct kail_syscall_prepost *);



extern asmlinkage void kail_restore_syscalls(void);

struct nameidata;
struct kail_datanameidata {
        char cdata[4];
        char *path;
        struct nameidata *nd;
};
#define KAIL_LOOKUP_BIT 0x40000000
#ifdef LINUX_RHEL4
#define SET_LOOKUP_FLAG(n) (n)->intent.open.flags = KAIL_LOOKUP_BIT;
#define CLEAR_LOOKUP_FLAG(n) (n)->intent.open.flags &= ~KAIL_LOOKUP_BIT;
#define CHECK_LOOKUP_FLAG(n) ((n)->intent.open.flags == KAIL_LOOKUP_BIT)
#endif 
#ifdef LINUX_SLES9
#define SET_LOOKUP_FLAG(n)
#define CLEAR_LOOKUP_FLAG(n)
#define CHECK_LOOKUP_FLAG(n)
#endif 
typedef unsigned char byte_t;





typedef int64_t oss_uid_t;
typedef int64_t oss_gid_t;
typedef struct {
    int ipV6:1;
    int ipV6V4Mapped:1;
    int ipV6V4Compat:1;
    union {
        uint32_t a32[4];
        uint16_t a16[8];
        uint8_t a8[16];
        struct {
            uint32_t pad[3];
            uint32_t addr;
        } addrClassic;
    } addr;
} oss_nwIP_t;





typedef struct {
    uint16_t protocol;
    uint16_t port;
} oss_nwService_t;

typedef struct {
    oss_nwIP_t ip;
    oss_nwService_t service;
} oss_nwAddr_t;

typedef struct {
    uint32_t count;
    oss_nwIP_t* ip;
} oss_nwIPList_t;

typedef struct {
    uint32_t count;
    char** name;
} oss_nwNameList_t;
typedef pid_t tid_t;



typedef pid_t pal_pid_t;
typedef tid_t pal_tid_t;




typedef unsigned long pal_scall_parm_t;


typedef void * pal_caller_t;



typedef kail_fmode_t pal_fmode_t;
typedef kail_dev_t pal_dev_t;
typedef kail_vnodeH_t pal_vnodeH_t;
typedef kail_vfs_t pal_vfs_val_t;



typedef kail_fsid_t pal_fsid_t;
typedef kail_fid_t pal_fid_t;
typedef kail_cred_t cred_t;

static inline int pal_pinMem(void *mem, size_t size)
{ return 0; }

static inline int pal_unpinMem(void *mem, size_t size)
{ return 0; }
static inline int pal_copyin(char *uaddr, char *kaddr, size_t count)
{
    return (int)kail_copy_from_user(kaddr, uaddr, count);
}
static inline int pal_copyout(char *kaddr, char *uaddr, size_t count)
{
    return (int)kail_copy_to_user(uaddr, kaddr, count);
}
static inline int
pal_copyinstr(char *uaddr, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_user(kaddr, uaddr, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int
pal_copyinstr_LSM(void *dnd, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_DND(kaddr, dnd, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int pal_suser(void)
{
    return (kail_current_euid() == 0);
}
static inline int
pal_unixDescIsCOE(int fd)
{
        return kail_current_files_close_on_exec(fd);
}
static inline void
pal_releVnode(pal_vnodeH_t vnh)
{
    ;
    kail_releVnode((void *)vnh);
}
static inline void
pal_holdVnode(pal_vnodeH_t vnh)
{
    ;
    kail_holdVnode((void *)vnh);
}





typedef void * pal_mutex_t;
typedef void * pal_cond_t;
typedef void * pal_icLock_t;
static inline int
pal_file_read(char *path, pal_vnodeH_t vnodeH, char *buffer, long offset, long len)
{
        return kail_file_read(path,vnodeH,buffer,offset,len);
}
extern char *pal_immunePrograms[];

extern char *pal_loginPrograms[];






extern void pal_machInit(void);
extern void pal_machShutdown(void);
extern int pal_mapOpenFlags(int);
extern void pal_fccInit(void);
extern void pal_fccShutdown(void);
extern void pal_fccFlush(void);
extern int pal_checkLoginBypassMach(char *, int, void *,void *, int32_t *);

extern void pal_errLogInit(void);
typedef oss_nwAddr_t pal_nwAddr_t;







typedef struct _pal_time {
    uint32_t secs;
    int32_t usecs;
} pal_timestruct_t;




typedef int64_t pal_time_t;
typedef oss_uid_t pal_uid_t;
typedef oss_gid_t pal_gid_t;

typedef pal_uid_t pal_authID_t;


typedef uint32_t pal_ptr32_t;
typedef struct _ids {
    pal_authID_t idVal;
    int setMask;
} pal_idSet_t;
typedef struct _idlist {
    pal_authID_t realId;
    pal_authID_t effId;
    pal_authID_t accId;


} pal_idList_t;
enum pal_ftypes { PAL_FTYPE_NONE, PAL_FTYPE_FILE, PAL_FTYPE_DIR,
             PAL_FTYPE_BLKDEV, PAL_FTYPE_CHARDEV, PAL_FTYPE_LNK,
             PAL_FTYPE_SOCK, PAL_FTYPE_BAD, PAL_FTYPE_FIFO,
             PAL_FTYPE_MPC, PAL_FTYPE_OTHER};
typedef enum pal_ftypes pal_ftypes_t;
typedef struct _fattr {
    pal_authID_t uid;
    pal_authID_t gid;
    pal_ftypes_t ftype;
    pal_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    pal_dev_t dev;
    pal_vfs_val_t check_vfsp;
} pal_fattr_t;
typedef struct _rfid {
    uint32_t ctime;
    pal_fsid_t fsid;
    pal_fid_t fid;
} pal_rawFid_t;
typedef struct pal_ph {
    char *path;
    char *pbuf;
    int pathLen;
    int pbLen;
    int flags;
} pal_pathBuf_t;
extern int pal_sysMemMB;
typedef char * pal_pathMemInfo_t;
extern char *pal_readSymLink(char *, int *);





extern void pal_delay(int);
extern int pal_kthreadCreate(void (*)(), void *, char *);
extern pal_authID_t pal_getEGid(void);







extern void pal_logErrMach(char *, int);
typedef char * sharedMemPtr_t;
extern char *pal_alloc(size_t);
extern void pal_free(void *, size_t);



extern void pal_getAllocInfo(int *, size_t *);
extern void pal_logErr(int, char *);
extern int pal_copyin(char *, char *, size_t);
extern int pal_copyinstr(char *, char *, size_t, size_t *);
extern int pal_copyout(char *, char *, size_t);
extern int pal_decomposePath(char *, int, pal_rawFid_t *, int *,
                        pal_rawFid_t *, int *, pal_fattr_t *, pal_vnodeH_t *);
extern int pal_LookupFidAndDir(char *, int, pal_rawFid_t *,
                               pal_rawFid_t *, pal_fattr_t *, int *);
extern int pal_vnodesToFids(pal_vnodeH_t, pal_vnodeH_t,
                            pal_rawFid_t *, pal_rawFid_t *, pal_rawFid_t **,
                            int *, pal_fattr_t *);
extern int pal_pathToFullPath(char *, int, pal_pathBuf_t *);
extern int pal_dirFidToPathFids(pal_rawFid_t *, pal_rawFid_t **, int *);
extern int pal_unixDescToRawFid(int, pal_rawFid_t *);
extern pal_vnodeH_t pal_unixDescToVnode(int);
extern int pal_unixDescToBaseName(int, pal_vnodeH_t, pal_pathBuf_t *);
extern int pal_unixDescIsCOE(int);



extern int pal_suser(void);
extern pal_authID_t pal_getEuid(void);
extern void pal_getREUids(pal_idList_t *);
extern void pal_holdVnode(pal_vnodeH_t);
extern void pal_releVnode(pal_vnodeH_t);
extern int pal_pinMem(void *, size_t);
extern int pal_unpinMem(void *, size_t);
extern int pal_getLocalTermDevice(char *, int, pal_dev_t *);
int pal_checkInheritLoginState(char *, uint32_t, int32_t, int32_t *);
int pal_execChecking(char *, int32_t *, uint32_t *, uint32_t *);
void pal_loginOriginWasReset(int32_t *);
extern int pal_checkLoginBypass(char *, int,
                                pal_idSet_t *, pal_idList_t *, int32_t *);
extern int32_t pal_devToInt32(pal_dev_t);
extern int pal_isImmunePath(char *);
extern int pal_expandExecArgs(void *, char *, int, int);


extern int pal_lookupFidsAndInfo(char *, int, pal_rawFid_t *,
        pal_rawFid_t *, pal_fattr_t *, pal_vnodeH_t *, pal_vnodeH_t *, int *);
extern int pal_pathFidsFromDirVnh(pal_vnodeH_t, pal_rawFid_t *, int *);
extern int pal_file_read(char *,pal_vnodeH_t,char *, long, long);





extern void pal_init(void);
extern void pal_shutdown(void);
extern uint32_t kutil_kossInitTime;

extern void kutil_freeStringWithLocal(char *, char *, int);
extern int kutil_setStringWithLocal(char *, int *, char *, int, char **);
extern char *kutil_prefixString(char *, int, char *, int *, int);

extern void kutil_pathBaseName(char *);
extern char * kutil_pathExtractBaseName(char *);
extern void kutil_pathToDotPath(char *, int);

extern char* kutil_pathToDotPathAndLeaf(char *, int);

extern void kutil_pathToDotDotPath(char *, int);
extern int kutil_pathCleanupTail(char *, int *);
extern int kutil_commonInit(void);
extern int kutil_commonShutdown(void);




extern void kutil_privInit(void);
extern void kutil_privShutdown(void);
extern int kutil_privCheck(int, pal_authID_t);
extern int kutil_isPrivUid(pal_authID_t);
typedef struct kutil_q {
    struct kutil_q *next;
    struct kutil_q *prev;
} kutil_q_t, kutil_qHead_t;
typedef void *kt_chanID_t;

typedef struct _kt_chan {
    uint32_t active;
    pal_mutex_t lock;
    char name[40];
} kt_channel_t;
extern kt_channel_t kt_defChannels[];

extern void kt_logString(int, char *);
extern void kt_Event0(kt_chanID_t, int, unsigned int);
extern void kt_Event1(kt_chanID_t, int, unsigned int, long);
extern void kt_Event2(kt_chanID_t, int, unsigned int, long, long);
extern void kt_Event3(kt_chanID_t, int, unsigned int, long, long, long);
extern void kt_Event4(kt_chanID_t, int, unsigned int, long, long, long, long);
extern void kt_Event5(kt_chanID_t, int, unsigned int,
                      long, long, long, long, long);
extern void kt_zeroLog(void);
extern void kt_setChannelActive(char *, int);
extern void kt_intError(int, int, int, int);
extern void kt_init(void);
extern void kt_shutdown(void);
enum kt_msgs {
    KT_TRACE_DUMMY = 1024,
    KT_TRACE_STR,
    KT_TRACE_INT,
    KT_TRACE_LKUPNAME,
    KT_TRACE_PROCESS_PATH,
    KT_TRACE_NOFID,
    KT_TRACE_TRACK_OPEN,
    KT_TRACE_KAZN_PATH_ACCESS,
    KT_TRACE_KAZN_PATH_ACCESS_RTN,
    KT_TRACE_KPC_NOTIFY,
    KT_TRACE_KPC_NOTIFY_RTN,
    KT_TRACE_KPC_GETATTR,
    KT_TRACE_KPC_GETATTR_RTN,
    KT_TRACE_KPC_SETVERSION,
    KT_TRACE_KPC_SETVERSION_RTN,
    KT_TRACE_KPC_SETEPOCH,
    KT_TRACE_KPC_SETEPOCH_RTN,
    KT_TRACE_KOSS_SYSCALL,
    KT_TRACE_KOSS_SYSCALL_RTN,
    KT_TRACE_KOSS_REGISTER,
    KT_TRACE_KOSS_REGISTER_RTN,
    KT_TRACE_KOSS_SET_PRIVID,
    KT_TRACE_KOSS_SET_PRIVPID,
    KT_TRACE_KOSS_ALLOC_FAIL,
    KT_TRACE_KOSS_INT_ERR,
    KT_TRACE_KAUD_SETLEVEL,
    KT_TRACE_KAUD_SETLEVEL_RTN,
    KT_TRACE_KAUD_AUD_SERVICE,
    KT_TRACE_KAUD_AUD_SERVICE_RTN,
    KT_TRACE_CSC_SETGROUPS,
    KT_TRACE_KOSS_PRIVCHECK,
    KT_TRACE_KOSS_PRIVCHECK_IDS,
    KT_TRACE_KOSS_PRIVCHECK_RTN,
    KT_TRACE_CSC_SUID,
    KT_TRACE_CSC_SUID2,
    KT_TRACE_CSC_SGID,
    KT_TRACE_CSC_SUID_BYPASS,
    KT_TRACE_CSC_SGID_BYPASS,
    KT_TRACE_KOSS_SET_ACTIVE,
    KT_TRACE_KOSS_SET_INACTIVE,
    KT_TRACE_KOSS_SET_STATE,
    KT_TRACE_NCT_OCREAT_CK_LINK_TGT,
    KT_TRACE_CSC_LOGIN_DIRECT_BP,
    KT_TRACE_KUTIL_GET_LOGIN_DATA,
    KT_TRACE_KUTIL_GET_LOGIN_DATA_EXIT,
    KT_TRACE_KAUD_LOG_USER_EVENT,
    KT_TRACE_KAUD_LOG_USER_EVENT_EXIT,
    KT_TRACE_KAUD_TRACE_EVENT,
    KT_TRACE_KAUD_TRACE_EVENT_EXIT,
    KT_TRACE_KAUD_LOGOUT_NOTERM,
    KT_TRACE_KAUD_LOGOUT_LOCTERM,
    KT_TRACE_KAUD_LOGOUT_REMTERM,
    KT_TRACE_KAUD_LOGOUT_EXIT,
    KT_TRACE_KAUD_TRACE_PID_EXEMPT,
    KT_TRACE_KAUD_TRACE_UID_EXEMPT,
    KT_TRACE_KOSS_INIT_PROC_RGY,
    KT_TRACE_KOSS_ASYNC_LU_START,
    KT_TRACE_KOSS_ASYNC_LU_STOP,
    KT_TRACE_KOSS_ASYNC_LU_TIMEOUT,
    KT_TRACE_KOSS_ASYNC_LU_STATE,
    KT_TRACE_KPCF_TRIG_REF,
    KT_TRACE_KPCF_SCAN_TIME,
    KT_TRACE_SHMEM_REINIT,
    KT_TRACE_SHMEM_REINITERR,
    KT_TRACE_SHMEM_INIT,
    KT_TRACE_SHMEM_FINI_ENT,
    KT_TRACE_SHMEM_FINI_WAITUSED,
    KT_TRACE_SHMEM_FINI_FAILUSED,
    KT_TRACE_SHMEM_FINI_FAILWAITERS,
    KT_TRACE_SHMEM_SRVT_START,
    KT_TRACE_SHMEM_SRVT_INVNODE,
    KT_TRACE_SHMEM_SRVT_ERRCOPY,
    KT_TRACE_SHMEM_SRVT_STOP,
    KT_TRACE_SHMEM_SRVT_WAIT,
    KT_TRACE_SHMEM_SRVT_WAITERR,
    KT_TRACE_SHMEM_STOP,
    KT_TRACE_GETMEM_NONE,
    KT_TRACE_SHBANG_TOOBIG,
    KT_TRACE_SHBANG_CHECK_READ,
    KT_TRACE_SHMEM_HELPER_START,
    KT_TRACE_SHMEM_HELPER_RESTART,
    KT_TRACE_SHMEM_HELPER_RETURN,
    KT_TRACE_SHMEM_CHECK_FAIL,
    KT_TRACE_SHMEM_NODE_RECLAIM,
    KT_TRACE_FDPATH_FAILURE,
    KT_TRACE_SHMEM_OLDPOOL_DEC
};
enum kt_kazn_msgs {
    KT_TRACE_KAZN_DUMMY = 2048,
    KT_TRACE_KAZN_ACC_ALLOWED_FI,
    KT_TRACE_KAZN_ACC_ALLOWED_ID,
    KT_TRACE_KAZN_ACC_ALLOWED_NW,
    KT_TRACE_KAZN_CFR,
    KT_TRACE_KAZN_CFR_HIT,
    KT_TRACE_KAZN_CFR_MISS,
    KT_TRACE_KAZN_KPCF_ADD,
    KT_TRACE_KAZN_KPCF_UPDATE,
    KT_TRACE_KAZN_KPCF_DEL,
    KT_TRACE_KPCF_DINS,
    KT_TRACE_KPCF_REFRES,
    KT_TRACE_KPCF_REFRES_RTN,
    KT_TRACE_KPCF_REF_FR,
    KT_TRACE_KPCF_NCADD,
    KT_TRACE_KPCF_NCHIT,
    KT_TRACE_KPCF_NCFLUSH,
    KT_TRACE_KPCF_DIR_NOTIFY,
    KT_TRACE_KPCF_EPOCH_DEL,
    KT_TRACE_KPCF_HIT_WC,
    KT_TRACE_KAZN_LOGIN_SUSKIP,
    KT_TRACE_KAZN_SECPGM_SUSKIP,
    KT_TRACE_KAZN_PRIVPGM_PERMIT,
    KT_TRACE_KPCF_HIT_LOCALTERM,
    KT_TRACE_KAZN_ACC_ALLOWED_EFLAGS,
    KT_TRACE_KAZN_RES_NOAZN,
    KT_TRACE_KPCF_KPCI_ADD_PO,
    KT_TRACE_KAZN_CHECKACCESS,
    KT_TRACE_KAZN_CHECKACCESS_GRANT,
    KT_TRACE_KAZN_CHECKACCESS_DENY,
    KT_TRACE_KAZN_CHECKACCESS_DENY_MORE,
    KT_TRACE_KPCF_REFRESH_NOTIFY,
    KT_TRACE_KPCF_CHECKPATH,
    KT_TRACE_KPCF_CKPATH_RTN,
    KT_TRACE_KPCF_CKPATH_FAST_RTN,
    KT_TRACE_KPCF_REF_DHASH,
    KT_TRACE_KPCF_REF_DHASH_RTN,
    KT_TRACE_RCF_ADD_GRANT,
    KT_TRACE_RCF_ADD_GRANT_RES,
    KT_TRACE_RCF_CHECK,
    KT_TRACE_RCF_CHECK_GRANT,
    KT_TRACE_RCF_CHECK_NOGRANT,
    KT_TRACE_RCF_FLUSH,
    KT_TRACE_RCF_COND_INFO,
    KT_TRACE_KAZN_DAEMON_EBUSY,
    KT_TRACE_KPCF_BKG_SLEEP,
    KT_TRACE_KPCF_BKG_RUN,
    KT_TRACE_KPCF_EPOCH_NOT,
    KT_TRACE_KPCF_EPOCH_NOT_COMMIT,
    KT_TRACE_KAZN_RES_NOTIFY,
    KT_TRACE_KPC_GET_NEWEPOCH,
    KT_TRACE_KPC_COMMIT_EPOCH,
    KT_TRACE_CSC_OPEN,
    KT_TRACE_CSC_KILL_ERR,
    KT_TRACE_KPCF_GENFID_ERR,
    KT_TRACE_KPCF_NOFID_REFRESH,
    KT_TRACE_KPCF_ADD_IMMUNE,
    KT_TRACE_KPCF_UPDATE_IMMUNE,
    KT_TRACE_KAZN_ERR_GRANT,
    KT_TRACE_KAZN_FIND_PGM_KPON,
    KT_TRACE_KAZN_FIND_PGM_KPON_FOUND,
    KT_TRACE_KAZN_FIND_PGM_KPON_NONE,
    KT_TRACE_KAZN_FIND_PGM_KPON_AMBIG,
    KT_TRACE_KAZN_KPC_QFILE,
    KT_TRACE_KAZN_KPC_QFILE_RTN,
    KT_TRACE_KAZN_KPC_QPGM,
    KT_TRACE_KAZN_KPC_QPGM_RTN,
    KT_TRACE_KAZN_KPC_DHASHFID_EXIT,
    KT_TRACE_KAZN_KPC_DHASHNAME_EXIT,
    KT_TRACE_KAZN_KPC_CREATE_NOTIFY,
    KT_TRACE_RCID_ADD_GRANT,
    KT_TRACE_RCID_ADD_GRANT_RES,
    KT_TRACE_RCID_CHECK,
    KT_TRACE_RCID_CHECK_GRANT,
    KT_TRACE_RCID_CHECK_NOGRANT,
    KT_TRACE_RCID_FLUSH,
    KT_TRACE_KAZN_AZNCALL_REMAP_TO,
    KT_TRACE_KPCF_EXCEPTION_ADD,
    KT_TRACE_KAZN_AZND_TOUT,
    KT_TRACE_KAZN_EXPAND_PATH,
    KT_TRACE_KAZN_EXPAND_PATH_ERR,
    KT_TRACE_KAZN_EXPAND_PATH_SKIP,
    KT_TRACE_KAZN_UFILE_HIT,
    KT_TRACE_KAZN_UFILE_ADD,
    KT_TRACE_KAZN_UFILE_MISS,
    KT_TRACE_KAZN_UFILE_FLUSH,
    KT_TRACE_KPCF_REF_DH_BYFID,
    KT_TRACE_KPCF_REF_DH_BYFID_END,
    KT_TRACE_EXEC_SETUSER,
    KT_TRACE_EXEC_SETGROUP,
    KT_TRACE_KAZN_CHECK_FID_ONLY,
    KT_TRACE_KAZN_EXEMPT_PID_PERMIT,
    KT_TRACE_KAZN_PFC_HIT,
    KT_TRACE_KAZN_PFC_ADD,
    KT_TRACE_KAZN_PFC_MISS,
    KT_TRACE_KAZN_PFC_FLUSH,
    KT_TRACE_KAZN_PFC_FLUSHBYRES,
    KT_TRACE_KAZN_PFC_PROTRES_RELE,
    KT_TRACE_KAZN_ACC_ALLOWED_PERMIT,
    KT_TRACE_KAZN_ACC_ALLOWED_DENY,

    KT_TRACE_KAZN_AUTOFS_NOREF,

    KT_TRACE_KAZN_NW_ADDR_BADFAM,
    KT_TRACE_KAZN_RES_TRY_AGAIN,
    KT_TRACE_KAZN_KPC_QNW,
    KT_TRACE_KAZN_KPC_QNW_RTN,
    KT_TRACE_KAZN_IMSURPGM_SUSKIP,
    KT_TRACE_KAZN_USER_AUDIT_LOGOUT,
    KT_TRACE_KAZN_ALWAYS_SET_KPON,
    KT_TRACE_KAZN_FILTER_RES,
    KT_TRACE_KAZN_KPCFT_DELAY,
    KT_TRACE_KAZN_IPV6_ADDR,
    KT_TRACE_KAZN_DHANAL_FRL_CLR,
    KT_TRACE_KAZN_SET_ALIAS,
    KT_TRACE_KAZN_HAS_ALIAS,
    KT_TRACE_KAZN_RES_WAIT,
    KT_TRACE_KAZN_RES_REFD,
    KT_TRACE_KAZN_RES_BROADCAST,
    KT_TRACE_KAZN_DHASH_REF_LOOP,
    KT_TRACE_KAZN_USE_COPY,
    KT_TRACE_KAZN_NO_COPY,
    KT_TRACE_KAZN_DENY_SHMCTL_OP,
    KT_TRACE_KAZN_DHASH_SEARCH_STALE
};







enum kt_kmsg_msgs {
    KT_TRACE_KMSG_DUMMY = 3072,
    KT_TRACE_KMSG_INIT,
    KT_TRACE_KMSG_FINISH,
    KT_TRACE_KMSG_OPEN,
    KT_TRACE_KMSG_CLOSE,
    KT_TRACE_KMSG_IOCTL,
    KT_TRACE_KMSG_READ_ENTRY,
    KT_TRACE_KMSG_READ_EXIT,
    KT_TRACE_KMSG_READ_WAIT,
    KT_TRACE_KMSG_READ_WORK,
    KT_TRACE_KMSG_WRITE_ENTRY,
    KT_TRACE_KMSG_WRITE_EXIT,
    KT_TRACE_KMSG_WRITE_ID,
    KT_TRACE_KMSG_WRITE_LEN,
    KT_TRACE_KMSG_SEND_REQ,
    KT_TRACE_KMSG_GET_RESP,
    KT_TRACE_KMSG_RECV_RESP,
    KT_TRACE_KMSG_GET_HAND,
    KT_TRACE_KMSG_FREE_HAND,
    KT_TRACE_KMSG_WAIT_MSG,

    KT_TRACE_KMSG_BADTRANID,
    KT_TRACE_KMSG_BADSIZE,
    KT_TRACE_KMSG_TOOBIG,
    KT_TRACE_KMSG_CHANCLOSED,
    KT_TRACE_KMSG_ERR_GET_HAND,
    KT_TRACE_KMSG_GET_RESP_ERR,
    KT_TRACE_KMSG_CHAN_DOWN,
    KT_TRACE_KMSG_CHAN_RETRY,
    KT_TRACE_KMSG_WAIT_TO,
    KT_TRACE_KMSG_HARD_TO,
    KT_TRACE_KMSG_TO_RETRY,
    KT_TRACE_KMSG_DOWN_TO_TOUT
};







enum kt_kenv_msgs {
    KT_TRACE_KENV_DUMMY = 4096,
    KT_TRACE_KENV_NEW_PROC_INFO,
    KT_TRACE_KENV_PR_ADD_FD,
    KT_TRACE_KENV_PR_CLOSE_FD,
    KT_TRACE_KENV_PR_RET_FDINFO,
    KT_TRACE_KENV_PR_GROW_FDTABLE,
    KT_TRACE_KENV_PR_ADD_FLAGS,
    KT_TRACE_KENV_PR_DEL_FLAGS,
    KT_TRACE_KENV_PR_SET_IMP_ID,
    KT_TRACE_KENV_E_NW_TERM,
    KT_TRACE_KENV_E_DEV_TERM,
    KT_TRACE_KENV_E_NO_TERM,
    KT_TRACE_KENV_PR_ADD_FLAGS_BNAME,
    KT_TRACE_KENV_PTP_E2BIG,
    KT_TRACE_KENV_PTP_E2BIG_RETRY,
    KT_TRACE_KENV_PR_GET_TRUE_ACCID,
    KT_TRACE_KENV_PR_SET_ACC_ID,
    KT_TRACE_KENV_PR_ADD_NO_FORK,
    KT_TRACE_KENV_PR_ADD_REMT_TERM,
    KT_TRACE_KENV_PR_GET_REMT_TERM,
    KT_TRACE_KENV_BUMP_STREAM_COUNT,
    KT_TRACE_KENV_DELAY_PROC_DEL,
    KT_TRACE_KENV_PROC_INFO_NOTPAR,
    KT_TRACE_KENV_E_NW_TERM_IPV6,
    KT_TRACE_KENV_IPV6_ADDR,
    KT_TRACE_KENV_PR_NOSET_REMT,
    KT_TRACE_KENV_SHMEM_TOOBIG,
    KT_TRACE_KENV_SHMEM_WAIT,
    KT_TRACE_KENV_SHMEM_STOPPED,
    KT_TRACE_KENV_SHMEM_NOFREE,
    KT_TRACE_KENV_SHMEM_INVNODE,
    KT_TRACE_KENV_SHMEM_RQWAIT,
    KT_TRACE_KENV_SHMEM_RQDONE,
    KT_TRACE_KENV_SHMEM_PUTERR,
    KT_TRACE_KENV_SHMEM_PUT,
    KT_TRACE_KENV_GETMEM_REL,
    KT_TRACE_KENV_GETMEM_NEVER,
    KT_TRACE_KENV_GETMEM_OK,
    KT_TRACE_KENV_GETMEM_OFF,
    KT_TRACE_KENV_GETMEM_ERR,
    KT_TRACE_KENV_PUTMEM,
    KT_TRACE_KENV_SHMAT_RESET,
    KT_TRACE_KENV_SHMREQ_SCAN_DELAY,
    KT_TRACE_KENV_SHMREQ_SCAN_NOW,
    KT_TRACE_KENV_SHMREQ_REC_NOPID,
    KT_TRACE_KENV_SHMREQ_REC_EXP,
    KT_TRACE_KENV_SHMREQ_SCAN_RET,
    KT_TRACE_KENV_SHMEM_RESET_EXEC,
    KT_TRACE_KENV_PROC_FORK_CHILD,
    KT_TRACE_KENV_PROC_FORK_PAR,
    KT_TRACE_KENV_PROC_ALREADY,
    KT_TRACE_KENV_PROC_CONDADD,
    KT_TRACE_KENV_PROC_EXISTS,
    KT_TRACE_KENV_PR_ADD_NO_PAR,
    KT_TRACE_KENV_PROC_ADD,
    KT_TRACE_KENV_PROC_ADD_PPID,
    KT_TRACE_KENV_PROC_TERM,
    KT_TRACE_KENV_PROC_USE_DEAD
};







enum kt_dbg_msgs {
    KT_TRACE_DBG_DUMMY = 8192,
    KT_TRACE_DBG_NCT_Q_AREQ,
    KT_TRACE_DBG_NCT_START_AREQ,
    KT_TRACE_DBG_NCT_END_AREQ,
    KT_TRACE_DBG_PAL_NO_FID,
    KT_TRACE_DBG_PAL_LKUP_ERR,
    KT_TRACE_DBG_PAL_DCOMP_ERR,
    KT_TRACE_DBG_PAL_LU_FID_DIR,
    KT_TRACE_DBG_TLI_SVC_PRIM_PEND,
    KT_TRACE_DBG_TLI_SVC_PRIM_NOPEND,
    KT_TRACE_DBG_NCT_PATH_OP_RESULT,
    KT_TRACE_DBG_NCT_FD_OP_RESULT,
    KT_TRACE_DBG_NCT_KILL_COMMON,
    KT_TRACE_DBG_NCT_KILL_TRAP,
    KT_TRACE_DBG_NCT_KILL_FILTER_PGRP,
    KT_TRACE_DBG_NCT_KILL_FILTER_USER,

    KT_TRACE_DBG_PAL_FILE_COUNT,
    KT_TRACE_DBG_PAL_FILE_LOOKUP22,
    KT_TRACE_DBG_PAL_FILE_LOOKUP24,

    KT_TRACE_DBG_KAZN_AUTOFS_NOVFSP,
    KT_TRACE_DBG_RFID_FL_VFSP,
    KT_TRACE_DBG_AUTO_FS_MOUNTED,
    KT_TRACE_DBG_DEFER_UMOUNT,
    KT_TRACE_DBG_CHECK_VFS_MOUNTED,
    KT_TRACE_DBG_MOUNTED_YES,
    KT_TRACE_DBG_MOUNTED_NO,
    KT_TRACE_DBG_VFS_DATA_SET,
    KT_TRACE_DBG_FURTHER_LKUP_REQ,
    KT_TRACE_DBG_NEXT_LOOKUP,
    KT_TRACE_DBG_GEN_RES_FIDS,
    KT_TRACE_DBG_CHECK_FID_PATH,

    KT_TRACE_DBG_RESET_VFS_DATA,
    KT_TRACE_DBG_FAILED_VFS_SEARCH,
    KT_TRACE_DBG_ASYNC_LU_START,
    KT_TRACE_DBG_DEFER_UNAVAIL,
    KT_TRACE_DBG_REFRESH_FSID_EQ,
    KT_TRACE_DBG_REFRESH_FSID_NOFID,
    KT_TRACE_DBG_REFRESH_EPOCH,

    KT_TRACE_DBG_KPCF_ADD_RES,
    KT_TRACE_DBG_KPCF_AZN_FLAGS,
    KT_TRACE_DBG_NCT_FORK_TRAP,
    KT_TRACE_DBG_EXIT_CHECK_LEAF,

    KT_TRACE_DBG_SHMEM_SRVT_WAIT,
    KT_TRACE_DBG_SHMEM_SRVT_PROC,
    KT_TRACE_DBG_SHMEM_SRVT_RECLAIM,
    KT_TRACE_DBG_SHBANG_EXEC,
    KT_TRACE_DBG_SHMEM_HELPER_CHECK,
    KT_TRACE_DBG_FDPATH_BUILT,
    KT_TRACE_DBG_BYPASS_ENTRY1,
    KT_TRACE_DBG_BYPASS_ENTRY2,
    KT_TRACE_DBG_BYPASS_EXIT
};
enum kt_ffdc_msgs {
    KT_TRACE_FFDC_DUMMY = 5120,
    KT_TRACE_FFDC_STR,
    KT_TRACE_FFDC_AZNCALL_FILE,
    KT_TRACE_FFDC_AZNCALL_IDSET,
    KT_TRACE_FFDC_AZNCALL_NWOUT,
    KT_TRACE_FFDC_AZNCALL_NWIN,
    KT_TRACE_FFDC_AZNCALL_RACC_ADDR,
    KT_TRACE_FFDC_AZNCALL_CONT,
    KT_TRACE_FFDC_AZNCALL_RES_PERMIT,
    KT_TRACE_FFDC_AZNCALL_RES_DENY,
    KT_TRACE_FFDC_ERR_GRANT,
    KT_TRACE_FFDC_AZNCALL_SLOW,
    KT_TRACE_FFDC_CSC_LOGIN,
    KT_TRACE_FFDC_CKLOGIN,
    KT_TRACE_FFDC_CKLOGIN_EXIT,
    KT_TRACE_FFDC_CKLOGIN_DOAZN,
    KT_TRACE_FFDC_EXEC_PGM,
    KT_TRACE_FFDC_EXEC_PGM_LINK,
    KT_TRACE_FFDC_EXEC_SUPGM,
    KT_TRACE_FFDC_EXEC_SGPGM,
    KT_TRACE_FFDC_EXEC_SUGPGM,
    KT_TRACE_FFDC_EXEC_DENIED,
    KT_TRACE_FFDC_EXEC_ALLOWED,
    KT_TRACE_FFDC_LOGOUT_LOC,
    KT_TRACE_FFDC_LOGOUT_REM,
    KT_TRACE_FFDC_PROC_ADD,
    KT_TRACE_FFDC_PROC_ADD_PPID,
    KT_TRACE_FFDC_PROC_TERM,
    KT_TRACE_FFDC_NPC_FREE,
    KT_TRACE_FFDC_HOST_RULE_BAD,
    KT_TRACE_FFDC_CSC_V6TERM,
    KT_TRACE_FFDC_IPV6_ADDR
};




enum kt_knpc_msgs {
    KT_TRACE_KNPC_DUMMY = 6144,
    KT_TRACE_KNPC_STR,
    KT_TRACE_KNPC_SEARCH_SERVICE,
    KT_TRACE_KNPC_SEARCH_HOSTIP,
    KT_TRACE_KNPC_SEARCH_HOSTNAME,
    KT_TRACE_KNPC_SEARCH_PROTOCOL,
    KT_TRACE_KNPC_NET_UPD_ENTRY,
    KT_TRACE_KNPC_NET_UPD_ENTRY2,
    KT_TRACE_KNPC_KPCRES_ATTACH,
    KT_TRACE_KNPC_NET_ALREADY,
    KT_TRACE_KNPC_NETIN_ADD_NODE,
    KT_TRACE_KNPC_NETIN_DEL_ERR,
    KT_TRACE_KNPC_NETIN_DEL,
    KT_TRACE_KNPC_NETOUT_ADD_NODE,
    KT_TRACE_KNPC_NETOUT_DEL_ERR,
    KT_TRACE_KNPC_NETOUT_DEL,
    KT_TRACE_KNPC_NETIN_MATCH,
    KT_TRACE_KNPC_NETOUT_MATCH,
    KT_TRACE_KNPC_DUMP_HEADER,
    KT_TRACE_KNPC_DUMP_ELEM,
    KT_TRACE_KNPC_CUR_INIT,
    KT_TRACE_KNPC_CUR_FINI,
    KT_TRACE_KNPC_CHECK_RES,

    KT_TRACE_KNPCD_SERV_NODE_ALLOC,
    KT_TRACE_KNPCD_SERV_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_SERV_NODE_FREE,
    KT_TRACE_KNPCD_HOSTIP_NODE_ALLOC,
    KT_TRACE_KNPCD_HOST_NODE_ALLOC,
    KT_TRACE_KNPCD_HOST_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_HOSTIP_NODE_FREE,
    KT_TRACE_KNPCD_HOST_NODE_FREE,
    KT_TRACE_KNPCD_PROT_NODE_ALLOC,
    KT_TRACE_KNPCD_PROT_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_PROT_NODE_FREE,
    KT_TRACE_KNPCD_MATCH_SERVICE,
    KT_TRACE_KNPCD_MATCH_HOSTIP,
    KT_TRACE_KNPCD_MATCH_PROTOCOL,
    KT_TRACE_KNPCD_KPON_FREE,
    KT_TRACE_KNPCD_WAIT_LOCK,
    KT_TRACE_KNPCD_SEARCH_SERV_ENTRY,
    KT_TRACE_KNPCD_SEARCH_NODE_CMP,
    KT_TRACE_KNPCD_FREE_NODE_REF,
    KT_TRACE_KNPCD_MATCH_HOSTNAME,
    KT_TRACE_KNPC_NETIN_SETRES,
    KT_TRACE_KNPC_NETOUT_SETRES,
    KT_TRACE_KNPC_ENV_SETRES,
    KT_TRACE_KNPCD_HOSTIPV6_NODE_ALLOC,
    KT_TRACE_KNPCD_HOSTIPV6_ADDR,
    KT_TRACE_KNPCD_HOSTIPV6_MASK,
    KT_TRACE_KNPCD_HOSTIPV6_NODE_FREE,
    KT_TRACE_KNPCD_HOSTIPV6_HIT_V4,
    KT_TRACE_KNPCD_HOSTIPV6_CMP,
    KT_TRACE_KNPC_SEARCH_HOSTIPV6,
    KT_TRACE_KNPCD_SEARCH_HOSTIPV6_QELEM,
    KT_TRACE_KNPCD_MATCH_HOSTIPV6,
    KT_TRACE_KNPC_BRANCH_CHANGE
};



enum kt_knrc_msgs {
    KT_TRACE_KNRC_DUMMY = 7168,
    KT_TRACE_KNRC_STR,
    KT_TRACE_KNRC_INIT_ERR,
    KT_TRACE_KNRC_INIT_CACHE,
    KT_TRACE_KNRC_FINI_FREE,
    KT_TRACE_KNRC_CHECK_GROW,
    KT_TRACE_KNRC_RECYCLE_ELEM,
    KT_TRACE_KNRC_NEW_POOL_ALLOC,
    KT_TRACE_KNRC_FLUSH,
    KT_TRACE_KNRC_ADD_EXACT,
    KT_TRACE_KNRC_ADD_GRANT_EXACT,
    KT_TRACE_KNRC_ADD_AMBIG,
    KT_TRACE_KNRC_AMBIG_HASH,
    KT_TRACE_KNRC_ADD_GRANT_AMBIG,
    KT_TRACE_KNRC_HAS_VIA,
    KT_TRACE_KNRC_ADD_STATS,
    KT_TRACE_KNRC_CHECK_EXACT,
    KT_TRACE_KNRC_RECLAIM_EXACT,
    KT_TRACE_KNRC_FID_NOMATCH,
    KT_TRACE_KNRC_HIT_EXACT,
    KT_TRACE_KNRC_NOMATCH_EXACT,
    KT_TRACE_KNRC_CHECK_STATS,
    KT_TRACE_KNRC_CHECK_AMBIG,
    KT_TRACE_KNRC_CHECK_HASHQ,
    KT_TRACE_KNRC_RECLAIM_AMBIG,
    KT_TRACE_KNRC_HIT_AMBIG,
    KT_TRACE_KNRC_NOMATCH_AMBIG,
    KT_TRACE_KNRC_RECLAIM,
    KT_TRACE_KNRC_RECLAIM_ELEM
};
struct uio {
        char *uio_base;
        char *uio_current;
        int32_t uio_left;
} ;
typedef struct uio uio_t;
typedef struct uio pal_uio_t;
static inline int
pal_uio_read(const char * const kaddr, const size_t count, pal_uio_t *const uiop)
{

        if (count < uiop->uio_left) {

                memcpy(uiop->uio_current,kaddr,count);


                uiop->uio_current += count;
                uiop->uio_left -= count;
                return 0;
        }
        else
        {




                return EFAULT;
        }
}
static inline int
pal_uio_write(char * const kaddr, const size_t count, pal_uio_t * const uiop)
{
    int rc = EFAULT;

        if (count <= uiop->uio_left) {

            memcpy(kaddr,uiop->uio_current,count);


            uiop->uio_current += count;
            uiop->uio_left -= count;
            return 0;
        }
        else
        {




                return EFAULT;
        }
}
#include <linux/ioctl.h>
static char KMSG_DEVICE[][14] = {
    "/dev/kossazn",
    "/dev/kossaud"
};




extern int kmsgDebug;
typedef struct chStatus {
    uint32_t opens;
    uint32_t msgs;
    uint32_t downCount;
    uint32_t rwCount;
    uint32_t gt1sec;
    uint32_t gt10sec;
    uint32_t waitTouts;
    uint32_t toRetries;
    uint32_t timeOutErrs;
    uint32_t downErrs;
    uint32_t downToToutErrs;
    uint32_t nobufs;
    uint32_t badTranID;
    uint32_t noDev;
    pal_time_t lastRead;
    pal_time_t lastResponse;
    pal_time_t downTime;
} kmsg_chanStats_t;


typedef struct chanInfo {
    int devStates;
    int chanId;
    kmsg_chanStats_t cs;
} kmsg_chanInfo_t;
extern kmsg_chanInfo_t kmsg_devData[];

extern void kmsg_Init(void);
extern void *kmsg_kGetMsgHandle(int, int, int *);
extern void kmsg_kPutMsgHandle(void *);
extern int kmsg_kAppendData(void *, char *, int);
extern int kmsg_kGetResponse(void *, char *, int, int *);
extern void kmsg_kSetTimeout(void *, int);
extern int kmsg_read(int, pal_uio_t *);
extern int kmsg_write(int, pal_uio_t *);
extern int kmsg_ioctl(int, int, char *);
extern int kmsg_open(int);
extern int kmsg_close(int);






pal_mutex_t kmsgLock;


static char cErrString[80];
kmsg_chanInfo_t kmsg_devData[2];



pal_cond_t kmsg_ChanCond[2], kmsg_BadQCond[2];


kutil_q_t kmsg_RequestQ[2];







typedef struct kmsg_activeQ {
    kutil_q_t aQ[16];
} kmsg_activeQ_t;



kmsg_activeQ_t kmsg_ActiveQueues[2];


int iEnabled=0;
int iReaders[2];



typedef struct _msg {
    kutil_q_t q;
    pal_time_t tstamp;
    pal_mutex_t mLock;
    pal_cond_t cv;
    int iChan;
    int tranId;
    int states;
    int bcount;
    int code;
    int timeout;
    char *bptr;
    char buf[6144];
} kmsg_kmsg_t;
int32_t kmsg_MsgPoolSize = 0;
kutil_q_t kmsg_FreeMsgQ;
pal_cond_t kmsg_FreeMsgQCond;
int kmsg_FreeMsgWaiters = 0;
int kmsgDebugTimeOut = 0;
int kmsgFreeTimeOut = ((300 + 30) * 2);
static uint kmsg_TranID = 0;
int
kmsg_open(int iChan )
{
    int iRC = 0;
    kmsg_chanInfo_t *devDataP;




    ;
    if (!kutil_privCheck(0,0)) return EPERM;

    (kail_mutex_lock(&kmsgLock));;

    switch( iChan ) {
    case 0 :
    case 1 :



        if ( !iEnabled ) {
            iRC = ESTALE;
            break;
        }
        devDataP = &kmsg_devData[iChan];

        switch(devDataP->devStates ){
        case 0x02:
            iRC = EINPROGRESS;
            break;
        case 0x08:
        case 0x04:
            iRC = EALREADY;
            break;
        case 0x01:
            devDataP->devStates = 0x08;
            iRC = 0;
            break;
        default:
            iRC = EINVAL;
        }
        break;
    default:

        iRC=ENODEV;
    }
    (kail_mutex_unlock(&kmsgLock));;
    ;
    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[0], KT_TRACE_KMSG_OPEN, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(iChan), (long)iRC),0) : 0);

    return(iRC);
}
int
kmsg_close(int iChan )
{
    int i, iRC = 0;
    kmsg_kmsg_t * pKmsg = (kmsg_kmsg_t *)NULL;
    kutil_q_t *pQueue, *qNext;
    kmsg_chanInfo_t *devDataP;


    (kail_mutex_lock(&kmsgLock));;


    switch( iChan ) {
    case 0 :
    case 1 :




        devDataP = &kmsg_devData[iChan];

        if (devDataP->devStates &
            (0x02 | 0x01)) {
            iRC = EALREADY;
            ;
        } else if (devDataP->devStates &
            (0x08 | 0x04)) {
            devDataP->devStates = 0x01;
            ;
        } else {
            iRC = EINVAL;
        }
        break;
    default:

        iRC=ENODEV;
    }


    if ( iRC == 0 ) {
        ;







        for (i = 0; i < 16; i++) {
            for( pQueue = (((kutil_q_t *)&(kmsg_ActiveQueues[iChan].aQ[i]))->next);
                pQueue != &(kmsg_ActiveQueues[iChan].aQ[i]);
                pQueue = qNext) {
                qNext = ((pQueue)->next);
                pKmsg = (kmsg_kmsg_t *)((pQueue));

                ;
                ;

                (((&pKmsg->q)->next)->prev = ((&pKmsg->q)->prev), ((&pKmsg->q)->prev)->next = ((&pKmsg->q)->next));
                (kail_mutex_lock(&(pKmsg)->mLock));;
                pKmsg->code = EIO;
                pKmsg->states = 0x8;
                (kail_mutex_unlock(&(pKmsg)->mLock));;
                (kail_wake_up(&pKmsg->cv));
            }
        }

        for( pQueue = (((kutil_q_t *)&kmsg_RequestQ[iChan])->next);
             pQueue != &kmsg_RequestQ[iChan];
             pQueue = qNext) {
             qNext = ((pQueue)->next);
            pKmsg = (kmsg_kmsg_t *)((pQueue));

            ;
            ;

            (((&pKmsg->q)->next)->prev = ((&pKmsg->q)->prev), ((&pKmsg->q)->prev)->next = ((&pKmsg->q)->next));
            (kail_mutex_lock(&(pKmsg)->mLock));;
            pKmsg->code = EIO;
            pKmsg->states = 0x8;
            (kail_mutex_unlock(&(pKmsg)->mLock));;
            (kail_wake_up(&pKmsg->cv));
        }





        (kail_wake_up(&kmsg_ChanCond[iChan]));
    }

    (kail_mutex_unlock(&kmsgLock));;

    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[0], KT_TRACE_KMSG_CLOSE, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(iChan), (long)iRC),0) : 0);

    return iRC;
}
int
kmsg_ioctl(int iChan, int iCmd, char *pcData)
{
    int iRC = 0;
    kmsg_chanInfo_t *devDataP;

    (kail_mutex_lock(&kmsgLock));;


    switch( iChan ) {
    case 0 :
    case 1 :



        devDataP = &kmsg_devData[iChan];

        switch((uint)iCmd) {
        case _IO('s', 1):
            if (devDataP->devStates == 0x04) {
                iRC = EALREADY;
            } else if (devDataP->devStates != 0x08 ) {
                iRC = EINPROGRESS;
            }
            else {
                ;
                kmsg_devData[iChan].cs.opens++;
                devDataP->devStates = 0x04;

                (kail_wake_up(&kmsg_ChanCond[iChan]));
            }
            break;

        case _IOW('s', 1, int):
            if (devDataP->devStates != 0x08) {
                iRC = EALREADY;
            } else {

            }
            break;

        default:
            iRC = EINVAL;
        }
        break;
    default:

        iRC=ENODEV;
    }
    (kail_mutex_unlock(&kmsgLock));;
    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[0], KT_TRACE_KMSG_IOCTL, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(iChan), (long)iCmd, (long)iRC),0) : 0);

    return iRC;
}
int
kmsg_read(int iChan, pal_uio_t *pUio)
{
    int eintr, aHash, iRC = 0;
    kutil_q_t *actQ;
    kmsg_kmsg_t *pKmsg;
    kmsg_chanInfo_t *devDataP;
    char ErrMsg[128];

    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[3])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[3], KT_TRACE_KMSG_READ_ENTRY, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(iChan)),0) : 0);
    (kail_mutex_lock(&kmsgLock));;


    switch( iChan ) {
    case 0 :
    case 1 :



        if ( !iEnabled ) {
            iRC = ESTALE;
            break;
        }

        devDataP = &kmsg_devData[iChan];
        if (devDataP->devStates != 0x04) {
            iRC = EINPROGRESS;
        }
        break;
    default:

        iRC=ENODEV;

    }




    if (( iRC == ENODEV ) || (iRC == ESTALE))
       {
       if ( iRC == ENODEV )
          kail_sprintf((ErrMsg), ("Unsupported Channel - device minor rc=%d"), (iRC));

       else
          kail_sprintf((ErrMsg), ("Stale Channel rc=%d"), (iRC));

       pal_logErr (0x340b4002, ErrMsg);
       }

    if ( iRC == 0 ) {
        kmsg_devData[iChan].cs.rwCount++;

        while( ((((kutil_q_t *)&kmsg_RequestQ[iChan])->next) == (kutil_q_t *)&kmsg_RequestQ[iChan]) ) {
            ;

            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[3])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[3], KT_TRACE_KMSG_READ_WAIT, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(iChan)),0) : 0);

            iReaders[iChan]++;
            eintr = (kail_cond_wait_intr(&kmsg_ChanCond[iChan],&kmsgLock));
            iReaders[iChan]--;
            if ( iEnabled == 0 ) {




                ;
                (kail_wake_up(&kmsg_BadQCond[iChan]));
            }
            if (eintr) {
                iRC = EINTR;
                break;
            } else {

                if (devDataP->devStates != 0x04) {
                    ;
                    iRC = EINPROGRESS;
                    break;
                }
            }

        }
    }

    if (iRC == 0) {
        ;







        pKmsg = (kmsg_kmsg_t *)(((((kutil_q_t *)&kmsg_RequestQ[iChan])->prev)));
        ;
        (((&pKmsg->q)->next)->prev = ((&pKmsg->q)->prev), ((&pKmsg->q)->prev)->next = ((&pKmsg->q)->next));
        ((&pKmsg->q)->next = (&pKmsg->q)->prev = (&pKmsg->q));

        (kail_mutex_lock(&(pKmsg)->mLock));;

        pKmsg->states |= 0x40;
        (kail_mutex_unlock(&kmsgLock));;

        iRC = pal_uio_read((char *)(&pKmsg->tranId),(sizeof(int)),(pUio));

        if (iRC == 0) {
            iRC = pal_uio_read((char *)(&pKmsg->bcount),(sizeof(pKmsg->bcount)),(pUio));
        }
        if (iRC == 0) {
            iRC = pal_uio_read((char *)(pKmsg->buf),(pKmsg->bcount),(pUio));
        }
        if (iRC == 0) {
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[3])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[3], KT_TRACE_KMSG_READ_WORK, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(iChan), (long)pKmsg->tranId, (long)pKmsg->bcount),0) : 0);


            ;

            pKmsg->states = 0x2;
        } else {
            pKmsg->code = iRC;
            pKmsg->states = 0x8;
            (kail_wake_up(&pKmsg->cv));
        }

        if (!(!kail_mutex_trylock(&kmsgLock))) {

            (kail_mutex_unlock(&(pKmsg)->mLock));;
            (kail_mutex_lock(&kmsgLock));;
            (kail_mutex_lock(&(pKmsg)->mLock));;
        }

        if (iRC == 0) {
            devDataP->cs.lastRead = ((pal_time_t)(kail_xtime->tv_sec));
            aHash = ((uint32_t)(pKmsg->tranId) & (16 - 1));
            actQ = &(kmsg_ActiveQueues[iChan].aQ[aHash]);
            ((&pKmsg->q)->next = (((kutil_q_t *)actQ)->next), (&pKmsg->q)->prev = (actQ), (((kutil_q_t *)actQ)->next)->prev = (&pKmsg->q), (actQ)->next = (&pKmsg->q));
        }

        (kail_mutex_unlock(&kmsgLock));;
        pKmsg->states &= ~0x40;
        (kail_mutex_unlock(&(pKmsg)->mLock));;

    } else {
        (kail_mutex_unlock(&kmsgLock));;
    }

    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[3])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[3], KT_TRACE_KMSG_READ_EXIT, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(iChan), (long)iRC),0) : 0);

    return iRC;
}
int
kmsg_write(int iChan, pal_uio_t *pUio)
{
    int iRC=0, iFound, iTid, iMlen, aHash;
    kutil_q_t *pQueue, *actQ;
    kmsg_kmsg_t *pKmsg;
    kmsg_chanInfo_t *devDataP;


    pKmsg = NULL;
    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[3])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[3], KT_TRACE_KMSG_WRITE_ENTRY, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(iChan)),0) : 0);
    ;


    iRC = pal_uio_write((char *)(&iTid),(sizeof(int)),(pUio));
    if (iRC)
        goto write_out;
    ;

    (kail_mutex_lock(&kmsgLock));;


    switch( iChan ) {
    case 0 :
    case 1 :



        if ( !iEnabled ) {
            iRC = ESTALE;
            break;
        }

        devDataP = &kmsg_devData[iChan];
        if (devDataP->devStates != 0x04) {
            iRC = EINPROGRESS;
        }
        break;
    default:

        iRC=ENODEV;
    }

    if (iRC == 0) {
        devDataP->cs.rwCount++;

        devDataP->cs.lastResponse = ((pal_time_t)(kail_xtime->tv_sec));




        iFound = 0;
        aHash = ((uint32_t)(iTid) & (16 - 1));
        actQ = &kmsg_ActiveQueues[iChan].aQ[aHash];
        for( pQueue = (((kutil_q_t *)actQ)->prev);
            pQueue != actQ; pQueue = ((pQueue)->prev)) {
            pKmsg = (kmsg_kmsg_t *)((pQueue));
            if (pKmsg->tranId == iTid) {
                iFound = 1;
                break;
            }
        }

        if (iFound) {
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[3])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[3], KT_TRACE_KMSG_WRITE_ID, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(iChan), (long)iTid),0) : 0);


            ;

            (((&pKmsg->q)->next)->prev = ((&pKmsg->q)->prev), ((&pKmsg->q)->prev)->next = ((&pKmsg->q)->next));
        } else {
            devDataP->cs.badTranID++;
            ;
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[3])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[3], KT_TRACE_KMSG_BADTRANID, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(iChan), (long)iTid),0) : 0);

            kail_sprintf((cErrString), ("Did not find tranID %d."), (iTid));

            ;
            iRC = ENOENT;
            pKmsg = NULL;
        }
    }

    if (pKmsg) {
        (kail_mutex_lock(&(pKmsg)->mLock));;
        iRC = pKmsg->code;
        pKmsg->states |= 0x40;
        (kail_mutex_unlock(&kmsgLock));;

        if (iRC == 0) {
            iRC = pal_uio_write((char *)(&(pKmsg->bcount)),(sizeof(int)),(pUio));
            if (iRC == 0) {
                iMlen = ((pUio)->uio_left);
                if ((iMlen == pKmsg->bcount) && (iMlen <= 6144)) {

                    ;

                    pKmsg->bptr = pKmsg->buf;
                    pKmsg->bcount = 0;
                    iRC = pal_uio_write((char *)(pKmsg->bptr),(iMlen),(pUio));

                    pKmsg->code = iRC;
                    if (iRC == 0) {
                        pKmsg->bcount = iMlen;
                        ;

                        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[3])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[3], KT_TRACE_KMSG_WRITE_LEN, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(iTid), (long)iMlen),0) : 0);



                    }
                } else {

                    if ( iMlen != pKmsg->bcount ) {
                        iRC = EINVAL;
                        ;


                        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[0], KT_TRACE_KMSG_BADSIZE, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(pKmsg->bcount), (long)iMlen, (long)pKmsg->tranId),0) : 0);




                        kail_sprintf((cErrString), ("Size of message mismatch, expect=%d, has=%d.\n"), (pKmsg->bcount), (iMlen));


                        ;
                    } else if (iMlen > 6144) {
                        iRC = E2BIG;
                        ;


                        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[0], KT_TRACE_KMSG_TOOBIG, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(pKmsg->tranId), (long)iMlen),0) : 0);



                        kail_sprintf((cErrString), ("Message written was too big - %d.\n"), (iMlen));


                        ;
                    }
                    pKmsg->code = iRC;
                }
            }
        }






        pKmsg->states &= ~0x40;
        pKmsg->states = 0x8;
        (kail_mutex_unlock(&(pKmsg)->mLock));;

        (kail_wake_up(&pKmsg->cv));
    } else {
        (kail_mutex_unlock(&kmsgLock));;
    }


  write_out:
    if (iRC) {
        ;
        (kail_mutex_lock(&kmsgLock));;
        kail_sprintf((cErrString), ("Returning - error in write(), %d.\n"), (iRC));

        ;
        (kail_mutex_unlock(&kmsgLock));;
    }

    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[3])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[3], KT_TRACE_KMSG_WRITE_EXIT, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(iChan), (long)iRC),0) : 0);

    return iRC;
}
static int
checkDevDown(
    kmsg_chanInfo_t *devDataP,
    int rwCount,
    pal_time_t callStart)
{
    pal_time_t now, lastRead, lastResponse;


    now = ((pal_time_t)(kail_xtime->tv_sec));
    if (devDataP->devStates & 0x10) {
        if ((devDataP->cs.downTime + 30) < now) {

            devDataP->devStates &= ~0x10;
            devDataP->cs.downTime = 0;
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[0], KT_TRACE_KMSG_CHAN_RETRY, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(devDataP->chanId)),0) : 0);

        }
    } else if (rwCount && callStart && devDataP->cs.lastRead) {
        lastRead = devDataP->cs.lastRead;
        lastResponse = devDataP->cs.lastResponse;
        if ((rwCount == devDataP->cs.rwCount) &&
            ((lastRead + (300 + 30)) < now) &&
            ((lastResponse + (300 + 30)) < now)) {
            devDataP->devStates |= 0x10;
            devDataP->cs.downCount++;
            devDataP->cs.downTime = now;
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[0], KT_TRACE_KMSG_CHAN_DOWN, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(devDataP->chanId), (long)devDataP->cs.downCount, (long)devDataP->cs.msgs),0) : 0);



        }
    }

    return (devDataP->devStates & 0x10);
}
int
kmsg_kGetResponse(void *hMsg, char *pcBuf, int iBlen, int *piOutLen)
{
    int iRC = 0,iWaitCode, isDown;
    int32_t rwCount;
    int64_t waitTime, timeout;
    pal_time_t start, responseTime;
    kmsg_chanInfo_t *devDataP;
    kmsg_kmsg_t *pKmsg = (kmsg_kmsg_t *)hMsg;






    ;
    ;
    *piOutLen = 0;

    (kail_mutex_lock(&kmsgLock));;

    devDataP = &kmsg_devData[pKmsg->iChan];
    if (devDataP->devStates != 0x04 ) {
        iRC = ENODEV;
    }
    if ( !iEnabled ) {
        iRC = ESTALE;
    }
    if (iRC) {
        (kail_mutex_unlock(&kmsgLock));;
        goto out;
    }

    start = ((pal_time_t)(kail_xtime->tv_sec));
    if (pKmsg->states == 0x1) {
        pKmsg->states = 0x4;

        ;


        ((&pKmsg->q)->next = (((kutil_q_t *)&kmsg_RequestQ[pKmsg->iChan])->next), (&pKmsg->q)->prev = (&kmsg_RequestQ[pKmsg->iChan]), (((kutil_q_t *)&kmsg_RequestQ[pKmsg->iChan])->next)->prev = (&pKmsg->q), (&kmsg_RequestQ[pKmsg->iChan])->next = (&pKmsg->q));

        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[3])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[3], KT_TRACE_KMSG_SEND_REQ, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(pKmsg->iChan), (long)pKmsg->tranId, (long)pKmsg->bcount),0) : 0);




        ;


        pKmsg->tstamp = start;






        (kail_mutex_unlock(&kmsgLock));;
        (kail_wake_up(&kmsg_ChanCond[pKmsg->iChan]));
    } else {
        (kail_mutex_unlock(&kmsgLock));;
    }







    (kail_mutex_lock(&(pKmsg)->mLock));;

    timeout = pKmsg->timeout;




    if (timeout < 6) {
        waitTime = timeout;
    } else {
        waitTime = 6;
    }

    rwCount = devDataP->cs.rwCount;
    responseTime = 0;

    if (pKmsg->states != 0x8) {
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[3])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[3], KT_TRACE_KMSG_GET_RESP, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(pKmsg->iChan), (long)pKmsg->tranId, (long)(int)timeout, (long)pKmsg->states),0) : 0);




    }

    while (pKmsg->states != 0x8) {

        if ( timeout <= 0 ) {
            (kail_cond_wait(&pKmsg->cv,&pKmsg->mLock));
        } else {
            iWaitCode = (kail_condTimedWait(&pKmsg->cv,&pKmsg->mLock,waitTime,0));

            if (iWaitCode == 2) {
                ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[3])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[3], KT_TRACE_KMSG_WAIT_TO, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(devDataP->chanId), (long)(int)waitTime),0) : 0);



                iRC = 0;
                (kail_mutex_unlock(&(pKmsg)->mLock));;
                (kail_mutex_lock(&kmsgLock));;
                devDataP->cs.waitTouts++;
                isDown = checkDevDown(devDataP, rwCount, start);
                if (start + timeout < ((pal_time_t)(kail_xtime->tv_sec))) {
                    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[3])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[3], KT_TRACE_KMSG_HARD_TO, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)((int)timeout)),0) : 0);

                    iRC = ETIMEDOUT;
                } else if (isDown) {
                    iRC = ETIMEDOUT;
                    devDataP->cs.downErrs++;
                    devDataP->cs.downToToutErrs++;
                    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[0], KT_TRACE_KMSG_DOWN_TO_TOUT, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(devDataP->cs.downToToutErrs)),0) : 0);

                } else {
                        devDataP->cs.toRetries++;
                        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[3])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[3], KT_TRACE_KMSG_TO_RETRY, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(devDataP->cs.toRetries)),0) : 0);

                }
                (kail_mutex_unlock(&kmsgLock));;
                (kail_mutex_lock(&(pKmsg)->mLock));;

                if (iRC) {
                    break;
                }
            }
        }
        responseTime = ((pal_time_t)(kail_xtime->tv_sec)) - start;
    }
    if ( pKmsg->states != 0x8 && iRC ) {

        while (pKmsg->states & 0x40) {
            (kail_cond_wait(&pKmsg->cv,&pKmsg->mLock));
        }
        (kail_mutex_unlock(&(pKmsg)->mLock));;
        (kail_mutex_lock(&kmsgLock));;
        (kail_mutex_lock(&(pKmsg)->mLock));;
        if ((pKmsg->states != 0x8) && iRC ) {
            pKmsg->code = iRC;
            pKmsg->states = 0x8;
            (((&pKmsg->q)->next)->prev = ((&pKmsg->q)->prev), ((&pKmsg->q)->prev)->next = ((&pKmsg->q)->next));
        }
        (kail_mutex_unlock(&kmsgLock));;
    }


    ;

    if (iRC == 0) {
        iRC = pKmsg->code;
    }

    (kail_mutex_unlock(&(pKmsg)->mLock));;





    if (iRC == 0) {
        if (responseTime > 1) {
            (kail_mutex_lock(&kmsgLock));;
            if (responseTime > 10) {
                devDataP->cs.gt10sec++;
            } else {
                devDataP->cs.gt1sec++;
            }
            (kail_mutex_unlock(&kmsgLock));;
        }
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[3])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[3], KT_TRACE_KMSG_RECV_RESP, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(pKmsg->tranId), (long)pKmsg->bcount, (long)iBlen),0) : 0);



        ;

        if (pKmsg->bcount >= iBlen) {
            memcpy(pcBuf,pKmsg->bptr,iBlen);
            pKmsg->bptr += iBlen;
            pKmsg->bcount -= iBlen;
            *piOutLen = iBlen;
        } else {

            iRC = EIO;
        }
     }

out:
    if (iRC) {
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[0], KT_TRACE_KMSG_GET_RESP_ERR, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(iRC)),0) : 0);

        (kail_mutex_lock(&kmsgLock));;
        if (iRC == ETIMEDOUT) {
            devDataP->cs.timeOutErrs++;
        }
        kail_sprintf((cErrString), ("KOSS ERR: kmsg get response iRC %d.\n"), (iRC));

        ;
        (kail_mutex_unlock(&kmsgLock));;
    }

    return iRC;
}
int
kmsg_kAppendData(void * hMsg, char *pcBuf, int iBlen)
{
    kmsg_kmsg_t *pKmsg = (kmsg_kmsg_t *)hMsg;
    int iRC = 0;


    ;
    ;







    ;


    if ( pKmsg->bcount + iBlen <= 6144 ) {
        memcpy(pKmsg->bptr,pcBuf,iBlen);
        pKmsg->bptr += iBlen;
        pKmsg->bcount += iBlen;
    } else {

        memcpy(pKmsg->bptr,pcBuf,6144 - pKmsg->bcount);
        pKmsg->bptr += (6144 - pKmsg->bcount);
        pKmsg->bcount = 6144;
        iRC = E2BIG;
    }

    return iRC;
}
void *
kmsg_kGetMsgHandle(int iChan, int iFlags, int *status)
{
    kmsg_kmsg_t *pKmsg = (kmsg_kmsg_t *)NULL;
    int iRC = 0, iWaitCode;
    uint nextTranId;
    int64_t tOut = kmsgFreeTimeOut;
    kmsg_chanInfo_t *devDataP = (kmsg_chanInfo_t *)NULL;


    ;

    switch( iChan ) {
    case 0 :
    case 1 :




        (kail_mutex_lock(&kmsgLock));;
        if ( !iEnabled ) {
            iRC = ESTALE;
            break;
        }
        devDataP = &kmsg_devData[iChan];

        for (;;) {
            if ((devDataP->devStates==0x01) ||
                (devDataP->devStates==0x02)) {
                iRC = ENODEV;
                devDataP->cs.noDev++;
                ;
                ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[3])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[3], KT_TRACE_KMSG_CHANCLOSED, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(iChan)),0) : 0);

                kail_sprintf((cErrString), ("Message channel %d is closed.\n"), (iChan));

                ;
                break;
            }
            if (devDataP->devStates == 0x08) {
                ;
                (kail_cond_wait(&kmsg_ChanCond[iChan],&kmsgLock));
            } else {
                break;
            }
        }

        break;
    default:

        iRC=ENODEV;

    }

    if ((iRC == 0) && (devDataP->devStates & 0x10) &&
        checkDevDown(devDataP, 0, 0)) {
        devDataP->cs.downErrs++;
        iRC = EAGAIN;
    }

    if ( iRC == 0 ) {




        while ( ((((kutil_q_t *)&kmsg_FreeMsgQ)->next) == (kutil_q_t *)&kmsg_FreeMsgQ) ) {
            ;
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[3])->active) ? (kt_Event0((kt_chanID_t)&kt_defChannels[3], KT_TRACE_KMSG_WAIT_MSG, (((0)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16))),0) : 0);
            kmsg_FreeMsgWaiters++;
            iWaitCode = (kail_condTimedWait(&kmsg_FreeMsgQCond,&kmsgLock,tOut,0));

            kmsg_FreeMsgWaiters--;
            if (iWaitCode == 2) {
                iRC = ENOBUFS;
                devDataP->cs.nobufs++;
                break;
            }

            if ((devDataP->devStates & 0x10) &&
                checkDevDown(devDataP, 0, 0)) {
                devDataP->cs.downErrs++;
                iRC = EAGAIN;
            }
        }
    } else {
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[3])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[3], KT_TRACE_KMSG_ERR_GET_HAND, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(iChan), (long)iRC),0) : 0);

        kail_sprintf((cErrString), ("Error opening channel %d, rc=%d.\n"), (iChan), (iRC));

        ;
    }

    if ( iRC == 0 ) {

        pKmsg = (kmsg_kmsg_t *)(((((kutil_q_t *)&kmsg_FreeMsgQ)->next)));
        ;
        (((&pKmsg->q)->next)->prev = ((&pKmsg->q)->prev), ((&pKmsg->q)->prev)->next = ((&pKmsg->q)->next));
        nextTranId = ++kmsg_TranID;
        devDataP->cs.msgs++;
    }

    (kail_mutex_unlock(&kmsgLock));;

    if (pKmsg) {

        ((&pKmsg->q)->next = (&pKmsg->q)->prev = (&pKmsg->q));
        pKmsg->tranId = nextTranId;
        pKmsg->states = 0x1;
        pKmsg->bcount = 0;
        pKmsg->bptr = pKmsg->buf;
        pKmsg->code = 0;
        pKmsg->iChan = iChan;
        pKmsg->timeout = 30;
        ;


        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[3])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[3], KT_TRACE_KMSG_GET_HAND, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(iChan), (long)pKmsg->tranId),0) : 0);

   } else if (iRC == EAGAIN) {






        pal_delay(200 );
   }

   ;
   *status = iRC;
   return (void *)pKmsg;
}
void
kmsg_kPutMsgHandle(void *hMsg)
{
    kmsg_kmsg_t *pKmsg = (kmsg_kmsg_t *)hMsg;
    int doSignal = 0;

    ;

    (kail_mutex_lock(&kmsgLock));;
    if ( pKmsg->states == 0x4 ||
         pKmsg->states == 0x2 ) {
        ;

        (((&pKmsg->q)->next)->prev = ((&pKmsg->q)->prev), ((&pKmsg->q)->prev)->next = ((&pKmsg->q)->next));
    }

    pKmsg->states = 0x20;
    ((&pKmsg->q)->next = (((kutil_q_t *)&kmsg_FreeMsgQ)->next), (&pKmsg->q)->prev = (&kmsg_FreeMsgQ), (((kutil_q_t *)&kmsg_FreeMsgQ)->next)->prev = (&pKmsg->q), (&kmsg_FreeMsgQ)->next = (&pKmsg->q));
    if (kmsg_FreeMsgWaiters) {
        doSignal = 1;
    }
    ;
    (kail_mutex_unlock(&kmsgLock));;

    if (doSignal) {
        (kail_wake_up(&kmsg_FreeMsgQCond));
    }

    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[3])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[3], KT_TRACE_KMSG_FREE_HAND, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(pKmsg->tranId)),0) : 0);

}
void
kmsg_kSetTimeout( void *hMsg, int iValue )
{
    kmsg_kmsg_t *pKmsg = (kmsg_kmsg_t *)hMsg;

    if (iValue < 300) {
        pKmsg->timeout = iValue;
    } else {
        pKmsg->timeout = 300;
    }
}
void
kmsg_Init()
{
    int iDev, i, j, ramMB, poolSize;
    kutil_q_t *qp;
    kmsg_kmsg_t *msgp;


    (kail_mutex_init(&kmsgLock));

    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[3])->active) ? (kt_Event0((kt_chanID_t)&kt_defChannels[3], KT_TRACE_KMSG_INIT, (((0)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16))),0) : 0);
    memset((char *)&kmsg_devData,0,sizeof(kmsg_devData));
    for ( iDev = 0; iDev <= 1; iDev++ ) {
        kmsg_devData[iDev].devStates = 0x01;
        kmsg_devData[iDev].chanId = iDev;
        (kail_cond_init(&kmsg_ChanCond[iDev]));
        ((&kmsg_RequestQ[iDev])->next = (&kmsg_RequestQ[iDev])->prev = (&kmsg_RequestQ[iDev]));
        (kail_cond_init(&kmsg_BadQCond[iDev]));
        iReaders[iDev] = 0;

        for (j = 0; j < 16; j++) {
            qp = &kmsg_ActiveQueues[iDev].aQ[j];
            ((qp)->next = (qp)->prev = (qp));
        }
    }


    ((&kmsg_FreeMsgQ)->next = (&kmsg_FreeMsgQ)->prev = (&kmsg_FreeMsgQ));
    (kail_cond_init(&kmsg_FreeMsgQCond));
    poolSize = 8;
    ramMB = pal_sysMemMB;
    if (ramMB >= 64) {
        poolSize += ramMB / 2;
        if (poolSize > 128) {
            poolSize = 128;
        }
    }

    for ( i= 0; i< poolSize; i++ ) {
        msgp = (kmsg_kmsg_t *)pal_alloc(sizeof(*msgp));
        if (msgp == NULL) {
            if (i > 8) {

                break;
            } else {

                (!(0)? (*((char *)0) = 0) : 0);
            }
        }

        kmsg_MsgPoolSize++;
        (kail_cond_init(&msgp->cv));
        (kail_mutex_init(&msgp->mLock));
        msgp->tranId = -1;
        msgp->bcount = 0;
        msgp->bptr = msgp->buf;
        msgp->code = 0;
        msgp->iChan = -1;
        msgp->states = 0x20;
        ((&msgp->q)->next = (&msgp->q)->prev = (&msgp->q));

        ((&msgp->q)->next = (((kutil_q_t *)&kmsg_FreeMsgQ)->next), (&msgp->q)->prev = (&kmsg_FreeMsgQ), (((kutil_q_t *)&kmsg_FreeMsgQ)->next)->prev = (&msgp->q), (&kmsg_FreeMsgQ)->next = (&msgp->q));
    }

    iEnabled = 1;
}





void
kmsg_shutdown()
{
    int iDev;
    kmsg_kmsg_t *msgp;
    kutil_q_t *qp, *qNext;


    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[3])->active) ? (kt_Event0((kt_chanID_t)&kt_defChannels[3], KT_TRACE_KMSG_FINISH, (((0)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16))),0) : 0);
    (kail_mutex_lock(&kmsgLock));;
    iEnabled = 0;







    (kail_mutex_unlock(&kmsgLock));;






    for ( iDev = 0; iDev <= 1; iDev++ ) {
        kmsg_close( iDev );
    }



    for ( iDev = 0; iDev <= 1; iDev++ ) {
        (kail_mutex_lock(&kmsgLock));;
        while ( iReaders[iDev] != 0 ) {
            ;

            (kail_cond_wait(&kmsg_BadQCond[iDev],&kmsgLock));
        }
        ;
        (kail_cond_destroy(&kmsg_BadQCond[iDev]));
        (kail_cond_destroy(&kmsg_ChanCond[iDev]));
        (kail_mutex_unlock(&kmsgLock));;
    }


    (kail_mutex_lock(&kmsgLock));;
    for (qp = (((kutil_q_t *)&kmsg_FreeMsgQ)->next);
        qp != &kmsg_FreeMsgQ; qp = qNext) {
        msgp = (kmsg_kmsg_t *)((qp));
        qNext = ((qp)->next);




        ;
        (kail_cond_destroy(&msgp->cv));
        (kail_mutex_destroy(&msgp->mLock));
        pal_free(msgp, sizeof(*msgp));
    }
    (kail_mutex_unlock(&kmsgLock));;







}
