
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *
 * IBM Tivoli Access Manager for Operating Systems 6.0.0
 * 5698-PDO
 * Licensed Materials - Property of IBM
 * 
 * (C) Copyright IBM Corp. 2000,2006. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 *
*/

static char sccsid[]="@(#)71	1.6  src/oss/kazn/kutil/kutil.c, oss.kazn.src, oss600, 040618a  10/10/01  15:30:52";
#include <linux/kernel.h>

#include <linux/stddef.h>


#include <asm/string.h>

#include <asm/byteorder.h>






#include <linux/stat.h>


#include <linux/limits.h>

#include <linux/errno.h>

#include <asm/ptrace.h>

#include <asm/fcntl.h>
  typedef int intptr_t;


 typedef unsigned int uintptr_t;


typedef __kernel_uid32_t uid32_t;
typedef __kernel_gid32_t gid32_t;
typedef struct kail_vfs
{
    void *mnt;
    void *mnt_parent;
    char devname[64];
} kail_vfs_t;






typedef struct {
        long val[2];
} kail_fsid_t;

typedef struct kail_fid {
    uint32_t fid_ino;
    uint32_t fid_gen;
    uint16_t fid_flags;
    uint16_t fid_data_len;

    char fid_data[(sizeof(char) * 64)];
} kail_fid_t;

typedef mode_t kail_fmode_t;
typedef dev_t kail_dev_t;
typedef void * kail_vnodeH_t;
typedef struct _kail_rfid {
    uint32_t ctime;
    kail_fsid_t fsid;
    kail_fid_t fid;
} kail_rawFid_t;
typedef struct _kail_cred {

        uid_t uid,euid,suid,fsuid;
        gid_t gid,egid,sgid,fsgid;
        int ngroups;
        int cr_ref;
        gid_t groups[32 ];
} kail_cred_t;

typedef int64_t kail_authID_t;
enum kail_ftypes { KAIL_FTYPE_NONE, KAIL_FTYPE_FILE, KAIL_FTYPE_DIR,
             KAIL_FTYPE_BLKDEV, KAIL_FTYPE_CHARDEV, KAIL_FTYPE_LNK,
             KAIL_FTYPE_SOCK, KAIL_FTYPE_BAD, KAIL_FTYPE_FIFO,
             KAIL_FTYPE_MPC, KAIL_FTYPE_OTHER};
typedef enum kail_ftypes kail_ftypes_t;

typedef struct _kail_fattr {
    kail_authID_t uid;
    kail_authID_t gid;
    kail_ftypes_t ftype;
    kail_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    dev_t dev;
    kail_vfs_t check_vfsp;
} kail_fattr_t;




extern volatile struct timespec *kail_xtime;





extern asmlinkage int (*kail_printk)(const char *, ...);
extern asmlinkage int (*kail_sprintf)(char * buf, const char * fmt, ...);
extern asmlinkage int (*kail_do_fork)(unsigned long, unsigned long, struct pt_regs *, unsigned long);


extern asmlinkage int kail_kernel_thread(int (*)(void *), void *,unsigned long);
extern asmlinkage int kail_kill_proc(pid_t, int, int);
extern asmlinkage long kail_strncpy_from_user(char *, const char *, long);
extern asmlinkage long kail_strncpy_from_DND(char *, void *, long);
extern unsigned long FASTCALL(kail_copy_to_user(void *, const void *, unsigned long));
extern unsigned long FASTCALL(kail_copy_from_user(void *, const void *, unsigned long));

extern void FASTCALL(kail_kernel_free(void *,unsigned long));
extern void * FASTCALL(kail_kernel_malloc(unsigned long));





extern asmlinkage void kail_mutex_init(void **);
extern void FASTCALL(kail_mutex_lock(void **));
extern int FASTCALL(kail_mutex_trylock(void **));
extern void FASTCALL(kail_mutex_unlock(void **));
extern asmlinkage void kail_mutex_destroy(void **);

extern asmlinkage void kail_cond_init(void **);
extern void FASTCALL(kail_wake_up(void **));
extern void FASTCALL(kail_cond_wait(void **, void **));
extern int FASTCALL(kail_cond_wait_intr(void **, void **));
extern asmlinkage int kail_condTimedWait(void **, void **, int64_t, int);
extern asmlinkage void kail_cond_destroy(void **);

extern asmlinkage void kail_iclock_init(void **);
extern void FASTCALL(kail_iclock_lock(void **));
extern void FASTCALL(kail_iclock_unlock(void **));
extern int FASTCALL(kail_iclock_trylock(void **));
extern asmlinkage void kail_iclock_destroy(void **);

extern void FASTCALL(kail_iclock_cond_wait(void **,void **));

extern asmlinkage int kail_current_pid(void);
extern asmlinkage int kail_current_tid(void);
extern asmlinkage int kail_current_Ppid(void);
extern int FASTCALL(kail_tid_to_pid(int));

extern pid_t FASTCALL(kail_pid_get_epid(pid_t));
extern void FASTCALL(kail_pid_delete(pid_t));
extern void FASTCALL(kail_epid_delete(pid_t));
extern void FASTCALL(kail_pid_add(pid_t,pid_t));

extern asmlinkage int kail_current_uid(void);
extern asmlinkage int kail_current_euid(void);
extern asmlinkage int kail_current_suid(void);
extern asmlinkage int kail_current_gid(void);
extern asmlinkage int kail_current_egid(void);
extern int FASTCALL(kail_current_files_close_on_exec(int));

extern asmlinkage int kail_socket_protocol(void *);
extern asmlinkage int kail_socket_getname(void *,void *,int *,int);

extern int FASTCALL(kail_fd_to_dev(int, dev_t *));
extern int FASTCALL(kail_fd_to_name(int, char **, int *));
extern int FASTCALL(kail_fd_to_socket(int,void **));

extern int FASTCALL(kail_socket_shutdown(void *));




extern int FASTCALL(kail_check_pid(int));
extern int FASTCALL(kail_get_pid_pgrp(int,int *));
extern int FASTCALL(kail_get_pid_uid(int,int *,int *));
extern void FASTCALL(kail_scan_procs(void *));

extern asmlinkage void kail_daemonize(const char *);
extern asmlinkage int kail_total_ram_mb(void);
extern void FASTCALL(kail_atomic_add(int,void *));

extern asmlinkage int kail_kernel_address_mode(void);






extern asmlinkage int kail_decomposePath(char *, int, kail_rawFid_t *, int *, kail_rawFid_t *, int *, kail_fattr_t *, kail_vnodeH_t *);
extern asmlinkage int kail_LookupFidAndDir(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, int *);
extern asmlinkage int kail_lookupFidsAndInfo(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, kail_vnodeH_t *, kail_vnodeH_t *, int *);
extern asmlinkage int kail_dirFidToPathFids( kail_rawFid_t *, kail_rawFid_t **, int *);
extern asmlinkage int kail_unixDescToRawFid( int , kail_rawFid_t *);
extern asmlinkage int kail_vnodesToFids( kail_vnodeH_t, kail_vnodeH_t, kail_rawFid_t *, kail_rawFid_t *, kail_rawFid_t **, int *, kail_fattr_t *);
extern asmlinkage int kail_makeFidChain(void *, kail_rawFid_t *, int *, const kail_cred_t *, int );




struct kail_register_chrdev_parameters {
        unsigned int dev_number;
        char *name;
        void *ownerp;
        void *readp;
        void *writep;
        void *ioctlp;
        void *openp;
        void *releasep;
        unsigned int ioctl_cnt;
        unsigned int *ioctl_cmds;
} ;

extern asmlinkage int kail_register_chrdev(struct kail_register_chrdev_parameters *, void **);
extern asmlinkage int kail_unregister_chrdev(struct kail_register_chrdev_parameters *, void *);
extern int FASTCALL(kail_minor(void *));

extern asmlinkage int kail_file_read(char *, kail_vnodeH_t *,char *, long, long);
extern asmlinkage void kail_write_log(const char *,const char *, int, int);
extern asmlinkage void kail_log_init(const char *);

extern asmlinkage int kail_pathToFullPath( char *, int , char **, char *,int);
extern void * FASTCALL(kail_unixDescToVnode(int));
extern void FASTCALL(kail_releVnode(void *));
extern void FASTCALL(kail_holdVnode(void *));
extern asmlinkage char * kail_readSymLink(char *, int *);



extern asmlinkage int kail_vfs_mounted(kail_vfs_t *);
extern asmlinkage int kail_vfs_check(kail_vfs_t *);


typedef struct {
        void *alloc;
        void *free;
        void *fcc_find;
        void *fcc_add;
} kail_call_back_t;

extern asmlinkage void kail_call_backs(kail_call_back_t *);
extern asmlinkage void kail_kernel_interface(void);
extern asmlinkage void kail_kernel_interface_shutdown(void);

typedef asmlinkage long (* sys_call_fn)();
struct kail_syscall_prepost {
        int call_index;
        sys_call_fn call_pre;
        sys_call_fn call_post;
};

extern int struct_cppath_size;

extern asmlinkage int kail_trap_syscalls(struct kail_syscall_prepost *);



extern asmlinkage void kail_restore_syscalls(void);

struct nameidata;
struct kail_datanameidata {
        char cdata[4];
        char *path;
        struct nameidata *nd;
};
#define KAIL_LOOKUP_BIT 0x40000000
#ifdef LINUX_RHEL4
#define SET_LOOKUP_FLAG(n) (n)->intent.open.flags = KAIL_LOOKUP_BIT;
#define CLEAR_LOOKUP_FLAG(n) (n)->intent.open.flags &= ~KAIL_LOOKUP_BIT;
#define CHECK_LOOKUP_FLAG(n) ((n)->intent.open.flags == KAIL_LOOKUP_BIT)
#endif 
#ifdef LINUX_SLES9
#define SET_LOOKUP_FLAG(n)
#define CLEAR_LOOKUP_FLAG(n)
#define CHECK_LOOKUP_FLAG(n)
#endif 
typedef unsigned char byte_t;





typedef int64_t oss_uid_t;
typedef int64_t oss_gid_t;
typedef struct {
    int ipV6:1;
    int ipV6V4Mapped:1;
    int ipV6V4Compat:1;
    union {
        uint32_t a32[4];
        uint16_t a16[8];
        uint8_t a8[16];
        struct {
            uint32_t pad[3];
            uint32_t addr;
        } addrClassic;
    } addr;
} oss_nwIP_t;





typedef struct {
    uint16_t protocol;
    uint16_t port;
} oss_nwService_t;

typedef struct {
    oss_nwIP_t ip;
    oss_nwService_t service;
} oss_nwAddr_t;

typedef struct {
    uint32_t count;
    oss_nwIP_t* ip;
} oss_nwIPList_t;

typedef struct {
    uint32_t count;
    char** name;
} oss_nwNameList_t;
typedef pid_t tid_t;



typedef pid_t pal_pid_t;
typedef tid_t pal_tid_t;




typedef unsigned long pal_scall_parm_t;


typedef void * pal_caller_t;



typedef kail_fmode_t pal_fmode_t;
typedef kail_dev_t pal_dev_t;
typedef kail_vnodeH_t pal_vnodeH_t;
typedef kail_vfs_t pal_vfs_val_t;



typedef kail_fsid_t pal_fsid_t;
typedef kail_fid_t pal_fid_t;
typedef kail_cred_t cred_t;

static inline int pal_pinMem(void *mem, size_t size)
{ return 0; }

static inline int pal_unpinMem(void *mem, size_t size)
{ return 0; }
static inline int pal_copyin(char *uaddr, char *kaddr, size_t count)
{
    return (int)kail_copy_from_user(kaddr, uaddr, count);
}
static inline int pal_copyout(char *kaddr, char *uaddr, size_t count)
{
    return (int)kail_copy_to_user(uaddr, kaddr, count);
}
static inline int
pal_copyinstr(char *uaddr, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_user(kaddr, uaddr, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int
pal_copyinstr_LSM(void *dnd, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_DND(kaddr, dnd, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int pal_suser(void)
{
    return (kail_current_euid() == 0);
}
static inline int
pal_unixDescIsCOE(int fd)
{
        return kail_current_files_close_on_exec(fd);
}
static inline void
pal_releVnode(pal_vnodeH_t vnh)
{
    ;
    kail_releVnode((void *)vnh);
}
static inline void
pal_holdVnode(pal_vnodeH_t vnh)
{
    ;
    kail_holdVnode((void *)vnh);
}





typedef void * pal_mutex_t;
typedef void * pal_cond_t;
typedef void * pal_icLock_t;
static inline int
pal_file_read(char *path, pal_vnodeH_t vnodeH, char *buffer, long offset, long len)
{
        return kail_file_read(path,vnodeH,buffer,offset,len);
}
extern char *pal_immunePrograms[];

extern char *pal_loginPrograms[];






extern void pal_machInit(void);
extern void pal_machShutdown(void);
extern int pal_mapOpenFlags(int);
extern void pal_fccInit(void);
extern void pal_fccShutdown(void);
extern void pal_fccFlush(void);
extern int pal_checkLoginBypassMach(char *, int, void *,void *, int32_t *);

extern void pal_errLogInit(void);
typedef oss_nwAddr_t pal_nwAddr_t;







typedef struct _pal_time {
    uint32_t secs;
    int32_t usecs;
} pal_timestruct_t;




typedef int64_t pal_time_t;
typedef oss_uid_t pal_uid_t;
typedef oss_gid_t pal_gid_t;

typedef pal_uid_t pal_authID_t;


typedef uint32_t pal_ptr32_t;
typedef struct _ids {
    pal_authID_t idVal;
    int setMask;
} pal_idSet_t;
typedef struct _idlist {
    pal_authID_t realId;
    pal_authID_t effId;
    pal_authID_t accId;


} pal_idList_t;
enum pal_ftypes { PAL_FTYPE_NONE, PAL_FTYPE_FILE, PAL_FTYPE_DIR,
             PAL_FTYPE_BLKDEV, PAL_FTYPE_CHARDEV, PAL_FTYPE_LNK,
             PAL_FTYPE_SOCK, PAL_FTYPE_BAD, PAL_FTYPE_FIFO,
             PAL_FTYPE_MPC, PAL_FTYPE_OTHER};
typedef enum pal_ftypes pal_ftypes_t;
typedef struct _fattr {
    pal_authID_t uid;
    pal_authID_t gid;
    pal_ftypes_t ftype;
    pal_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    pal_dev_t dev;
    pal_vfs_val_t check_vfsp;
} pal_fattr_t;
typedef struct _rfid {
    uint32_t ctime;
    pal_fsid_t fsid;
    pal_fid_t fid;
} pal_rawFid_t;
typedef struct pal_ph {
    char *path;
    char *pbuf;
    int pathLen;
    int pbLen;
    int flags;
} pal_pathBuf_t;
extern int pal_sysMemMB;
typedef char * pal_pathMemInfo_t;
extern char *pal_readSymLink(char *, int *);





extern void pal_delay(int);
extern int pal_kthreadCreate(void (*)(), void *, char *);
extern pal_authID_t pal_getEGid(void);







extern void pal_logErrMach(char *, int);
typedef char * sharedMemPtr_t;
extern char *pal_alloc(size_t);
extern void pal_free(void *, size_t);



extern void pal_getAllocInfo(int *, size_t *);
extern void pal_logErr(int, char *);
extern int pal_copyin(char *, char *, size_t);
extern int pal_copyinstr(char *, char *, size_t, size_t *);
extern int pal_copyout(char *, char *, size_t);
extern int pal_decomposePath(char *, int, pal_rawFid_t *, int *,
                        pal_rawFid_t *, int *, pal_fattr_t *, pal_vnodeH_t *);
extern int pal_LookupFidAndDir(char *, int, pal_rawFid_t *,
                               pal_rawFid_t *, pal_fattr_t *, int *);
extern int pal_vnodesToFids(pal_vnodeH_t, pal_vnodeH_t,
                            pal_rawFid_t *, pal_rawFid_t *, pal_rawFid_t **,
                            int *, pal_fattr_t *);
extern int pal_pathToFullPath(char *, int, pal_pathBuf_t *);
extern int pal_dirFidToPathFids(pal_rawFid_t *, pal_rawFid_t **, int *);
extern int pal_unixDescToRawFid(int, pal_rawFid_t *);
extern pal_vnodeH_t pal_unixDescToVnode(int);
extern int pal_unixDescToBaseName(int, pal_vnodeH_t, pal_pathBuf_t *);
extern int pal_unixDescIsCOE(int);



extern int pal_suser(void);
extern pal_authID_t pal_getEuid(void);
extern void pal_getREUids(pal_idList_t *);
extern void pal_holdVnode(pal_vnodeH_t);
extern void pal_releVnode(pal_vnodeH_t);
extern int pal_pinMem(void *, size_t);
extern int pal_unpinMem(void *, size_t);
extern int pal_getLocalTermDevice(char *, int, pal_dev_t *);
int pal_checkInheritLoginState(char *, uint32_t, int32_t, int32_t *);
int pal_execChecking(char *, int32_t *, uint32_t *, uint32_t *);
void pal_loginOriginWasReset(int32_t *);
extern int pal_checkLoginBypass(char *, int,
                                pal_idSet_t *, pal_idList_t *, int32_t *);
extern int32_t pal_devToInt32(pal_dev_t);
extern int pal_isImmunePath(char *);
extern int pal_expandExecArgs(void *, char *, int, int);


extern int pal_lookupFidsAndInfo(char *, int, pal_rawFid_t *,
        pal_rawFid_t *, pal_fattr_t *, pal_vnodeH_t *, pal_vnodeH_t *, int *);
extern int pal_pathFidsFromDirVnh(pal_vnodeH_t, pal_rawFid_t *, int *);
extern int pal_file_read(char *,pal_vnodeH_t,char *, long, long);





extern void pal_init(void);
extern void pal_shutdown(void);
typedef void * kenv_pathReqHandle_t;







typedef struct kenv_pathMemInfo {
    kenv_pathReqHandle_t handle;
    uint16_t pathFlags, palFlags;
    uint32_t memSerial;
    pal_pathMemInfo_t palInfo;
} kenv_pathMemInfo_t;

extern int kenv_pathMemInit(int, uint32_t, uint32_t);
extern int kenv_pathMemFini(void);

extern uint32_t kenv_pathGetMemSerial(void);
extern int kenv_pathMemCurrent(uint32_t serial);
extern int kenv_pathMemService(void);
extern int kenv_pathMemHelper(int, uint32_t *);
extern void kenv_pathMemStop(int shutdown);

extern int kenv_pathMemGet(char *, int, kenv_pathMemInfo_t *);
extern int kenv_pathMemWaitReady(kenv_pathMemInfo_t *);
extern void kenv_pathMemCancel(kenv_pathReqHandle_t);
extern int kenv_pathMemPut(void *, kenv_pathMemInfo_t *);
extern uint32_t kenv_pathMemOffset(kenv_pathReqHandle_t);


extern int kenv_pathGetShmid(void);



extern int kenv_pathDebug;
typedef uint32_t kenv_procFlags_t;
typedef struct kenv_procPidList {
    pal_pid_t *pids;
    int listAllocSize;
} kenv_procPidList_t;

typedef struct procStats {
    uint32_t procAdds;
    uint32_t activeProcs;
    uint32_t fdTableGrows;
    uint32_t hashBoosts;
} kenv_procStats_t;



extern kenv_procStats_t kenv_procStats;

extern void kenv_procAdd(pal_pid_t, pal_pid_t, int);
extern int kenv_procConditionalAdd(pal_pid_t, pal_pid_t, int);
extern int kenv_procDelete(pal_pid_t);
extern int kenv_procSetProgramData(pal_pid_t, pal_rawFid_t *, pal_rawFid_t *,
                                   pal_fattr_t *, char *, kenv_procFlags_t *,
                                   int);
extern int kenv_procGetProgramInfo(pal_pid_t, char *,
                                   int *, pal_rawFid_t *,
                                   pal_fattr_t *,
                                   pal_rawFid_t *, int *);
extern int kenv_procRegisterPid(pal_pid_t);
extern int kenv_procIsPrivPid(pal_pid_t);
extern int kenv_procGetInfo(pal_pid_t, kenv_procFlags_t *,
                            pal_idList_t *, pal_rawFid_t *);
extern int kenv_procGetInfoExt(pal_pid_t, kenv_procFlags_t *,
                               pal_idList_t *, void **);
extern int kenv_procGetProcPPid(pal_pid_t, pal_pid_t *);
extern int kenv_procGetInfoNotPar(pal_pid_t, void *, kenv_procFlags_t *,
                                  pal_idList_t *, pal_rawFid_t *);
extern pal_pid_t kenv_procGetFlagsAndIds(kenv_procFlags_t *, pal_idList_t *);
extern pal_pid_t kenv_procGetFlagsAndIdsExt(kenv_procFlags_t *, pal_idList_t *,
                                            void **);
extern int kenv_procGetProgramFid(pal_pid_t,
                            pal_rawFid_t *, pal_rawFid_t *, pal_fattr_t *);
extern int kenv_procAddProcFlags(pal_pid_t, kenv_procFlags_t *);
extern int kenv_procDelProcFlags(pal_pid_t, kenv_procFlags_t, int);
extern int kenv_procSetImpId(pal_pid_t, pal_authID_t);
extern int kenv_procAddFd(pal_pid_t, int, void *);
extern void kenv_procCloseFd(pal_pid_t, int);
extern void kenv_procLazyCloseFd(pal_pid_t, int);
extern pal_vnodeH_t kenv_procGetFdDirVnode(pal_pid_t, int);
extern void kenv_procCloseAllFdesc(pal_pid_t, int);
extern void kenv_procSetFdFlags(pal_pid_t, int, int);
extern void kenv_procDupFd(pal_pid_t, int, int);
extern int kenv_procGetRterm(pal_pid_t, pal_nwAddr_t *);
extern int kenv_procCheckSetRterm(pal_pid_t, pal_nwAddr_t *);
extern int kenv_procCheckGetRterm(pal_pid_t, pal_nwAddr_t *);
extern void kenv_procPurgeStale(int);
extern void kenv_procUpdateAccId(pal_pid_t, pal_authID_t);

extern int kenv_procAddProcFlagsByName(char *, pal_rawFid_t *,
                                       kenv_procFlags_t, int);
extern int kenv_procGetRegisteredCount(void);
extern void kenv_procFdCloseAll(void);
extern int32_t kenv_procGetLoginState(pal_pid_t);
extern void kenv_procSetLoginState(pal_pid_t, int32_t);
extern void kenv_procSetDirectLoginID(pal_pid_t, pal_authID_t);
extern int kenv_procGetDirectLoginID(pal_pid_t, pal_authID_t *);
extern int kenv_procSetLocalTerm(pal_pid_t, char *, int);
extern int kenv_procGetTrueAccId(pal_pid_t, pal_authID_t *);
extern int kenv_procGetPidList(kenv_procPidList_t **, kenv_procFlags_t);
extern void kenv_procFreePidList(kenv_procPidList_t *);
extern void kenv_procFreeAllLazyCloses(void);
extern int kenv_procIncStreamCount(pal_pid_t);
extern int kenv_procDecStreamCount(pal_pid_t, void *);




extern int kenv_procClearExecData(pal_pid_t);
extern void kenv_procClearExecMem(void *);
extern void kenv_procSavePutMemInfo(kenv_pathMemInfo_t *);
extern void kenv_procResetSharedMem(pal_pid_t);
extern sharedMemPtr_t kenv_procGetPathMem(char *,int,kenv_pathMemInfo_t *,
                                          int *);
extern void kenv_procPutPathMem(void *, kenv_pathMemInfo_t *);
extern int kenv_procCheckShmat(void *, kenv_pathMemInfo_t *);
extern int kenv_procIsCopyShmid(int);

extern void kenv_procInit(void);
extern void kenv_procShutdown(void);
typedef struct kutil_q {
    struct kutil_q *next;
    struct kutil_q *prev;
} kutil_q_t, kutil_qHead_t;
typedef struct kpc_resFlags {






    int isLoginPgm:1;

    int isSecPgm:1;


    int isSecFile:1;

    int isXdmPgm:1;

    int isImpersonator:1;




    int hasAcl:1;


    int isTCB:1;



    int hasCond:1;






    int isWC:1;







    int isPrivPgm:1;


    int isTerminal:1;




    int defToNWTerm:1;
    int hasViaPgm:1;

    int hasTod:1;

    int condOther:1;



    int isRootDir:1;

    int isImSurPgm:1;


    int isVia:1;


    int hasPop:1;

    int hasAuthz:1;
} kpc_resFlags_t;
extern uint32_t kutil_kossInitTime;

extern void kutil_freeStringWithLocal(char *, char *, int);
extern int kutil_setStringWithLocal(char *, int *, char *, int, char **);
extern char *kutil_prefixString(char *, int, char *, int *, int);

extern void kutil_pathBaseName(char *);
extern char * kutil_pathExtractBaseName(char *);
extern void kutil_pathToDotPath(char *, int);

extern char* kutil_pathToDotPathAndLeaf(char *, int);

extern void kutil_pathToDotDotPath(char *, int);
extern int kutil_pathCleanupTail(char *, int *);
extern int kutil_commonInit(void);
extern int kutil_commonShutdown(void);




extern void kutil_privInit(void);
extern void kutil_privShutdown(void);
extern int kutil_privCheck(int, pal_authID_t);
extern int kutil_isPrivUid(pal_authID_t);
typedef void (*kpc_res_rele_func_t)(void *);
typedef struct kpcInfo {
    struct kpcInfo *next;
    struct kpcInfo *prev;
    char *resName;
    kpc_resFlags_t resFlags;
    uint32_t kpcFlags;
    uint32_t branchId;
    byte_t *extData;
    uint16_t resNameLen;
    uint16_t extDataLen;
    union {
        struct __f {
            pal_rawFid_t *poFid;
            pal_ftypes_t poFtype;
            int32_t kpcFileAddGen;
            pal_rawFid_t __poFid;
        } f;
        struct __nw {
            int64_t policyVersion;
            pal_ptr32_t pUserRes;
            void *pRes;
            kpc_res_rele_func_t relef;
        } nw;
    } resData;

    char __resName[48];
} kenv_kpcInfo_t;
typedef struct filetgt {
    char *trappedNameRef;
    char *baseName;
    pal_pathBuf_t *fullSrnRef;
    pal_rawFid_t *dir_rfidp;
    pal_rawFid_t *pathFids;
    pal_vnodeH_t dir_vnh;
    pal_vnodeH_t vnh;
    struct filetgt *auxFile;
    int tnLen;
    int pathFidsCount;
    int pathFidsAlloced;
    pal_rawFid_t rfid;
    pal_fattr_t fattrs;
    pal_pid_t killPid;


    void *tgt_nd;
    void *aux_tgt_nd;


    pal_rawFid_t _fids[5];
} kenv_fileTgt_t;






typedef struct pgmInfo {
    kenv_procFlags_t procFlags;
    char *pgmSRN;
    char *pgmKPON;
    pal_rawFid_t pgmFid;
    pal_rawFid_t pgmDFid;
    pal_fattr_t pgmFattrs;
    struct pgmInfo *saveArea;
    int16_t __srnLen;
    int16_t __kponLen;
    char __srn[32];
    char __kpon[32];
} pgmInfo_t;
typedef void * kenv_envHandle_t;

typedef struct kenv_env {
    int magic;
    uint32_t flags;
    pal_pid_t pid;
    int envError;



    union {



        struct {
            kenv_fileTgt_t f;
            pal_idSet_t idSet;
            pal_dev_t termDev;
            char *localTermName;
            pal_nwAddr_t nwTermAddr;
            byte_t *termExtData;
            int termExtDataLen;
        } fs;



        struct {
            pal_nwAddr_t addrRemote;
            pal_nwAddr_t addrLocal;
        } nw;
    } tgt;




    pal_idList_t idList;




    pgmInfo_t accPgm;




    int kpcInfoCount;
    kenv_kpcInfo_t *kpcInfoHead;
    kenv_kpcInfo_t *curKPCInfo;
    kenv_kpcInfo_t _kpcInfo;



    void *auxDatap1;
} kenv_env_t;
extern pal_authID_t kenv_envGetAuthID(kenv_envHandle_t);
extern pal_idList_t *kenv_envGetIdListRef(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetRawFid(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetPathFids(kenv_envHandle_t, int *);
extern void kenv_envSetPathFids(kenv_envHandle_t, int, pal_rawFid_t *);
extern void kenv_envSetRfid(kenv_envHandle_t, pal_rawFid_t *, pal_fattr_t *);
extern void kenv_envSetFattr(kenv_envHandle_t, pal_fattr_t *);
extern pal_fattr_t *kenv_envGetFattr(kenv_envHandle_t);
extern void kenv_envSetKPCInfo(kenv_envHandle_t , kenv_kpcInfo_t *);
extern kenv_kpcInfo_t * kenv_envGetKPCInfo(kenv_envHandle_t);
extern void kenv_envResetKPCInfo(kenv_envHandle_t);
extern void kenv_envSetNextKPCInfo(kenv_envHandle_t);
extern void kenv_envSetFirstKPCInfo(kenv_envHandle_t);
extern void kenv_envResetKPCInfoResName(kenv_envHandle_t,
                                        kenv_kpcInfo_t *, char *, int);
extern char * kenv_envGetProgram(kenv_envHandle_t);
extern pal_rawFid_t *
        kenv_envGetPgmFidAndDirFid(kenv_envHandle_t,
                                   pal_rawFid_t **, pal_fattr_t **);
extern char *kenv_envSetPgmResource(kenv_envHandle_t, char *, int);
extern char *kenv_envGetPgmResource(kenv_envHandle_t);
extern void kenv_envSetAuxFileActive(kenv_envHandle_t, int);
extern char *kenv_envGetTrappedName(kenv_envHandle_t, int *);
extern char *kenv_envGetBaseName(kenv_envHandle_t);
extern void kenv_envSetImpProcAccId(kenv_envHandle_t, pal_authID_t);
extern void kenv_envProgramExecUpdate(kenv_envHandle_t);
extern void kenv_envSaveProgramState(kenv_envHandle_t);
extern void kenv_envRestoreProgramState(kenv_envHandle_t);
extern void kenv_envTrackOpenFd(kenv_envHandle_t, int, int);
extern int kenv_envGetFdInfo(kenv_envHandle_t, int);
extern void kenv_envGetTerminals(kenv_envHandle_t,
                                 pal_dev_t **, pal_nwAddr_t **);
extern pal_dev_t *kenv_envGetTermDev(kenv_envHandle_t);
extern char *kenv_envSetLocalTermName(kenv_envHandle_t, char *);
extern byte_t *kenv_envSetTermExtData(kenv_envHandle_t, int, byte_t *);
extern byte_t *kenv_envGetTermExtData(kenv_envHandle_t, int *);
extern pal_nwAddr_t *kenv_envGetNWTerm(kenv_envHandle_t);
extern void kenv_envResetTargetData(kenv_envHandle_t, int);
extern char *kenv_envFdToBname(kenv_envHandle_t);
extern pal_pathBuf_t *kenv_envGetFullSrnRef(kenv_envHandle_t);
extern void kenv_envSetFullSrnRef(kenv_envHandle_t, pal_pathBuf_t *);
extern pal_rawFid_t *kenv_envBuildPathFids(kenv_envHandle_t, int *);
extern pal_rawFid_t *kenv_envGetDirRawFid(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetFidsAndFattrs(kenv_envHandle_t,
                                              pal_rawFid_t **, pal_fattr_t **);

extern int kenv_envSetKPCCurrent(kenv_envHandle_t, char *);




extern void kenv_envSetTrappedNameRef(kenv_env_t *, char *, int);
extern void kenv_envInit(kenv_env_t *);
extern void kenv_envClean(kenv_env_t *);
extern int kenv_envProcessTrappedPath(kenv_env_t *, int);
extern int kenv_envProcessAuxPath(kenv_env_t *, char *, int, int);
extern void kenv_envUpdateACLInfo(kenv_env_t *);
extern void kenv_envInitialize(void);
extern void kenv_envShutdown(void);
extern kenv_env_t *kenv_envAllocEnv(void);
extern void kenv_envFreeEnv(kenv_env_t *);
typedef struct kaud_auditEventInfo {
    uint32_t flags;



    uint32_t kaud_magic;
    uint32_t event_id;
    uint32_t aud_fail_status;
    uint32_t aud_report_flags;
    uint32_t aud_qualifier;
    uint32_t aud_permissions;
    uint16_t aud_view;
    uint16_t aud_action;
    uint16_t aud_reason;
    uint16_t aud_outcome;
    uint16_t aud_resource_type;
    int64_t aud_accessor_uid ;
    int64_t aud_target_id ;
    int64_t aud_accessor_pid ;
    int64_t aud_accessor_eff_id ;
    int64_t aud_accessor_real_id ;




    uint32_t aud_nw_flags;
    oss_nwAddr_t aud_local_conn;
    oss_nwAddr_t aud_remote_conn;
    oss_nwAddr_t aud_remote_login_term;



    char aud_target_pon[256];
    char aud_target_srn[256];
    char aud_branch_name[80];
    char aud_local_term[80];
    char aud_accessor_name[24];
    char aud_program_name[256];




} kaud_auditEventInfo_t;
extern int kaud_syscall(pal_scall_parm_t, pal_scall_parm_t,
                        pal_scall_parm_t, pal_scall_parm_t,
                        pal_scall_parm_t, int *);


extern int kaud_setAuditLevel(int32_t);




extern int kaud_intTraceFlags;
extern int kaud_checkTrace;
extern int kaud_doLogoutAudit;
extern int kaud_eucTraceUsers;
typedef struct kaud_auditServInfo {
   uint32_t event_id;
   uint32_t aud_view;
   uint64_t aud_action;
   uint32_t aud_reason;
   uint32_t aud_outcome;
   uint32_t aud_fail_status;
   uint32_t aud_resr_type;
   uint32_t pol_flags;
   uint64_t pol_epoch;
   uint64_t pol_version;
} kaud_auditServInfo_t;
extern int kaud_expandSRN;
extern int32_t kaud_audit_level;
extern int32_t kaud_warning_mode;

extern int kaud_auditService(kaud_auditServInfo_t*);
extern int kaud_logUserAuditEvent(kaud_auditEventInfo_t *);
extern int kaud_auditTraceEvent(kenv_envHandle_t, int, int, int);
extern int kaud_eucAdd(pal_authID_t uid, uint32_t states);
extern int kaud_eucDel(pal_authID_t uid);
extern int kaud_eucDump(pal_authID_t *, uint32_t *, int);
extern void kaud_auditLogout(pal_authID_t,pal_pid_t,int,char *,pal_nwAddr_t *);

extern void kaud_init(void);
extern void kaud_shutdown(void);
typedef void *kt_chanID_t;

typedef struct _kt_chan {
    uint32_t active;
    pal_mutex_t lock;
    char name[40];
} kt_channel_t;
extern kt_channel_t kt_defChannels[];

extern void kt_logString(int, char *);
extern void kt_Event0(kt_chanID_t, int, unsigned int);
extern void kt_Event1(kt_chanID_t, int, unsigned int, long);
extern void kt_Event2(kt_chanID_t, int, unsigned int, long, long);
extern void kt_Event3(kt_chanID_t, int, unsigned int, long, long, long);
extern void kt_Event4(kt_chanID_t, int, unsigned int, long, long, long, long);
extern void kt_Event5(kt_chanID_t, int, unsigned int,
                      long, long, long, long, long);
extern void kt_zeroLog(void);
extern void kt_setChannelActive(char *, int);
extern void kt_intError(int, int, int, int);
extern void kt_init(void);
extern void kt_shutdown(void);
typedef struct kaznStats {
    int32_t accAllowedCalls;
    int32_t checkAccessCalls;
    int32_t totalGrants;
    int32_t totalDenies;
    int32_t rcGrants;
    int32_t privGrants;
    int32_t padA;
    int32_t loginIdSets;
    int32_t secIdSets;
    int32_t noTrustDenies;
    int32_t impSetId;
    int32_t padB;
    int32_t pdosdCalls;
    int32_t pdosdActiveCalls;
    int32_t pdosdFileCalls;
    int32_t pdosdIdCalls;
    int32_t pdosdNetCalls;
    int32_t pdosdLoginCalls;
    int32_t pdosdFail;
    int32_t pdosdGrantError;
    int32_t pdosdDenyError;
    int32_t pdosdGrantAudit;
    int32_t pdosdDenyAudit;
    int32_t pdosdSlowCalls;
    int32_t pdosdTimeOuts;
    int32_t pdosdBusy;
    int32_t pdosdInWarning;
} kaznStats_t;




extern kazn_expandSRN;
typedef int kazn_aznResult_t;
extern kaznStats_t kaznStats;

extern char *kazn_grantStr;
extern char *kazn_denyStr;

extern int kazn_accessAllowed(kenv_envHandle_t, int, int, int);
extern kazn_aznResult_t kazn_checkAccess(kenv_envHandle_t, int, int, int);
extern void kazn_kpcUpdateLastNotify(void);
extern int kazn_setGrantSuserOnError(int);
extern void kazn_expandTrappedFilePath(kenv_envHandle_t, kenv_kpcInfo_t *,
                                       int, pal_pathBuf_t *);
extern void kazn_init(void);
extern void kazn_shutdown(void);
typedef struct loginData {
    int32_t callerFlags;
    int32_t global_audit;
    int32_t loginLocType;
    int32_t activeLogins;



    int32_t activeLoginsOnTerm;




    char loginPgmKPON[256];
    union {
        char localTermKPON[128];
        oss_nwAddr_t nwTermAddr;
    } termInfo;
} kosseal_loginData_t;
extern int kutil_kossDebugFlag;
extern int kutil_kossActive;
extern int32_t kutil_optionalTraps;







extern int kutil_kossChecksum;




extern kutil_kconfig(pal_scall_parm_t, pal_scall_parm_t,
                       pal_scall_parm_t, pal_scall_parm_t, pal_scall_parm_t,
                       int *);
int
kutil_setStringWithLocal(
    char *inStr,
    int *inOutLen,
    char *lclStr,
    int lclStrLen,
    char **outStr)
{
    char *strp = lclStr;
    int len = *inOutLen;
    int rc = 0;






    if (len == 0) {
        len = strlen(inStr);
    }

    if (!lclStr || (len >= lclStrLen)) {
        strp = pal_alloc(len + 1);
    }

    if (strp) {
        memcpy(strp,inStr,len + 1);
        *inOutLen = len;
        *outStr = strp;
    } else {
        *inOutLen = 0;
        rc = ENOMEM;
    }
    return rc;
}
void
kutil_freeStringWithLocal(char *inStr, char *lclStr, int inLen)
{
    if (inStr == lclStr) {
        return;
    }

    ;

    if (inLen == 0) {
        inLen = strlen(inStr);
    }
    pal_free(inStr, inLen + 1);
}
char *
kutil_prefixString(
    char *prefix,
    int prefixLen,
    char *tbuf,
    int *bufSpace,
    int addSlash)
{
    int insLen = prefixLen, space = *bufSpace;

    ;

    if (insLen == 0) {
        insLen = strlen(prefix);
    }
    if (addSlash) {
        insLen++;
    }

    ;
    if (insLen > space) {
        return NULL;
    }

    *bufSpace = space - insLen;
    if (addSlash) {
        *(--tbuf) = '/';
        --insLen;
    }
    tbuf -= insLen;
    memcpy(tbuf,prefix,insLen);

    return tbuf;
}
int
kutil_commonInit(void)
{
    int rc = 0;


    (void)pal_pinMem(&kutil_kossActive, sizeof(kutil_kossActive));
    kt_init();
    kenv_envInitialize();
    kenv_procInit();
    kutil_privInit();
    kazn_init();
    kaud_init();

    return rc;
}
int
kutil_commonShutdown(void)
{
    int rc = 0;


    (void)pal_unpinMem(&kutil_kossActive, sizeof(kutil_kossActive));
    kaud_shutdown();
    kutil_privShutdown();
    kenv_procShutdown();
    kenv_envShutdown();
    kazn_shutdown();
    kt_shutdown();

    return rc;
}
