
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *
 * IBM Tivoli Access Manager for Operating Systems 6.0.0
 * 5698-PDO
 * Licensed Materials - Property of IBM
 * 
 * (C) Copyright IBM Corp. 2000,2006. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 *
*/

static char sccsid[] = "@(#)81       1.49  src/oss/kazn/kail/kail_kernel_interface.c, oss.kazn.src, oss600, 070720c 8/9/07 13:34:18";
static const char oss_copyright[] =

"5698-PDO\n"
"Licensed Materials - Property of IBM\n"
"\n"
"(C) Copyright IBM Corp. 2000,2007. All Rights Reserved.\n"
"\n"
"US Government Users Restricted Rights - Use, duplication or\n"
"disclosure restricted by GSA ADP Schedule Contract with\n"
"IBM Corp.\n"

;
static const char oss_product[] = "IBM Tivoli Access Manager for Operating Systems Runtime";

static const char oss_version_full[] =
    "6"
    ".0"
    ".0"
    ".9"
    " (070720c)";

static const char oss_version_release[] =
        "6"
        ".0"
        ".0";

static const char oss_version_product[] =
        "6"
        ".0";
 static const char *kailBuildInfo = oss_version_full;
#include <linux/version.h>
#include <linux/module.h>

#include <linux/kernel.h>


#include <linux/types.h>

#include <linux/slab.h>

#include <linux/vmalloc.h>

#include <linux/smp_lock.h>

#include <linux/sched.h>

#include <linux/file.h>

#include <linux/fs.h>


#include <linux/wait.h>

#include <linux/namei.h>

#include <linux/list.h>

#include <linux/mount.h>

#include <linux/ptrace.h>

#include <linux/pid.h>

#include <linux/fs_struct.h>




#include <net/sock.h>

#include <asm/atomic.h>

#include <asm/semaphore.h>

#include <asm/current.h>

#include <asm/uaccess.h>


#include <linux/nfs_fs.h>
typedef struct kail_vfs
{
    void *mnt;
    void *mnt_parent;
    char devname[64];
} kail_vfs_t;






typedef struct {
        long val[2];
} kail_fsid_t;

typedef struct kail_fid {
    uint32_t fid_ino;
    uint32_t fid_gen;
    uint16_t fid_flags;
    uint16_t fid_data_len;

    char fid_data[(sizeof(char) * 64)];
} kail_fid_t;

typedef mode_t kail_fmode_t;
typedef dev_t kail_dev_t;
typedef void * kail_vnodeH_t;
typedef struct _kail_rfid {
    uint32_t ctime;
    kail_fsid_t fsid;
    kail_fid_t fid;
} kail_rawFid_t;
typedef struct _kail_cred {

        uid_t uid,euid,suid,fsuid;
        gid_t gid,egid,sgid,fsgid;
        int ngroups;
        int cr_ref;
        gid_t groups[32 ];
} kail_cred_t;

typedef int64_t kail_authID_t;
enum kail_ftypes { KAIL_FTYPE_NONE, KAIL_FTYPE_FILE, KAIL_FTYPE_DIR,
             KAIL_FTYPE_BLKDEV, KAIL_FTYPE_CHARDEV, KAIL_FTYPE_LNK,
             KAIL_FTYPE_SOCK, KAIL_FTYPE_BAD, KAIL_FTYPE_FIFO,
             KAIL_FTYPE_MPC, KAIL_FTYPE_OTHER};
typedef enum kail_ftypes kail_ftypes_t;

typedef struct _kail_fattr {
    kail_authID_t uid;
    kail_authID_t gid;
    kail_ftypes_t ftype;
    kail_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    dev_t dev;
    kail_vfs_t check_vfsp;
} kail_fattr_t;




extern volatile struct timespec *kail_xtime;





extern asmlinkage int (*kail_printk)(const char *, ...);
extern asmlinkage int (*kail_sprintf)(char * buf, const char * fmt, ...);
extern asmlinkage int (*kail_do_fork)(unsigned long, unsigned long, struct pt_regs *, unsigned long);


extern asmlinkage int kail_kernel_thread(int (*)(void *), void *,unsigned long);
extern asmlinkage int kail_kill_proc(pid_t, int, int);
extern asmlinkage long kail_strncpy_from_user(char *, const char *, long);
extern asmlinkage long kail_strncpy_from_DND(char *, void *, long);
extern unsigned long FASTCALL(kail_copy_to_user(void *, const void *, unsigned long));
extern unsigned long FASTCALL(kail_copy_from_user(void *, const void *, unsigned long));

extern void FASTCALL(kail_kernel_free(void *,unsigned long));
extern void * FASTCALL(kail_kernel_malloc(unsigned long));





extern asmlinkage void kail_mutex_init(void **);
extern void FASTCALL(kail_mutex_lock(void **));
extern int FASTCALL(kail_mutex_trylock(void **));
extern void FASTCALL(kail_mutex_unlock(void **));
extern asmlinkage void kail_mutex_destroy(void **);

extern asmlinkage void kail_cond_init(void **);
extern void FASTCALL(kail_wake_up(void **));
extern void FASTCALL(kail_cond_wait(void **, void **));
extern int FASTCALL(kail_cond_wait_intr(void **, void **));
extern asmlinkage int kail_condTimedWait(void **, void **, int64_t, int);
extern asmlinkage void kail_cond_destroy(void **);

extern asmlinkage void kail_iclock_init(void **);
extern void FASTCALL(kail_iclock_lock(void **));
extern void FASTCALL(kail_iclock_unlock(void **));
extern int FASTCALL(kail_iclock_trylock(void **));
extern asmlinkage void kail_iclock_destroy(void **);

extern void FASTCALL(kail_iclock_cond_wait(void **,void **));

extern asmlinkage int kail_current_pid(void);
extern asmlinkage int kail_current_tid(void);
extern asmlinkage int kail_current_Ppid(void);
extern int FASTCALL(kail_tid_to_pid(int));
extern pid_t FASTCALL(kail_pid_get_epid(pid_t));
extern void FASTCALL(kail_pid_delete(pid_t));
extern void FASTCALL(kail_epid_delete(pid_t));
extern void FASTCALL(kail_pid_add(pid_t,pid_t));


extern asmlinkage int kail_current_uid(void);
extern asmlinkage int kail_current_euid(void);
extern asmlinkage int kail_current_suid(void);
extern asmlinkage int kail_current_gid(void);
extern asmlinkage int kail_current_egid(void);
extern int FASTCALL(kail_current_files_close_on_exec(int));

extern asmlinkage int kail_socket_protocol(void *);
extern asmlinkage int kail_socket_getname(void *,void *,int *,int);

extern int FASTCALL(kail_fd_to_dev(int, dev_t *));
extern int FASTCALL(kail_fd_to_name(int, char **, int *));
extern int FASTCALL(kail_fd_to_socket(int,void **));

extern int FASTCALL(kail_socket_shutdown(void *));




extern int FASTCALL(kail_check_pid(int));
extern int FASTCALL(kail_get_pid_pgrp(int,int *));
extern int FASTCALL(kail_get_pid_uid(int,int *,int *));
extern void FASTCALL(kail_scan_procs(void *));

extern asmlinkage void kail_daemonize(const char *);
extern asmlinkage int kail_total_ram_mb(void);
extern void FASTCALL(kail_atomic_add(int,void *));

extern asmlinkage int kail_kernel_address_mode(void);






extern asmlinkage int kail_decomposePath(char *, int, kail_rawFid_t *, int *, kail_rawFid_t *, int *, kail_fattr_t *, kail_vnodeH_t *);
extern asmlinkage int kail_LookupFidAndDir(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, int *);
extern asmlinkage int kail_lookupFidsAndInfo(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, kail_vnodeH_t *, kail_vnodeH_t *, int *);
extern asmlinkage int kail_dirFidToPathFids( kail_rawFid_t *, kail_rawFid_t **, int *);
extern asmlinkage int kail_unixDescToRawFid( int , kail_rawFid_t *);
extern asmlinkage int kail_vnodesToFids( kail_vnodeH_t, kail_vnodeH_t, kail_rawFid_t *, kail_rawFid_t *, kail_rawFid_t **, int *, kail_fattr_t *);
extern asmlinkage int kail_makeFidChain(void *, kail_rawFid_t *, int *, const kail_cred_t *, int );

extern asmlinkage int kail_copy_exec_argv(void *, char *, int);


struct group_info;
extern gid_t * FASTCALL(kail_groups_blocks(struct group_info *,int));
extern int FASTCALL(kail_groups_ngroups(struct group_info *));
extern int FASTCALL(kail_groups_nblocks(struct group_info *));







struct kail_register_chrdev_parameters {
        unsigned int dev_number;
        char *name;
        void *ownerp;
        void *readp;
        void *writep;
        void *ioctlp;



        void *openp;
        void *releasep;
        unsigned int ioctl_cnt;
        unsigned int *ioctl_cmds;
} ;

extern asmlinkage int kail_register_chrdev(struct kail_register_chrdev_parameters *, void **);
extern asmlinkage int kail_unregister_chrdev(struct kail_register_chrdev_parameters *, void *);
extern int FASTCALL(kail_minor(void *));

extern asmlinkage int kail_file_read(char *, kail_vnodeH_t *,char *, long, long);
extern asmlinkage void kail_write_log(const char *,const char *, int, int);
extern asmlinkage void kail_log_init(const char *);

extern asmlinkage int kail_pathToFullPath( char *, int , char **, char *,int);
extern void * FASTCALL(kail_unixDescToVnode(int));
extern void FASTCALL(kail_releVnode(void *));
extern void FASTCALL(kail_holdVnode(void *));
extern asmlinkage char * kail_readSymLink(char *, int *);



extern asmlinkage int kail_vfs_mounted(kail_vfs_t *);
extern asmlinkage int kail_vfs_check(kail_vfs_t *);


typedef struct {
        void *alloc;
        void *free;
        void *fcc_find;
        void *fcc_add;
} kail_call_back_t;

extern asmlinkage void kail_call_backs(kail_call_back_t *);
extern asmlinkage void kail_kernel_interface(void);
extern asmlinkage void kail_kernel_interface_shutdown(void);

typedef asmlinkage long (* sys_call_fn)();
struct kail_syscall_prepost {
        int call_index;
        sys_call_fn call_pre;
        sys_call_fn call_post;
};

extern int struct_cppath_size;

struct kail_lsmhooks {
        int lsmhook_index;
        sys_call_fn lsmhook_pre;
        sys_call_fn lsmhook_post;
};
extern asmlinkage int kail_trap_syscalls(struct kail_syscall_prepost *,struct kail_lsmhooks *);



extern asmlinkage void kail_restore_syscalls(void);

extern int change_KailPerm2ro(void);

struct nameidata;
struct kail_datanameidata {
        char cdata[4];
        char *path;
        struct nameidata *nd;
};
#define KAIL_LOOKUP_BIT 0x40000000
#if defined(LINUX_RHEL4) || defined(LINUX_SLES10) || defined(LINUX_RHEL5)
#define SET_LOOKUP_FLAG(n) (n)->intent.open.flags = KAIL_LOOKUP_BIT;
#define CLEAR_LOOKUP_FLAG(n) (n)->intent.open.flags &= ~KAIL_LOOKUP_BIT;
#define CHECK_LOOKUP_FLAG(n) ((n)->intent.open.flags == KAIL_LOOKUP_BIT)
#endif 
#ifdef LINUX_SLES9
#define SET_LOOKUP_FLAG(n)
#define CLEAR_LOOKUP_FLAG(n)
#define CHECK_LOOKUP_FLAG(n)
#endif 
struct syscall_glue_table {
        long syscall_index;
        sys_call_fn syscall_glue_pre;
        sys_call_fn syscall_glue_post;
        sys_call_fn syscall_glue_pre_post;

        sys_call_fn sys32call_glue_pre;
        sys_call_fn sys32call_glue_post;
        sys_call_fn sys32call_glue_pre_post;

};
extern struct syscall_glue_table kail_syscall_glue_list[];

struct syscall_table {
        sys_call_fn orig_syscall;
        sys_call_fn syscall_pre;
        sys_call_fn syscall_post;

        sys_call_fn orig_sys32call;

};
extern struct syscall_table kail_syscall_list[];
typedef unsigned int uid32_t;
typedef unsigned int gid32_t;
struct kail_lsmhooks_table {
        sys_call_fn lsmhooks_pre;
        sys_call_fn lsmhooks_post;
};
extern struct kail_lsmhooks_table kail_lsmhooks_list[];
struct kail_vnode_t {
        struct nameidata nd;
        int malloc;
        int count;

        spinlock_t lock;
} ;

typedef struct kail_vnode_t * kail_vnodep_t;
volatile struct timespec *kail_xtime = NULL;



EXPORT_SYMBOL(kail_xtime);


asmlinkage int (*kail_printk)(const char *, ...) = NULL;
EXPORT_SYMBOL(kail_printk);

asmlinkage int (*kail_sprintf)(char * buf, const char * fmt, ...) = NULL;
EXPORT_SYMBOL(kail_sprintf);
kail_cred_t palCred, *palCredp;

char * (*kail_pal_alloc)(size_t);
void (*kail_pal_free)(void *, size_t);
void (*kail_fcc_add)(kail_rawFid_t *, int);
int (*kail_fcc_find)(kail_rawFid_t *, kail_rawFid_t *, int *);



asmlinkage int
kail_kernel_thread(int (*f)(void *), void *p,unsigned long l)
{
        return kernel_thread(f,p,l);
}
EXPORT_SYMBOL(kail_kernel_thread);

asmlinkage int
kail_kill_proc(pid_t p, int a, int b)
{
        return kill_proc(p,a,b);
}
EXPORT_SYMBOL(kail_kill_proc);

asmlinkage long
kail_strncpy_from_DND(char *d, void *dnd, long l)
{
        struct kail_datanameidata *dndp = (struct kail_datanameidata *)dnd;
        int rc;

        strncpy(d,dndp->path,l);
        if (d[l-1] == 0)
                rc = strlen(d);
        else
                rc = l;

        return rc;
}
EXPORT_SYMBOL(kail_strncpy_from_DND);

asmlinkage long
kail_strncpy_from_user(char *d, const char *s, long l)
{
        return strncpy_from_user(d,s,l);
}
EXPORT_SYMBOL(kail_strncpy_from_user);

unsigned long
FASTCALL() kail_copy_from_user(void *to_addr, const void * from_addr, unsigned long n)
{
        return copy_from_user(to_addr,from_addr,n);
}
EXPORT_SYMBOL(kail_copy_from_user);

unsigned long
FASTCALL() kail_copy_to_user(void *to, const void *from, unsigned long n)
{
        return (copy_to_user(to,from,n));
}
EXPORT_SYMBOL(kail_copy_to_user);

asmlinkage void
kail_mutex_init(void **mp)
{
        struct semaphore * l_mp = (struct semaphore *)kmalloc(sizeof(struct semaphore),GFP_KERNEL);
        (unlikely(!(l_mp)) ? (printk("kail_assert: %s:%d\n","/project/oss600/build/oss600/src/oss/kazn/kail/kail_kernel_interface.c",397), *((char *)0) = 0,0) : 0);

        init_MUTEX(l_mp);
        *mp = l_mp;
        return;
}
EXPORT_SYMBOL(kail_mutex_init);

void
FASTCALL() kail_mutex_lock(void **mp)
{
        down((struct semaphore *)(*mp));
        return;
}
EXPORT_SYMBOL(kail_mutex_lock);

void
FASTCALL() kail_mutex_unlock(void **mp)
{
        up((struct semaphore *)(*mp));
        return;
}
EXPORT_SYMBOL(kail_mutex_unlock);

int
FASTCALL() kail_mutex_trylock(void **mp)
{
        return down_trylock((struct semaphore *)(*mp));
}
EXPORT_SYMBOL(kail_mutex_trylock);

asmlinkage void
kail_mutex_destroy(void **mp)
{
        if (*mp)
                kfree(*mp);
        return;
}
EXPORT_SYMBOL(kail_mutex_destroy);


asmlinkage void
kail_cond_init(void **cvp)
{
        wait_queue_head_t * l_cvp = (wait_queue_head_t *)kmalloc(sizeof(wait_queue_head_t),GFP_KERNEL);
        (unlikely(!(l_cvp)) ? (printk("kail_assert: %s:%d\n","/project/oss600/build/oss600/src/oss/kazn/kail/kail_kernel_interface.c",442), *((char *)0) = 0,0) : 0);

        init_waitqueue_head(l_cvp);
        *cvp = l_cvp;
        return;
}
EXPORT_SYMBOL(kail_cond_init);

void
FASTCALL() kail_wake_up(void **wq)
{
        wake_up((wait_queue_head_t *)(*wq));
        return;
}
EXPORT_SYMBOL(kail_wake_up);

void
FASTCALL() kail_cond_wait(void **cvp, void **mp)
{
        wait_queue_head_t * const l_cvp = *cvp;
        struct semaphore *const l_mp = *mp;

        DECLARE_WAITQUEUE(wait, current);
        add_wait_queue(l_cvp, &wait);

        current->state = TASK_UNINTERRUPTIBLE;

        up(l_mp);

        schedule();


        current->state = TASK_RUNNING;

        remove_wait_queue(l_cvp, &wait);

        down(l_mp);
        return;
}
EXPORT_SYMBOL(kail_cond_wait);


int
FASTCALL() kail_cond_wait_intr(void **cvp, void **mp)
{
        wait_queue_head_t * const l_cvp = *cvp;
        struct semaphore * const l_mp = *mp;
        int rc = 0;

        DECLARE_WAITQUEUE(wait, current);

        add_wait_queue(l_cvp, &wait);

        current->state = TASK_INTERRUPTIBLE;

        up(l_mp);

        schedule();

        if (signal_pending(current))
                rc = 1;


        current->state = TASK_RUNNING;

        remove_wait_queue(l_cvp, &wait);

        down(l_mp);

        return rc;
}
EXPORT_SYMBOL(kail_cond_wait_intr);
asmlinkage int
kail_condTimedWait(void **cvp, void **mp, int64_t tout, int waitFlags)
{
        wait_queue_head_t * const l_cvp = *cvp;
        struct semaphore * const l_mp = *mp;
        int rc = 0;
        const int allowIntr = waitFlags & 0x1;

        DECLARE_WAITQUEUE(wait, current);

        add_wait_queue(l_cvp, &wait);

        current->state = allowIntr ? TASK_INTERRUPTIBLE : TASK_UNINTERRUPTIBLE;

        up(l_mp);


        if (waitFlags & 0x2) {


                tout = ((tout*HZ) >> 20);
        } else {
                tout *= HZ;
        }

        rc = schedule_timeout(1 + tout);


        current->state = TASK_RUNNING;

        remove_wait_queue(l_cvp, &wait);

        down(l_mp);

        if (allowIntr) {
                if (signal_pending(current))
                        rc = 3;
        } else if (rc == 0)
                rc = 2;
        else
                rc = 1;

        return rc;
}
EXPORT_SYMBOL(kail_condTimedWait);

asmlinkage void
kail_cond_destroy(void **cvp)
{
        if (*cvp)
                kfree(*cvp);
        return;
}
EXPORT_SYMBOL(kail_cond_destroy);
asmlinkage void
kail_iclock_init(void **lp)
{
        spinlock_t * l_lp = (spinlock_t *)kmalloc(sizeof(spinlock_t),GFP_KERNEL);
        (unlikely(!(l_lp)) ? (printk("kail_assert: %s:%d\n","/project/oss600/build/oss600/src/oss/kazn/kail/kail_kernel_interface.c",623), *((char *)0) = 0,0) : 0);

        spin_lock_init(l_lp);
        *lp = l_lp;


        return;
}
EXPORT_SYMBOL(kail_iclock_init);

void
FASTCALL() kail_iclock_lock(void **lp)
{





        spin_lock((spinlock_t *)(*lp));


        return;
}
EXPORT_SYMBOL(kail_iclock_lock);

void
FASTCALL() kail_iclock_unlock(void **lp)
{





        spin_unlock((spinlock_t *)(*lp));


        return;
}
EXPORT_SYMBOL(kail_iclock_unlock);

int
FASTCALL() kail_iclock_trylock(void **lp)
{






        return spin_trylock((spinlock_t *)(*lp));




}
EXPORT_SYMBOL(kail_iclock_trylock);

asmlinkage void
kail_iclock_destroy(void **lp)
{

        if (*lp)
                kfree(*lp);

        return;
}
EXPORT_SYMBOL(kail_iclock_destroy);


void
FASTCALL() kail_iclock_cond_wait(void **cvp, void **lp)
{
        wait_queue_head_t * const l_cvp = *cvp;




        spinlock_t *const l_lp = *lp;


        DECLARE_WAITQUEUE(wait, current);
        add_wait_queue(l_cvp, &wait);

        current->state = TASK_UNINTERRUPTIBLE;






        spin_unlock(l_lp);



        schedule();


        current->state = TASK_RUNNING;

        remove_wait_queue(l_cvp, &wait);






        spin_lock(l_lp);


        return;
}
EXPORT_SYMBOL(kail_iclock_cond_wait);

asmlinkage int
kail_current_Ppid(void)
{

        return (int)(current->parent->pid);



}
EXPORT_SYMBOL(kail_current_Ppid);

asmlinkage int
kail_current_pid(void)
{
        return (int)(current->tgid);
}
EXPORT_SYMBOL(kail_current_pid);

asmlinkage int
kail_current_tid(void)
{
        return (int)(current->pid);
}
EXPORT_SYMBOL(kail_current_tid);







typedef struct pid_entry {
        struct pid_entry *epid_prev;
        struct pid_entry *epid_next;
        struct pid_entry *pid_prev;
        struct pid_entry *pid_next;
        pid_t pid;
        pid_t epid;
} pid_entry_t;

static pid_entry_t *kail_pid_entry_pool;




static pid_entry_t *kail_pid_table[512 + 1];
static pid_entry_t *kail_epid_table[512 + 1];



static void * kail_pptLock;
static void get_more_kail_pid_entries()
{
        int i;
        pid_entry_t *tmpp;

        kail_pid_entry_pool = (void *)kmalloc(sizeof(pid_entry_t) * 48,GFP_KERNEL);
        (unlikely(!(kail_pid_entry_pool)) ? (printk("kail_assert: %s:%d\n","/project/oss600/build/oss600/src/oss/kazn/kail/kail_kernel_interface.c",806), *((char *)0) = 0,0) : 0);

        ;



        kail_pid_entry_pool->pid_next = kail_pid_table[512];
        kail_pid_table[512] = kail_pid_entry_pool;
        kail_pid_entry_pool->epid_next = kail_epid_table[512];
        kail_epid_table[512] = kail_pid_entry_pool;
        kail_pid_entry_pool++;


        for (i = 1,tmpp = kail_pid_entry_pool;
                i < 48 - 1;
                        i++) {
                tmpp->pid_next = tmpp + 1;
                tmpp->epid_next = tmpp + 1;
                tmpp++;
        }


        tmpp->pid_next = NULL;
        tmpp->epid_next = NULL;

        return;
}

void pid_init()
{
        int i;

        kail_iclock_init(&kail_pptLock);
        kail_iclock_lock(&kail_pptLock);

        for (i = 0;i <= 512; i++) {

                kail_pid_table[i] = NULL;
                kail_epid_table[i] = NULL;
        }


        kail_pid_entry_pool = NULL;
        get_more_kail_pid_entries();

        kail_iclock_unlock(&kail_pptLock);

}

void pid_shutdown()
{
        int i;
        pid_entry_t *tmpp;

        kail_iclock_lock(&kail_pptLock);
        tmpp = kail_pid_table[512];


        while (tmpp) {
                pid_entry_t *to_free = tmpp;
                tmpp = tmpp->pid_next;
                kfree(to_free);
        }


        for (i = 0;i <= 512; i++) {
                kail_pid_table[i] = NULL;
                kail_epid_table[i] = NULL;
        }

        kail_pid_entry_pool = NULL;

        kail_iclock_unlock(&kail_pptLock);

        kail_iclock_destroy(&kail_pptLock);
}



static inline pid_entry_t *find_kail_pid_entry(const pid_t find_pid)
{
        pid_entry_t *tmpp = kail_pid_table[((((find_pid) >> 8) ^ (find_pid)) & (512 - 1))];

        while ((tmpp != NULL) && (tmpp->pid != find_pid))
                tmpp = tmpp->pid_next;






        ;

        return tmpp;
}



static inline pid_entry_t *find_kail_epid_entry(const pid_t find_epid)
{
        pid_entry_t *tmpp = kail_epid_table[((((find_epid) >> 8) ^ (find_epid)) & (512 - 1))];

        while ((tmpp != NULL) && (tmpp->epid != find_epid))
                tmpp = tmpp->epid_next;






        ;

        return tmpp;
}



pid_t
FASTCALL() kail_pid_get_epid(const pid_t pid)
{
        pid_entry_t *tmpp;
        pid_t epid = pid;


        kail_iclock_lock(&kail_pptLock);



        if (tmpp = find_kail_pid_entry(pid))
                epid = tmpp->epid;



        kail_iclock_unlock(&kail_pptLock);

        return epid;

}
EXPORT_SYMBOL(kail_pid_get_epid);
void
FASTCALL() kail_pid_delete(const pid_t delete_pid)
{
        pid_entry_t *tmpp;


        kail_iclock_lock(&kail_pptLock);


        if ((tmpp = find_kail_pid_entry(delete_pid)) != NULL) {
                pid_entry_t *tmpp_n, *tmpp_p;

                ;

                do { const pid_entry_t * const tmpp_this = (tmpp); const pid_t l_pid = tmpp_this->pid; const pid_t l_epid = tmpp_this->epid; pid_entry_t * const tmpp_pn = tmpp_this->pid_next; pid_entry_t * const tmpp_pp = tmpp_this->pid_prev; pid_entry_t * const tmpp_en = tmpp_this->epid_next; pid_entry_t * const tmpp_ep = tmpp_this->epid_prev; if (tmpp_pn) tmpp_pn->pid_prev = tmpp_pp; if (tmpp_pp) tmpp_pp->pid_next = tmpp_pn; if (kail_pid_table[((((l_pid) >> 8) ^ (l_pid)) & (512 - 1))] == tmpp_this) kail_pid_table[((((l_pid) >> 8) ^ (l_pid)) & (512 - 1))] = tmpp_pn; if (tmpp_en) tmpp_en->epid_prev = tmpp_ep; if (tmpp_ep) tmpp_ep->epid_next = tmpp_en; if (kail_epid_table[((((l_epid) >> 8) ^ (l_epid)) & (512 - 1))] == tmpp_this) kail_epid_table[((((l_epid) >> 8) ^ (l_epid)) & (512 - 1))] = tmpp_en; } while (0);


                tmpp->pid_next = kail_pid_entry_pool;
                kail_pid_entry_pool = tmpp;
        }


        kail_iclock_unlock(&kail_pptLock);
        return;

}
EXPORT_SYMBOL(kail_pid_delete);


void
FASTCALL() kail_epid_delete(const pid_t delete_epid)
{
        pid_entry_t *tmpp;


        kail_iclock_lock(&kail_pptLock);


        if ((tmpp = find_kail_epid_entry(delete_epid)) != NULL) {



                while ((tmpp != NULL) && (tmpp->epid == delete_epid)) {

                        ;


                        do { const pid_entry_t * const tmpp_this = (tmpp); const pid_t l_pid = tmpp_this->pid; const pid_t l_epid = tmpp_this->epid; pid_entry_t * const tmpp_pn = tmpp_this->pid_next; pid_entry_t * const tmpp_pp = tmpp_this->pid_prev; pid_entry_t * const tmpp_en = tmpp_this->epid_next; pid_entry_t * const tmpp_ep = tmpp_this->epid_prev; if (tmpp_pn) tmpp_pn->pid_prev = tmpp_pp; if (tmpp_pp) tmpp_pp->pid_next = tmpp_pn; if (kail_pid_table[((((l_pid) >> 8) ^ (l_pid)) & (512 - 1))] == tmpp_this) kail_pid_table[((((l_pid) >> 8) ^ (l_pid)) & (512 - 1))] = tmpp_pn; if (tmpp_en) tmpp_en->epid_prev = tmpp_ep; if (tmpp_ep) tmpp_ep->epid_next = tmpp_en; if (kail_epid_table[((((l_epid) >> 8) ^ (l_epid)) & (512 - 1))] == tmpp_this) kail_epid_table[((((l_epid) >> 8) ^ (l_epid)) & (512 - 1))] = tmpp_en; } while (0);


                        tmpp->pid_next = kail_pid_entry_pool;
                        kail_pid_entry_pool = tmpp;


                        tmpp = tmpp->epid_next;
                }
        }


        kail_iclock_unlock(&kail_pptLock);
        return;

}
EXPORT_SYMBOL(kail_epid_delete);


void
FASTCALL() kail_pid_add(pid_t pid,pid_t epid)
{
        int i;
        const int pid_hash = ((((pid) >> 8) ^ (pid)) & (512 - 1));
        const int epid_hash = ((((epid) >> 8) ^ (epid)) & (512 - 1));
        pid_entry_t *tmpp,*new_entry;


        kail_iclock_lock(&kail_pptLock);


        if ((tmpp = find_kail_pid_entry(pid)) != NULL) {


                ;

                do { const pid_entry_t * const tmpp_this = (tmpp); const pid_t l_pid = tmpp_this->pid; const pid_t l_epid = tmpp_this->epid; pid_entry_t * const tmpp_pn = tmpp_this->pid_next; pid_entry_t * const tmpp_pp = tmpp_this->pid_prev; pid_entry_t * const tmpp_en = tmpp_this->epid_next; pid_entry_t * const tmpp_ep = tmpp_this->epid_prev; if (tmpp_pn) tmpp_pn->pid_prev = tmpp_pp; if (tmpp_pp) tmpp_pp->pid_next = tmpp_pn; if (kail_pid_table[((((l_pid) >> 8) ^ (l_pid)) & (512 - 1))] == tmpp_this) kail_pid_table[((((l_pid) >> 8) ^ (l_pid)) & (512 - 1))] = tmpp_pn; if (tmpp_en) tmpp_en->epid_prev = tmpp_ep; if (tmpp_ep) tmpp_ep->epid_next = tmpp_en; if (kail_epid_table[((((l_epid) >> 8) ^ (l_epid)) & (512 - 1))] == tmpp_this) kail_epid_table[((((l_epid) >> 8) ^ (l_epid)) & (512 - 1))] = tmpp_en; } while (0);


                tmpp->pid_next = kail_pid_entry_pool;
                kail_pid_entry_pool = tmpp;
        }




        if (unlikely(!kail_pid_entry_pool))
                get_more_kail_pid_entries();


        new_entry = kail_pid_entry_pool;
        kail_pid_entry_pool = kail_pid_entry_pool->pid_next;


        new_entry->pid = pid;



        if (tmpp = find_kail_pid_entry(epid)) {

                epid = tmpp->pid;
        }
        new_entry->epid = epid;


        tmpp = kail_pid_table[pid_hash];
        new_entry->pid_next = tmpp;
        new_entry->pid_prev = NULL;
        if (tmpp)
                tmpp->pid_prev = new_entry;
        kail_pid_table[pid_hash] = new_entry;


        tmpp = kail_epid_table[epid_hash];
        new_entry->epid_next = tmpp;
        new_entry->epid_prev = NULL;
        if (tmpp)
                tmpp->epid_prev = new_entry;
        kail_epid_table[epid_hash] = new_entry;

        ;
;

;



        kail_iclock_unlock(&kail_pptLock);

        return;

}
EXPORT_SYMBOL(kail_pid_add);


asmlinkage int
kail_current_gid(void)
{
        return (int)(current->gid);
}
EXPORT_SYMBOL(kail_current_gid);

asmlinkage int
kail_current_egid(void)
{
        return (int)(current->egid);
}
EXPORT_SYMBOL(kail_current_egid);

asmlinkage int
kail_current_uid(void)
{
        return (int)(current->uid);
}
EXPORT_SYMBOL(kail_current_uid);

asmlinkage int
kail_current_euid(void)
{
        return (int)(current->euid);
}
EXPORT_SYMBOL(kail_current_euid);

asmlinkage int
kail_current_suid(void)
{
        return (int)(current->suid);
}
EXPORT_SYMBOL(kail_current_suid);

int
FASTCALL() kail_current_files_close_on_exec(int fd)
{
#if defined(LINUX_SLES10) || defined(LINUX_RHEL5)




#endif 

#if defined(LINUX_SLES9) || defined(LINUX_RHEL4) 

    return (FD_ISSET(fd, current->files->close_on_exec));

#endif 
}
EXPORT_SYMBOL(kail_current_files_close_on_exec);

asmlinkage int
kail_socket_protocol(void *sp)
{
    if (((struct socket *)sp)->sk)

            return (((struct socket *)sp)->sk->sk_protocol);



    else
            return -1;
}
EXPORT_SYMBOL(kail_socket_protocol);

asmlinkage int
kail_socket_getname(void *sp,void *addr,int *len,int type)
{
        return ((struct socket *)sp)->ops->getname((struct socket *)sp,(struct sockaddr *)addr,len,type);
}
EXPORT_SYMBOL(kail_socket_getname);




enum
{
  SHUT_RD = 0,
  SHUT_WR,
  SHUT_RDWR
};


int
FASTCALL() kail_socket_shutdown(void *sp)
{
        int rc = 0;






        if (sp)
                rc = ((struct socket *)sp)->ops->shutdown((struct socket *)sp, SHUT_RDWR);

        return rc;
}
EXPORT_SYMBOL(kail_socket_shutdown);


int
FASTCALL() kail_tid_to_pid(int tid)
{
        struct task_struct *tsp;
        int rc = tid;


        if (tid == current->pid)
                return (current->tgid);


        read_lock(&tasklist_lock);
        tsp = find_task_by_pid(tid);
#ifndef TASK_ZOMBIE
#define TASK_ZOMBIE EXIT_ZOMBIE
#endif





        if ((tsp != NULL) && (tsp->state != TASK_ZOMBIE))
                rc = tsp->tgid;

        read_unlock(&tasklist_lock);

        return rc;
}
EXPORT_SYMBOL(kail_tid_to_pid);


int
FASTCALL() kail_check_pid(int pid)
{
        int rc;
        struct task_struct *tsp;


        read_lock(&tasklist_lock);
        tsp = find_task_by_pid(pid);
        rc = ((tsp != NULL) && (tsp->state != TASK_ZOMBIE));

        read_unlock(&tasklist_lock);

        return rc;

}
EXPORT_SYMBOL(kail_check_pid);

int
FASTCALL() kail_get_pid_pgrp(int pid, int *pgrp)
{
        struct task_struct *tsp;
        int rc = 0;

        if (unlikely(!pgrp))
                return 0;

        if (unlikely(pid == 0)) {

                *pgrp = process_group(current);



                return 1;
        }


        read_lock(&tasklist_lock);
        tsp = find_task_by_pid(pid);
        if (tsp) {

                *pgrp = process_group(tsp);



                rc = 1;
        }
        read_unlock(&tasklist_lock);
        return rc;

}
EXPORT_SYMBOL(kail_get_pid_pgrp);

int
FASTCALL() kail_get_pid_uid(int pid, int *uidp, int *euidp)
{
        struct task_struct *tsp;
        int rc = 0;

        if (unlikely(!uidp || !euidp))
                return 0;

        if (unlikely(pid == 0)) {
                *uidp = (int) current->uid;
                *euidp = (int) current->euid;
                return 1;
        }


        read_lock(&tasklist_lock);
        tsp = find_task_by_pid(pid);
        if (tsp) {
                *uidp = (int) tsp->uid;
                *euidp = (int) tsp->euid;
                rc = 1;
        }
        read_unlock(&tasklist_lock);

        return rc;

}
EXPORT_SYMBOL(kail_get_pid_uid);
void
FASTCALL() kail_scan_procs(void *register_proc)
{
    struct task_struct *tsp,*ttsp;

    char * local_buffer = kmalloc(256,GFP_KERNEL);

    read_lock(&tasklist_lock);


    do_each_thread(ttsp,tsp)



    {
            char *exeName = NULL;
            struct vm_area_struct * vma;

            if (!tsp->mm)
                continue;

            if (tsp->uid != 0)
                    continue;


            vma = tsp->mm->mmap;


            while (vma) {
                    if ((vma->vm_flags & VM_EXECUTABLE) && vma->vm_file) {
                            exeName = d_path(vma->vm_file->f_dentry,vma->vm_file->f_vfsmnt,local_buffer,256);






                            break;
                    }
                    vma = vma->vm_next;
            }

            if (!exeName)
                    continue;

            { void (*rp)(pid_t,char *) = register_proc;
                rp(tsp->pid, exeName);
            }

    }

   while_each_thread(ttsp,tsp);


    read_unlock(&tasklist_lock);

    kfree(local_buffer);
    return;
}
EXPORT_SYMBOL(kail_scan_procs);

asmlinkage void
kail_daemonize(const char *name)
{

        daemonize(name);
        return;
}
EXPORT_SYMBOL(kail_daemonize);
asmlinkage int
kail_file_read(char *filename, kail_vnodeH_t *vnH, char *buf, long offset, long len)
{
    int rc = 0;
    struct file *fp;
    kail_vnodep_t vnp = (kail_vnodep_t)vnH;


        if (vnp) {
                do { struct dentry * const l_d = (vnp->nd.dentry); ; dget(l_d); ; } while (0);
                do { struct vfsmount * const l_m = (vnp->nd.mnt); ; mntget(l_m); ; } while (0);
                fp = dentry_open(vnp->nd.dentry,vnp->nd.mnt,O_RDONLY);
        } else {

                fp = filp_open(filename, O_RDONLY, 0600);
        }

        if ((!IS_ERR(fp)) && fp) {




                mm_segment_t fs = get_fs();
                loff_t f_pos = offset;

                set_fs(get_ds());


                rc = fp->f_op->read(fp,buf,len,&f_pos);

                set_fs(fs);


                if (vnp) {
                        fput(fp);
                } else {
                        filp_close(fp,current->files);
                }

                return rc;
        }
        else {
                return -1;
        }
}
EXPORT_SYMBOL(kail_file_read);


static struct file * err_log_fp = NULL;







static void
doLogWrite(const char *buf, int len)
{




        mm_segment_t fs = get_fs();

        set_fs(get_ds());


        if (err_log_fp->f_op->write)
                err_log_fp->f_op->write(err_log_fp,buf,len,&err_log_fp->f_pos);

        if (err_log_fp->f_op->fsync)
                err_log_fp->f_op->fsync(err_log_fp,err_log_fp->f_dentry,0);
        set_fs(fs);

        return;
}
#if defined(LINUX_SLES10) || defined(LINUX_RHEL5)




#endif 

#if defined(LINUX_SLES9) || defined(LINUX_RHEL4) 




#endif 
asmlinkage void
kail_write_log(const char * const filename,const char *msg, int len, int maxsize)
{

        if (err_log_fp) {
                struct dentry * const dentry = err_log_fp->f_dentry;
                struct inode * const inode = dentry->d_inode;

                if (unlikely(inode->i_size > maxsize)) {

                    struct iattr newattrs;
                    newattrs.ia_size = 0;
                    newattrs.ia_valid = ATTR_SIZE | ATTR_CTIME;
                    down(&(inode->i_sem));
                    if (!notify_change(dentry,&newattrs)) {
                            char wrapMsg[80];
                            up(&(inode->i_sem));
                            sprintf(wrapMsg, "%x LOG FILLED\n", (int)xtime.tv_sec);
                            doLogWrite(wrapMsg, strlen(wrapMsg));
                    }
                    else
                            up(&(inode->i_sem));
                }


                doLogWrite(msg, len);
        }
        else
                printk("kail_write_log: err_log_fp=NULL! pid=%d msg=\"%s\"\n",
                                current->pid,msg);

        return;
}
EXPORT_SYMBOL(kail_write_log);

asmlinkage void
kail_log_init(const char *filename)
{



        struct file * fp = filp_open(filename, O_CREAT|O_TRUNC|O_RDWR, 0600);
        if ((!IS_ERR(fp)) && fp) {

                filp_close(fp,current->files);
        }


        fp = filp_open(filename, O_APPEND|O_WRONLY, 0600);
        if ((!IS_ERR(fp)) && fp) {

                err_log_fp = fp;
        }
        else
                printk("kail_log_init: unable to open \"%s\"\n", filename);

        return;
}
EXPORT_SYMBOL(kail_log_init);

asmlinkage int
kail_total_ram_mb(void)
{
        struct sysinfo mem_info;
        si_meminfo(&mem_info);

        return (mem_info.totalram >> (20-PAGE_SHIFT));
}
EXPORT_SYMBOL(kail_total_ram_mb);

asmlinkage int
kail_kernel_address_mode(void)
{




        return (segment_eq(get_fs(), get_ds()));
}
EXPORT_SYMBOL(kail_kernel_address_mode);
int
FASTCALL() kail_groups_ngroups(struct group_info *grp)
{
        return(grp->ngroups);
}
EXPORT_SYMBOL(kail_groups_ngroups);

int
FASTCALL() kail_groups_nblocks(struct group_info *grp)
{
        return(grp->nblocks);
}
EXPORT_SYMBOL(kail_groups_nblocks);

gid_t *
FASTCALL() kail_groups_blocks(struct group_info *grp,int block)
{
        return(grp->blocks[block]);
}
EXPORT_SYMBOL(kail_groups_blocks);


void
FASTCALL() kail_atomic_add(int value,void *variable)
{
        atomic_add(value,(atomic_t *)variable);
        return;
}
EXPORT_SYMBOL(kail_atomic_add);
asmlinkage int
kail_vfs_mounted(kail_vfs_t *valp)
{
        if (valp) {
                struct vfsmount * const mnt = (struct vfsmount *)valp->mnt;
                struct vfsmount * const mntp = (struct vfsmount *)valp->mnt_parent;
                struct list_head *p;

                ;


                if (!list_empty(&mntp->mnt_mounts)) {
                        list_for_each(p,&mntp->mnt_mounts) {
                                struct vfsmount * const chp = list_entry(p,struct vfsmount,mnt_child);
                                ;

                                if (chp && chp->mnt_devname && !strncmp(chp->mnt_devname,valp->devname,64)) {
                                        if (chp != mnt) {

                                                valp->mnt = (void *)chp;
                                        }
                                        ;
                                        return 1;
                                }
                        }
                }
                else { ; }

                ;

                valp->mnt = (void *)0x0f0f0f0f;
                return 0;

        } else {
                return 0;
        }
}
EXPORT_SYMBOL(kail_vfs_mounted);

asmlinkage int
kail_vfs_check(kail_vfs_t *valp)
{
 struct vfsmount *mnt = (struct vfsmount *)valp->mnt;
 struct vfsmount *mntp = (struct vfsmount *)valp->mnt_parent;
 struct list_head *p;

;


  if (!list_empty(&mntp->mnt_mounts)) {
     list_for_each(p,&mntp->mnt_mounts) {
        struct vfsmount * chp = list_entry(p,struct vfsmount,mnt_child);
;

     }
  } else { ; }

        return 0;
}
EXPORT_SYMBOL(kail_vfs_check);

static void
kail_vfs_set(kail_vfs_t *valp, struct vfsmount *mnt)
{
        valp->mnt = (void *) mnt;
        valp->mnt_parent = (void *) mnt->mnt_parent;
        if (mnt->mnt_devname) {
               strncpy(valp->devname,mnt->mnt_devname,64);
        } else {
               strcpy(valp->devname,"NOFSName");
        }
        ;
        return;
}
static int
doFidAndAttrs(
    kail_vnodep_t vnp,
    kail_rawFid_t *fp,
    kail_fattr_t *fap,
    const kail_cred_t *const cp)
{
    struct inode * const ip = ((vnp)->nd.dentry)->d_inode;

    if (unlikely(ip == NULL)) {
            return ENOENT;
    }



    fp->ctime = ip->i_ctime.tv_sec;




    fp->fsid.val[0] = (long)(ip->i_sb->s_dev);





    fp->fsid.val[1] = (long) ((vnp)->nd.mnt);
    fp->fid.fid_ino = ip->i_ino;
    fp->fid.fid_gen = ip->i_generation;

    fp->fid.fid_flags = 0;
    fp->fid.fid_data_len = 0;
    if (!(ip->i_sb->s_type->fs_flags & FS_REQUIRES_DEV)) {

        if (!((*ip->i_sb->s_type->name == 'p') && !strcmp("proc", ip->i_sb->s_type->name)) &&
            !((*ip->i_sb->s_type->name == 't') && !strcmp("tmpfs", ip->i_sb->s_type->name)) &&
            !((*ip->i_sb->s_type->name == 'd') && !strcmp("devpts", ip->i_sb->s_type->name)) &&
            !((*ip->i_sb->s_type->name == 'r') && !strcmp("ramfs", ip->i_sb->s_type->name)) &&
            !((*ip->i_sb->s_type->name == 'u') && !strcmp("usbfs", ip->i_sb->s_type->name)) &&
            !((*ip->i_sb->s_type->name == 's') && !strcmp("sysfs", ip->i_sb->s_type->name))
           ) {
            fp->fid.fid_flags = 0x1;

            if ((*ip->i_sb->s_type->name == 'n') && !strcmp("nfs", ip->i_sb->s_type->name)) {
                    int dsize;




                    (unlikely(!((NFS_FH((((vnp)->nd.dentry))->d_inode)))) ? (printk("kail_assert: %s:%d\n","/project/oss600/build/oss600/src/oss/kazn/kail/kail_kernel_interface.c",1968), *((char *)0) = 0,0) : 0);
                    dsize = ((((sizeof(char) * 64)) < ((((NFS_FH((((vnp)->nd.dentry))->d_inode)))->size + sizeof(int)))) ? ((sizeof(char) * 64)) : ((((NFS_FH((((vnp)->nd.dentry))->d_inode)))->size + sizeof(int))));
                    fp->fid.fid_data_len = dsize;
                    memcpy((void *)&(fp->fid.fid_data),
                            (const void *)((NFS_FH((((vnp)->nd.dentry))->d_inode))),
                            dsize);
            }
        }
    }
    ;


    ;



    if (fap) {
       const umode_t i_mode = ip->i_mode;


       fap->uid = (kail_authID_t) ip->i_uid;
       fap->gid = (kail_authID_t) ip->i_gid;

       fap->dev = 0;

       if (S_ISREG(i_mode)) fap->ftype = KAIL_FTYPE_FILE;
       else if (S_ISDIR(i_mode)) fap->ftype = KAIL_FTYPE_DIR;
       else if (S_ISBLK(i_mode)) { fap->ftype = KAIL_FTYPE_BLKDEV;
               fap->dev = ip->i_rdev;
       }
       else if (S_ISCHR(i_mode)) { fap->ftype = KAIL_FTYPE_CHARDEV;
               fap->dev = ip->i_rdev;
       }
       else if (S_ISLNK(i_mode)) fap->ftype = KAIL_FTYPE_LNK;
       else if (S_ISSOCK(i_mode)) fap->ftype = KAIL_FTYPE_SOCK;
       else if (S_ISFIFO(i_mode)) fap->ftype = KAIL_FTYPE_FIFO;
       else fap->ftype = KAIL_FTYPE_OTHER;

       fap->mode = i_mode & S_IALLUGO;
       fap->links = ip->i_nlink;
       if (fp->fid.fid_flags == 0x1) {
               fap->attrFlags = 0x1;
       } else {
               fap->attrFlags = 0;
       }

       if (((vnp)->nd.mnt)->mnt_mountpoint->d_sb->s_magic == 0x0187) {
               fap->attrFlags |= 0x4;
               kail_vfs_set(&fap->check_vfsp,((vnp)->nd.mnt));
       }

       ;

    }

    return 0;

}
asmlinkage int
kail_makeFidChain(
    void *void_dir_vnp,
    kail_rawFid_t *flp,
    int *count,
    const kail_cred_t *const cp,
    int skipF)
{
    int rc = 0, needFids = 0;
    int nfids = 0, maxfids = *count;
    kail_rawFid_t rfid;
    kail_rawFid_t *fp = flp;
    kail_vnodep_t dir_vnp = void_dir_vnp;
    kail_vnodep_t vnp;

    ;


    (unlikely(!(flp)) ? (printk("kail_assert: %s:%d\n","/project/oss600/build/oss600/src/oss/kazn/kail/kail_kernel_interface.c",2063), *((char *)0) = 0,0) : 0);

    if (unlikely((maxfids < 1) || !((dir_vnp)->nd.dentry)))
        return EINVAL;

    do { ; if ((0)) { (vnp) = (kail_vnodep_t)kmalloc(sizeof(struct kail_vnode_t),GFP_KERNEL); (unlikely(!((vnp))) ? (printk("kail_assert: %s:%d\n","/project/oss600/build/oss600/src/oss/kazn/kail/kail_kernel_interface.c",2068), *((char *)0) = 0,0) : 0); (vnp)->malloc = 1; spin_lock_init(&((vnp)->lock));; } else { (vnp) = (kail_vnodep_t)__builtin_alloca (sizeof(struct kail_vnode_t)); (vnp)->malloc = 0; } (vnp)->nd.dentry = NULL; (vnp)->count = 0; ; } while (0);

    ((vnp)->nd.dentry) = ((dir_vnp)->nd.dentry);
    ((vnp)->nd.mnt) = ((dir_vnp)->nd.mnt);

    do { if ((vnp)->malloc) { spin_lock(&((vnp)->lock)); }; (vnp)->count++; ; do { struct dentry * const l_d = ((vnp)->nd.dentry); ; dget(l_d); ; } while (0); do { struct vfsmount * const l_m = ((vnp)->nd.mnt); ; mntget(l_m); ; } while (0); if ((vnp)->malloc) { spin_unlock(&((vnp)->lock)); }; } while (0);
    for (;;) {
        ;

        if (nfids || !skipF) {
            rc = doFidAndAttrs(vnp, &rfid, NULL, cp);
            if (rc == 0) {


                if (nfids == 0) {
                    const int fccCode = kail_fcc_find(&rfid, flp, count);
                    if (fccCode == 0 || (fccCode == E2BIG)) {

                        do { if ((vnp)->malloc) { spin_lock(&((vnp)->lock)); }; if ((vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((vnp)->nd)); path_release(l_n); ; ; } while (0); (vnp)->count--; } if ((vnp)->malloc) { spin_unlock(&((vnp)->lock)); }; if ((vnp)->count == 0) do { ; if (((vnp)->count == 0) && ((vnp)->malloc == 1)) { kfree((vnp)); } (void *)(vnp) = NULL; } while (0); } while (0);
                        return fccCode;
                    }
                }

                if (nfids < maxfids) {
                    *fp = rfid; fp++;
                } else {
                    needFids = 1;
                }
                nfids++;
            } else {
                do { if ((vnp)->malloc) { spin_lock(&((vnp)->lock)); }; if ((vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((vnp)->nd)); path_release(l_n); ; ; } while (0); (vnp)->count--; } if ((vnp)->malloc) { spin_unlock(&((vnp)->lock)); }; if ((vnp)->count == 0) do { ; if (((vnp)->count == 0) && ((vnp)->malloc == 1)) { kfree((vnp)); } (void *)(vnp) = NULL; } while (0); } while (0);
            }
        }
        skipF = 0;

        if (rc == 0) {


            struct dentry * p_dentry = ((vnp)->nd.dentry)->d_parent;
            struct vfsmount * p_mnt = ((vnp)->nd.mnt);

            do { struct dentry * const l_d = (p_dentry); ; dget(l_d); ; } while (0);
            do { struct vfsmount * const l_m = (p_mnt); ; mntget(l_m); ; } while (0);


            if (((vnp)->nd.dentry) == p_dentry) {
            struct dentry *last_p_dentry = p_dentry;
            struct vfsmount *last_p_mnt = p_mnt;
            struct dentry *next_p_dentry = p_dentry;
            struct vfsmount *next_p_mnt = p_mnt;
            int keep_going;



    ;

    ;


            keep_going = follow_up(&next_p_mnt,&next_p_dentry);

            p_dentry = next_p_dentry;
            p_mnt = next_p_mnt;

    ;

    ;

                    while (follow_up(&next_p_mnt,&next_p_dentry)) {
    ;

    ;

                            last_p_dentry = p_dentry;
                            last_p_mnt = p_mnt;
                            p_dentry = next_p_dentry;
                            p_mnt = next_p_mnt;
                    }

    ;

    ;


                    if (p_dentry != last_p_dentry) {
                            do { struct dentry * const l_d = (p_dentry); ; dput(l_d); ; } while (0);
                            p_dentry = last_p_dentry;
                            do { struct dentry * const l_d = (p_dentry); ; dget(l_d); ; } while (0);
                    }
                    if (p_mnt != last_p_mnt) {
                            do { struct vfsmount * const l_m = (p_mnt); ; mntput(l_m); ; } while (0);
                            p_mnt = last_p_mnt;
                            do { struct vfsmount * const l_m = (p_mnt); ; mntget(l_m); ; } while (0);
                    }

    ;

    ;





                    { struct dentry *tmp_dentry = p_dentry;
                            p_dentry = p_dentry->d_parent;
                            do { struct dentry * const l_d = (p_dentry); ; dget(l_d); ; } while (0);
                            do { struct dentry * const l_d = (tmp_dentry); ; dput(l_d); ; } while (0);
                    }
    ;

    ;


                    if (((vnp)->nd.dentry) == p_dentry) {

                            do { struct dentry * const l_d = (p_dentry); ; dput(l_d); ; } while (0);
                            do { struct vfsmount * const l_m = (p_mnt); ; mntput(l_m); ; } while (0);

                            do { if ((vnp)->malloc) { spin_lock(&((vnp)->lock)); }; if ((vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((vnp)->nd)); path_release(l_n); ; ; } while (0); (vnp)->count--; } if ((vnp)->malloc) { spin_unlock(&((vnp)->lock)); }; if ((vnp)->count == 0) do { ; if (((vnp)->count == 0) && ((vnp)->malloc == 1)) { kfree((vnp)); } (void *)(vnp) = NULL; } while (0); } while (0);
                            break;
                    }
            }

            do { struct dentry * const l_d = (((vnp)->nd.dentry)); ; dput(l_d); ; } while (0);
            do { struct vfsmount * const l_m = (((vnp)->nd.mnt)); ; mntput(l_m); ; } while (0);

            ((vnp)->nd.dentry) = p_dentry;
            ((vnp)->nd.mnt) = p_mnt;

        }
        else
                break;

    }

    if (rc == 0) {
        *count = nfids;
        if (needFids) {
            rc = E2BIG;

        } else if (nfids > 2) {
            kail_fcc_add(flp, nfids);

        }
    } else {
        *count = 0;
    }


    if (unlikely(vnp != NULL)) {
            ;
            do { ; if (((vnp)->count == 0) && ((vnp)->malloc == 1)) { kfree((vnp)); } (void *)(vnp) = NULL; } while (0);
    }

    ;

    return rc;
}
EXPORT_SYMBOL(kail_makeFidChain);
static int
filtervp(
        struct inode *inode,
        int flags)
{
    int rc = 1;

    if (flags & 0x4) {
            rc = !S_ISREG(inode->i_mode);
    } else if (flags & 0x1) {
            rc = !S_ISDIR(inode->i_mode);
    } else if (flags & 0x2) {
            rc = !S_ISLNK(inode->i_mode);
    } else {
            rc = 0;
    }


    if (unlikely(rc))
            rc = ENOSYS;

    return rc;

}
static int
doLookupName(
        char *path,
        int inFlags,
        kail_vnodep_t *dir_vnpp,
        kail_vnodep_t *vnpp,
        const kail_cred_t *const cp)
{
    int rc = 0;
    struct nameidata nd,dir_nd;
    uid_t saved_fsuid;
    gid_t saved_fsgid;
    if (cp) {
            saved_fsuid = current->fsuid;
            saved_fsgid = current->fsgid;
            current->fsuid = (uid_t) cp->fsuid;
            current->fsgid = (uid_t) cp->fsgid;
    }


    ((*vnpp)->nd.dentry) = NULL;
    if (dir_vnpp) {
            ((*dir_vnpp)->nd.dentry) = NULL;
    }

    ;


    memset(&nd,0,sizeof(nd));
    memset(&dir_nd,0,sizeof(dir_nd));





    if (path[0] == '\0') {
        struct kail_datanameidata *dnd = (struct kail_datanameidata *)path;

        nd.dentry = dnd->nd->dentry;
        nd.mnt = dnd->nd->mnt;


        do { struct dentry * const l_d = (nd.dentry); ; dget(l_d); ; } while (0);
        do { struct vfsmount * const l_m = (nd.mnt); ; mntget(l_m); ; } while (0);

        ;

    } else {


#ifdef LINUX_SLES9

    intent_init(&nd.intent, IT_LOOKUP);

#endif
    SET_LOOKUP_FLAG(&nd);
    rc = path_lookup(path,(inFlags & 0x8) ? 0 : LOOKUP_FOLLOW,&nd);
    CLEAR_LOOKUP_FLAG(&nd);
    }




    if (unlikely(rc)) { ; }






    if (unlikely(rc == -ENOENT) && dir_vnpp) {

#ifdef LINUX_SLES9

        intent_init(&dir_nd.intent, IT_LOOKUP);

#endif

        SET_LOOKUP_FLAG(&dir_nd);
        rc = path_lookup(path, LOOKUP_PARENT,&dir_nd);
        CLEAR_LOOKUP_FLAG(&dir_nd);
        if (!rc) {





                (*dir_vnpp)->nd = dir_nd;
                (*dir_vnpp)->count = 1;


                rc = -ENOENT;
        } else {
                ;
        }
    }
    if (unlikely(rc)) {
        rc = -rc;
        goto doLU_out;
    }

    ;

    ;



    if (dir_vnpp)
    {
        struct dentry *p_dentry = nd.dentry->d_parent;
        struct vfsmount *p_mnt = nd.mnt;

        do { struct dentry * const l_d = (p_dentry); ; dget(l_d); ; } while (0);
        do { struct vfsmount * const l_m = (p_mnt); ; mntget(l_m); ; } while (0);


        if (unlikely(nd.dentry == p_dentry)) {
            struct dentry *last_p_dentry = p_dentry;
            struct vfsmount *last_p_mnt = p_mnt;
            struct dentry *next_p_dentry = p_dentry;
            struct vfsmount *next_p_mnt = p_mnt;
            int keep_going;



    ;

    ;


            keep_going = follow_up(&next_p_mnt,&next_p_dentry);

            p_dentry = next_p_dentry;
            p_mnt = next_p_mnt;

    ;

    ;


                    while (follow_up(&next_p_mnt,&next_p_dentry)) {
    ;

    ;

                            last_p_dentry = p_dentry;
                            last_p_mnt = p_mnt;
                            p_dentry = next_p_dentry;
                            p_mnt = next_p_mnt;
                    }

    ;

    ;


                    if (p_dentry != last_p_dentry) {
                            do { struct dentry * const l_d = (p_dentry); ; dput(l_d); ; } while (0);
                            p_dentry = last_p_dentry;
                            do { struct dentry * const l_d = (p_dentry); ; dget(l_d); ; } while (0);
                    }
                    if (p_mnt != last_p_mnt) {
                            do { struct vfsmount * const l_m = (p_mnt); ; mntput(l_m); ; } while (0);
                            p_mnt = last_p_mnt;
                            do { struct vfsmount * const l_m = (p_mnt); ; mntget(l_m); ; } while (0);
                    }

    ;

    ;




                    { struct dentry *tmp_dentry = p_dentry;
                            p_dentry = p_dentry->d_parent;
                            do { struct dentry * const l_d = (p_dentry); ; dget(l_d); ; } while (0);
                            do { struct dentry * const l_d = (tmp_dentry); ; dput(l_d); ; } while (0);
                    }
    ;

    ;


        }


        dir_nd.dentry = p_dentry;
        dir_nd.mnt = p_mnt;

        (*dir_vnpp)->nd = dir_nd;
        (*dir_vnpp)->count = 1;
    }

    if (nd.dentry->d_inode) {

        (*vnpp)->nd = nd;
        (*vnpp)->count = 1;
    }
    else {
        ;
        rc = ENOENT;

        do { struct nameidata * const l_n = (&nd); path_release(l_n); ; ; } while (0);
    }

doLU_out:

    ;



    if ((((*vnpp))->nd.dentry)) {
       ;

       ;

       ;

       ;

    }
    if (dir_vnpp) {
    ;



    if ((((*dir_vnpp))->nd.dentry)) {
       ;

       ;

       ;

       ;

    }
    }


    if (cp) {
            current->fsuid = saved_fsuid;
            current->fsgid = saved_fsgid;
    }

    return rc;

}
static int
inodetodentry(
    struct inode *inode,
    struct dentry **dpp,
    const kail_cred_t *const cp)
{
    int rc = 0;
    struct dentry * dentry = NULL;
    struct list_head * head = &inode->i_dentry;
    struct list_head * next = inode->i_dentry.next;

    ;


    while (next != head) {
                struct list_head * tmp = next;
                struct dentry * tmp_d;
                next = tmp->next;
                tmp_d = list_entry(tmp, struct dentry, d_alias);
                if (!list_empty((struct list_head *)(&(tmp_d->d_hash))))
                {
                        do { struct dentry * const l_d = (tmp_d); ; dget(l_d); ; } while (0);
                        dentry = tmp_d;
                        break;
                }
                else
                {




{




                struct super_block *sb = user_get_super(inode->i_rdev);




                if (sb && sb->s_root) {
                        do { struct dentry * const l_d = (sb->s_root); ; dget(l_d); ; } while (0);
                        dentry = sb->s_root;
                        break;
                }
}
                }
    }


    if (unlikely(!dentry))
        rc = ENOENT;

    *dpp = dentry;

    ;

    return rc;
}
asmlinkage int
kail_decomposePath(
    char *path,
    int inFlags,
    kail_rawFid_t *rfid,
    int *gotFid,
    kail_rawFid_t *pathFids,
    int *pathFidCount,
    kail_fattr_t *retAttrs,
    kail_vnodeH_t *dvnHp)
{
    kail_vnodep_t dir_vnp;
    kail_vnodep_t vnp;
    int rc, skip = 0;
    const int flags = inFlags & ~0x8;

    const kail_cred_t * const cp = (!(flags & 0x10)) ? NULL : palCredp;
    *gotFid = 0;

    ;



    do { ; if ((0)) { (vnp) = (kail_vnodep_t)kmalloc(sizeof(struct kail_vnode_t),GFP_KERNEL); (unlikely(!((vnp))) ? (printk("kail_assert: %s:%d\n","/project/oss600/build/oss600/src/oss/kazn/kail/kail_kernel_interface.c",2677), *((char *)0) = 0,0) : 0); (vnp)->malloc = 1; spin_lock_init(&((vnp)->lock));; } else { (vnp) = (kail_vnodep_t)__builtin_alloca (sizeof(struct kail_vnode_t)); (vnp)->malloc = 0; } (vnp)->nd.dentry = NULL; (vnp)->count = 0; ; } while (0);


    if (dvnHp)
            *dvnHp = NULL;
    do { ; if (((dvnHp) ? 1 : 0)) { (dir_vnp) = (kail_vnodep_t)kmalloc(sizeof(struct kail_vnode_t),GFP_KERNEL); (unlikely(!((dir_vnp))) ? (printk("kail_assert: %s:%d\n","/project/oss600/build/oss600/src/oss/kazn/kail/kail_kernel_interface.c",2682), *((char *)0) = 0,0) : 0); (dir_vnp)->malloc = 1; spin_lock_init(&((dir_vnp)->lock));; } else { (dir_vnp) = (kail_vnodep_t)__builtin_alloca (sizeof(struct kail_vnode_t)); (dir_vnp)->malloc = 0; } (dir_vnp)->nd.dentry = NULL; (dir_vnp)->count = 0; ; } while (0);

    rc = doLookupName(path, (inFlags & 0x8), &dir_vnp, &vnp, cp);


    if (rc == ENOENT) {

        if (vnp)
                do { if ((vnp)->malloc) { spin_lock(&((vnp)->lock)); }; if ((vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((vnp)->nd)); path_release(l_n); ; ; } while (0); (vnp)->count--; } if ((vnp)->malloc) { spin_unlock(&((vnp)->lock)); }; if ((vnp)->count == 0) do { ; if (((vnp)->count == 0) && ((vnp)->malloc == 1)) { kfree((vnp)); } (void *)(vnp) = NULL; } while (0); } while (0);

      if (flags & 0x20) {



        if (((dir_vnp)->nd.dentry) && ((dir_vnp)->nd.dentry)->d_inode)
                rc = 0;
        else {
                do { if ((dir_vnp)->malloc) { spin_lock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((dir_vnp)->nd)); path_release(l_n); ; ; } while (0); (dir_vnp)->count--; } if ((dir_vnp)->malloc) { spin_unlock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count == 0) do { ; if (((dir_vnp)->count == 0) && ((dir_vnp)->malloc == 1)) { kfree((dir_vnp)); } (void *)(dir_vnp) = NULL; } while (0); } while (0);

        }
      }
      else
        if (dir_vnp)
                do { if ((dir_vnp)->malloc) { spin_lock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((dir_vnp)->nd)); path_release(l_n); ; ; } while (0); (dir_vnp)->count--; } if ((dir_vnp)->malloc) { spin_unlock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count == 0) do { ; if (((dir_vnp)->count == 0) && ((dir_vnp)->malloc == 1)) { kfree((dir_vnp)); } (void *)(dir_vnp) = NULL; } while (0); } while (0);
    }

    if (rc == 0) {
            if (vnp) {
                    if (flags)
                            rc = filtervp(((vnp)->nd.dentry)->d_inode, flags);
                    if (rc == 0) {
                            rc = doFidAndAttrs(vnp, rfid, retAttrs, cp);
                            if (rc == 0) {
                                    *gotFid = 1;
                                    if (((dir_vnp)->nd.dentry) == ((vnp)->nd.dentry))
                                            skip = 1;
                            }
                    }
                    do { if ((vnp)->malloc) { spin_lock(&((vnp)->lock)); }; if ((vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((vnp)->nd)); path_release(l_n); ; ; } while (0); (vnp)->count--; } if ((vnp)->malloc) { spin_unlock(&((vnp)->lock)); }; if ((vnp)->count == 0) do { ; if (((vnp)->count == 0) && ((vnp)->malloc == 1)) { kfree((vnp)); } (void *)(vnp) = NULL; } while (0); } while (0);
            }

            if (rc == 0) {
                    rc = kail_makeFidChain(dir_vnp, pathFids, pathFidCount, cp, skip);
            }

            if (dvnHp && (rc == 0) && *pathFidCount) {
                    *dvnHp = dir_vnp;
            } else {
                    do { if ((dir_vnp)->malloc) { spin_lock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((dir_vnp)->nd)); path_release(l_n); ; ; } while (0); (dir_vnp)->count--; } if ((dir_vnp)->malloc) { spin_unlock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count == 0) do { ; if (((dir_vnp)->count == 0) && ((dir_vnp)->malloc == 1)) { kfree((dir_vnp)); } (void *)(dir_vnp) = NULL; } while (0); } while (0);
            }
    }

    ;


    return rc;
}
EXPORT_SYMBOL(kail_decomposePath);
asmlinkage int
kail_LookupFidAndDir(
    char *path,
    int inFlags,
    kail_rawFid_t *rfid,
    kail_rawFid_t *dir_rfid,
    kail_fattr_t *fap,
    int *retFlags)
{
    int rc;

    const kail_cred_t * const cp = (!(inFlags & 0x10)) ? NULL : palCredp;
    kail_vnodep_t dir_vnp;
    kail_vnodep_t vnp;

    *retFlags = 0;


    do { ; if ((0)) { (vnp) = (kail_vnodep_t)kmalloc(sizeof(struct kail_vnode_t),GFP_KERNEL); (unlikely(!((vnp))) ? (printk("kail_assert: %s:%d\n","/project/oss600/build/oss600/src/oss/kazn/kail/kail_kernel_interface.c",2777), *((char *)0) = 0,0) : 0); (vnp)->malloc = 1; spin_lock_init(&((vnp)->lock));; } else { (vnp) = (kail_vnodep_t)__builtin_alloca (sizeof(struct kail_vnode_t)); (vnp)->malloc = 0; } (vnp)->nd.dentry = NULL; (vnp)->count = 0; ; } while (0);
    do { ; if ((0)) { (dir_vnp) = (kail_vnodep_t)kmalloc(sizeof(struct kail_vnode_t),GFP_KERNEL); (unlikely(!((dir_vnp))) ? (printk("kail_assert: %s:%d\n","/project/oss600/build/oss600/src/oss/kazn/kail/kail_kernel_interface.c",2778), *((char *)0) = 0,0) : 0); (dir_vnp)->malloc = 1; spin_lock_init(&((dir_vnp)->lock));; } else { (dir_vnp) = (kail_vnodep_t)__builtin_alloca (sizeof(struct kail_vnode_t)); (dir_vnp)->malloc = 0; } (dir_vnp)->nd.dentry = NULL; (dir_vnp)->count = 0; ; } while (0);

    rc = doLookupName(path, (inFlags & 0x8), &dir_vnp, &vnp, cp);


    if (rc == ENOENT) {

        if (vnp) {
                do { if ((vnp)->malloc) { spin_lock(&((vnp)->lock)); }; if ((vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((vnp)->nd)); path_release(l_n); ; ; } while (0); (vnp)->count--; } if ((vnp)->malloc) { spin_unlock(&((vnp)->lock)); }; if ((vnp)->count == 0) do { ; if (((vnp)->count == 0) && ((vnp)->malloc == 1)) { kfree((vnp)); } (void *)(vnp) = NULL; } while (0); } while (0);
        }



        if (((dir_vnp)->nd.dentry) && ((dir_vnp)->nd.dentry)->d_inode)
                rc = 0;
        else {
                do { if ((dir_vnp)->malloc) { spin_lock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((dir_vnp)->nd)); path_release(l_n); ; ; } while (0); (dir_vnp)->count--; } if ((dir_vnp)->malloc) { spin_unlock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count == 0) do { ; if (((dir_vnp)->count == 0) && ((dir_vnp)->malloc == 1)) { kfree((dir_vnp)); } (void *)(dir_vnp) = NULL; } while (0); } while (0);

        }
    }

    if (rc == 0) {
            if (vnp) {
                    const int flags = inFlags & ~0x8;
                    if (flags) {
                            rc = filtervp(((vnp)->nd.dentry)->d_inode, flags);
                    }
                    if (rc == 0) {
                            rc = doFidAndAttrs(vnp, rfid, fap, cp);
                            if (rc == 0)
                                    *retFlags |= 0x1;
                    }
                    if (((vnp)->nd.dentry) == ((dir_vnp)->nd.dentry)) {



                            do { if ((dir_vnp)->malloc) { spin_lock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((dir_vnp)->nd)); path_release(l_n); ; ; } while (0); (dir_vnp)->count--; } if ((dir_vnp)->malloc) { spin_unlock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count == 0) do { ; if (((dir_vnp)->count == 0) && ((dir_vnp)->malloc == 1)) { kfree((dir_vnp)); } (void *)(dir_vnp) = NULL; } while (0); } while (0);
                    }
                    do { if ((vnp)->malloc) { spin_lock(&((vnp)->lock)); }; if ((vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((vnp)->nd)); path_release(l_n); ; ; } while (0); (vnp)->count--; } if ((vnp)->malloc) { spin_unlock(&((vnp)->lock)); }; if ((vnp)->count == 0) do { ; if (((vnp)->count == 0) && ((vnp)->malloc == 1)) { kfree((vnp)); } (void *)(vnp) = NULL; } while (0); } while (0);
            }

            if ((rc == 0) && dir_rfid && dir_vnp) {
                    rc = doFidAndAttrs(dir_vnp, dir_rfid, NULL, cp);
                    if (rc == 0)
                            *retFlags |= 0x2;
            }
            if (dir_vnp)
                    do { if ((dir_vnp)->malloc) { spin_lock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((dir_vnp)->nd)); path_release(l_n); ; ; } while (0); (dir_vnp)->count--; } if ((dir_vnp)->malloc) { spin_unlock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count == 0) do { ; if (((dir_vnp)->count == 0) && ((dir_vnp)->malloc == 1)) { kfree((dir_vnp)); } (void *)(dir_vnp) = NULL; } while (0); } while (0);
    }

    return rc;

}
EXPORT_SYMBOL(kail_LookupFidAndDir);
asmlinkage int
kail_lookupFidsAndInfo(
    char *path,
    int inFlags,
    kail_rawFid_t *rfid,
    kail_rawFid_t *dir_rfid,
    kail_fattr_t *fap,
    kail_vnodeH_t *vnH,
    kail_vnodeH_t *dirvnH,
    int *retFlags)
{
    int rc;
    const int flags = inFlags & ~0x8;

    const kail_cred_t * const cp = (!(flags & 0x10)) ? NULL : palCredp;
    kail_vnodep_t dir_vnp;
    kail_vnodep_t vnp;


    *retFlags = 0;


    if (vnH) {
            *vnH = NULL;
    }
    do { ; if (((vnH) ? 1 : 0)) { (vnp) = (kail_vnodep_t)kmalloc(sizeof(struct kail_vnode_t),GFP_KERNEL); (unlikely(!((vnp))) ? (printk("kail_assert: %s:%d\n","/project/oss600/build/oss600/src/oss/kazn/kail/kail_kernel_interface.c",2878), *((char *)0) = 0,0) : 0); (vnp)->malloc = 1; spin_lock_init(&((vnp)->lock));; } else { (vnp) = (kail_vnodep_t)__builtin_alloca (sizeof(struct kail_vnode_t)); (vnp)->malloc = 0; } (vnp)->nd.dentry = NULL; (vnp)->count = 0; ; } while (0);


    if (dirvnH) {
            *dirvnH = NULL;
    }
    do { ; if (((dirvnH) ? 1 : 0)) { (dir_vnp) = (kail_vnodep_t)kmalloc(sizeof(struct kail_vnode_t),GFP_KERNEL); (unlikely(!((dir_vnp))) ? (printk("kail_assert: %s:%d\n","/project/oss600/build/oss600/src/oss/kazn/kail/kail_kernel_interface.c",2884), *((char *)0) = 0,0) : 0); (dir_vnp)->malloc = 1; spin_lock_init(&((dir_vnp)->lock));; } else { (dir_vnp) = (kail_vnodep_t)__builtin_alloca (sizeof(struct kail_vnode_t)); (dir_vnp)->malloc = 0; } (dir_vnp)->nd.dentry = NULL; (dir_vnp)->count = 0; ; } while (0);

    rc = doLookupName(path, (inFlags & 0x8), &dir_vnp, &vnp, cp);


    if (rc == ENOENT) {

        if (vnp)
                do { if ((vnp)->malloc) { spin_lock(&((vnp)->lock)); }; if ((vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((vnp)->nd)); path_release(l_n); ; ; } while (0); (vnp)->count--; } if ((vnp)->malloc) { spin_unlock(&((vnp)->lock)); }; if ((vnp)->count == 0) do { ; if (((vnp)->count == 0) && ((vnp)->malloc == 1)) { kfree((vnp)); } (void *)(vnp) = NULL; } while (0); } while (0);

      if (flags & 0x20) {



        if (((dir_vnp)->nd.dentry) && ((dir_vnp)->nd.dentry)->d_inode)
                rc = 0;
        else {
                do { if ((dir_vnp)->malloc) { spin_lock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((dir_vnp)->nd)); path_release(l_n); ; ; } while (0); (dir_vnp)->count--; } if ((dir_vnp)->malloc) { spin_unlock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count == 0) do { ; if (((dir_vnp)->count == 0) && ((dir_vnp)->malloc == 1)) { kfree((dir_vnp)); } (void *)(dir_vnp) = NULL; } while (0); } while (0);

        }
      }
      else
        if (dir_vnp)
                do { if ((dir_vnp)->malloc) { spin_lock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((dir_vnp)->nd)); path_release(l_n); ; ; } while (0); (dir_vnp)->count--; } if ((dir_vnp)->malloc) { spin_unlock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count == 0) do { ; if (((dir_vnp)->count == 0) && ((dir_vnp)->malloc == 1)) { kfree((dir_vnp)); } (void *)(dir_vnp) = NULL; } while (0); } while (0);
    }

    if (rc == 0) {
            if (vnp) {
                    if (flags) {
                            rc = filtervp(((vnp)->nd.dentry)->d_inode, flags);
                    }
                    if (rc == 0) {
                            rc = doFidAndAttrs(vnp, rfid, fap, cp);
                            if (rc == 0)
                                    *retFlags |= 0x1;
                    }
                    if (((vnp)->nd.dentry) == ((dir_vnp)->nd.dentry)) {



                            do { if ((dir_vnp)->malloc) { spin_lock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((dir_vnp)->nd)); path_release(l_n); ; ; } while (0); (dir_vnp)->count--; } if ((dir_vnp)->malloc) { spin_unlock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count == 0) do { ; if (((dir_vnp)->count == 0) && ((dir_vnp)->malloc == 1)) { kfree((dir_vnp)); } (void *)(dir_vnp) = NULL; } while (0); } while (0);
                    }
            }

            if (dir_vnp && (rc == 0)) {
                    rc = doFidAndAttrs(dir_vnp, dir_rfid, NULL, cp);
                    if (rc == 0)
                            *retFlags |= 0x2;
            }

            if ((rc == 0) && dirvnH && dir_vnp) {
                    *dirvnH = dir_vnp;
            } else {
                    if (dir_vnp)
                            do { if ((dir_vnp)->malloc) { spin_lock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((dir_vnp)->nd)); path_release(l_n); ; ; } while (0); (dir_vnp)->count--; } if ((dir_vnp)->malloc) { spin_unlock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count == 0) do { ; if (((dir_vnp)->count == 0) && ((dir_vnp)->malloc == 1)) { kfree((dir_vnp)); } (void *)(dir_vnp) = NULL; } while (0); } while (0);
            }

            if ((rc == 0) && vnH && vnp) {
                    *vnH = vnp;
            } else {
                    if (vnp)
                            do { if ((vnp)->malloc) { spin_lock(&((vnp)->lock)); }; if ((vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((vnp)->nd)); path_release(l_n); ; ; } while (0); (vnp)->count--; } if ((vnp)->malloc) { spin_unlock(&((vnp)->lock)); }; if ((vnp)->count == 0) do { ; if (((vnp)->count == 0) && ((vnp)->malloc == 1)) { kfree((vnp)); } (void *)(vnp) = NULL; } while (0); } while (0);
            }
    }

    return rc;
}
EXPORT_SYMBOL(kail_lookupFidsAndInfo);
asmlinkage int
kail_vnodesToFids(
    kail_vnodeH_t dirVnh,
    kail_vnodeH_t vnh,
    kail_rawFid_t *rfidp,
    kail_rawFid_t *dir_rfidp,
    kail_rawFid_t **pFids,
    int *count,
    kail_fattr_t *fap)
{
    int rc, pFidCount, allocCount = 0;
    kail_rawFid_t stackFids[3], *fids;
    kail_vnodep_t dir_vnp = (kail_vnodep_t)dirVnh;
    kail_vnodep_t vnp = (kail_vnodep_t)vnh;

    const kail_cred_t * const cp = NULL;

    rc = doFidAndAttrs(vnp, rfidp, fap, cp);
    if (unlikely(rc != 0))
            goto out;

    if (pFids) {
        *count = 0;
        pFidCount = 3;
        fids = stackFids;
        rc = kail_makeFidChain(dir_vnp, fids, &pFidCount, cp, (((vnp)->nd.dentry) == ((dir_vnp)->nd.dentry)));
        if (rc == E2BIG) {
            fids = (kail_rawFid_t *) kail_pal_alloc(pFidCount * sizeof(*fids));
            if (fids) {
                allocCount = pFidCount;
                rc = kail_makeFidChain(dir_vnp, fids, &pFidCount, cp, (((vnp)->nd.dentry) == ((dir_vnp)->nd.dentry)));
            }
        }
    } else if (dir_rfidp) {
        rc = doFidAndAttrs(dir_vnp, dir_rfidp, NULL, cp);
        if (rc == 0)
            *count = 1;
    }

    if ((rc == 0) && pFids && pFidCount) {
        if (!allocCount) {
            fids = (kail_rawFid_t *)kail_pal_alloc(pFidCount * sizeof(*fids));
            if (fids) {
                memcpy((char *)fids,(char *)stackFids,pFidCount * sizeof(*fids));
            }
        }

        if (fids) {
            *pFids = fids;
            *count = pFidCount;
        } else {
            rc = ENOMEM;
        }
    }

  out:

    if (rc) {
        *count = 0;
        if (pFids) {
            *pFids = NULL;
        }
    }

    return rc;
}
EXPORT_SYMBOL(kail_vnodesToFids);
asmlinkage int
kail_dirFidToPathFids(
    kail_rawFid_t *dFid,
    kail_rawFid_t **pFids,
    int *count)
{
    int rc;
    struct inode *inode;

    const kail_cred_t * const cp = NULL;
    kail_vnodep_t dir_vnp;

    do { ; if ((0)) { (dir_vnp) = (kail_vnodep_t)kmalloc(sizeof(struct kail_vnode_t),GFP_KERNEL); (unlikely(!((dir_vnp))) ? (printk("kail_assert: %s:%d\n","/project/oss600/build/oss600/src/oss/kazn/kail/kail_kernel_interface.c",3069), *((char *)0) = 0,0) : 0); (dir_vnp)->malloc = 1; spin_lock_init(&((dir_vnp)->lock));; } else { (dir_vnp) = (kail_vnodep_t)__builtin_alloca (sizeof(struct kail_vnode_t)); (dir_vnp)->malloc = 0; } (dir_vnp)->nd.dentry = NULL; (dir_vnp)->count = 0; ; } while (0);

    (unlikely(!(pFids && count)) ? (printk("kail_assert: %s:%d\n","/project/oss600/build/oss600/src/oss/kazn/kail/kail_kernel_interface.c",3071), *((char *)0) = 0,0) : 0);

    *count = 0;
    *pFids = NULL;

    ((dir_vnp)->nd.dentry) = NULL;
    lock_kernel();
    do { kail_rawFid_t * const l_f = (dFid); const unsigned long ino = l_f->fid.fid_ino; const dev_t dev = (dev_t) l_f->fsid.val[0]; struct super_block * const sb = user_get_super((dev_t)dev); struct inode * const l_i = iget(sb, ino); ; (inode) = l_i; } while (0);
    if (inode) {
            struct dentry *l_dentry;
            rc = inodetodentry(inode, &l_dentry, cp);
            ((dir_vnp)->nd.dentry) = l_dentry;
            iput(inode);
    }
    unlock_kernel();

    ((dir_vnp)->nd.mnt) = (struct vfsmount *)(dFid->fsid.val[1]);

    if (!rc && ((dir_vnp)->nd.dentry)) {
        kail_rawFid_t stackFids[3];
        int allocCount = 0;
        int pFidCount = 3;
        kail_rawFid_t * fids = stackFids;

        rc = kail_makeFidChain( dir_vnp, fids, &pFidCount, cp, 0);
        if (unlikely(rc == E2BIG)) {
            fids = (kail_rawFid_t *) kail_pal_alloc(pFidCount * sizeof(*fids));
            if (fids) {
                allocCount = pFidCount;
                rc = kail_makeFidChain( dir_vnp, fids, &pFidCount, cp, 0);
            }
        }

        if (!rc && pFidCount) {
            if (!allocCount) {
                fids = (kail_rawFid_t *)kail_pal_alloc(pFidCount * sizeof(*fids));
                if (fids) {
                    memcpy( (char *)fids, (char *)stackFids, pFidCount * sizeof(*fids));
                }
            }

            if (fids) {
                *pFids = fids;
                *count = pFidCount;
            } else {
                rc = ENOMEM;
            }
        }
    }

    if (((dir_vnp)->nd.dentry))
            do { struct dentry * const l_d = (((dir_vnp)->nd.dentry)); ; dput(l_d); ; } while (0);

    do { ; if (((dir_vnp)->count == 0) && ((dir_vnp)->malloc == 1)) { kfree((dir_vnp)); } (void *)(dir_vnp) = NULL; } while (0);

    return rc;
}
EXPORT_SYMBOL(kail_dirFidToPathFids);
static char*
kail_parseLeafFromInPath(
    char *inPath )
{
    const int len = strlen(inPath);
    char *cp = inPath + len;

    if (*cp == '/') {
      cp--;
      if (len == 1)
          return NULL;
    }

    for (;;) {
       if (*cp == '/') {
           return cp +1;
       }
       if (cp == inPath) {
          return cp;
       }
       cp--;
    }

    return NULL;
}
static char *
kail_appendLeafToEndOfPBuf(
   char * const leaf,
   char * const prefix,
   char * const pbuf,
   const int pbLen
   )
{
    const int prefixLen = strlen(prefix);
   if ((strlen(leaf) + prefixLen + 1) >= pbLen) {
      return prefix;
   }




   if (prefix != pbuf) {
      memmove(pbuf, prefix, prefixLen);
   }

   pbuf[prefixLen] = '\0';

   strcat(pbuf,"/");

   strcat(pbuf,leaf);

   return pbuf;

}
asmlinkage int
kail_pathToFullPath(
     char *inPath,
     int inFlags,
     char **pp,
     char *pbuf,
     int pbLen)
{
    int rc = 0;
    int saveLeaf = 0;
    const int flags = inFlags & ~0x8;


    const kail_cred_t * const cp = (!(flags & 0x10)) ? NULL : palCredp;
    kail_vnodep_t dir_vnp;
    kail_vnodep_t vnp;


    do { ; if ((0)) { (vnp) = (kail_vnodep_t)kmalloc(sizeof(struct kail_vnode_t),GFP_KERNEL); (unlikely(!((vnp))) ? (printk("kail_assert: %s:%d\n","/project/oss600/build/oss600/src/oss/kazn/kail/kail_kernel_interface.c",3260), *((char *)0) = 0,0) : 0); (vnp)->malloc = 1; spin_lock_init(&((vnp)->lock));; } else { (vnp) = (kail_vnodep_t)__builtin_alloca (sizeof(struct kail_vnode_t)); (vnp)->malloc = 0; } (vnp)->nd.dentry = NULL; (vnp)->count = 0; ; } while (0);


    do { ; if ((0)) { (dir_vnp) = (kail_vnodep_t)kmalloc(sizeof(struct kail_vnode_t),GFP_KERNEL); (unlikely(!((dir_vnp))) ? (printk("kail_assert: %s:%d\n","/project/oss600/build/oss600/src/oss/kazn/kail/kail_kernel_interface.c",3263), *((char *)0) = 0,0) : 0); (dir_vnp)->malloc = 1; spin_lock_init(&((dir_vnp)->lock));; } else { (dir_vnp) = (kail_vnodep_t)__builtin_alloca (sizeof(struct kail_vnode_t)); (dir_vnp)->malloc = 0; } (dir_vnp)->nd.dentry = NULL; (dir_vnp)->count = 0; ; } while (0);


    rc = doLookupName(inPath, (inFlags & 0x8), &dir_vnp, &vnp, cp);


    if (rc == ENOENT) {

        if (vnp)
                do { if ((vnp)->malloc) { spin_lock(&((vnp)->lock)); }; if ((vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((vnp)->nd)); path_release(l_n); ; ; } while (0); (vnp)->count--; } if ((vnp)->malloc) { spin_unlock(&((vnp)->lock)); }; if ((vnp)->count == 0) do { ; if (((vnp)->count == 0) && ((vnp)->malloc == 1)) { kfree((vnp)); } (void *)(vnp) = NULL; } while (0); } while (0);

      if (flags & 0x20) {



        if (((dir_vnp)->nd.dentry) && ((dir_vnp)->nd.dentry)->d_inode) {
                rc = 0;
                saveLeaf = 1;
        }
        else {
                do { if ((dir_vnp)->malloc) { spin_lock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((dir_vnp)->nd)); path_release(l_n); ; ; } while (0); (dir_vnp)->count--; } if ((dir_vnp)->malloc) { spin_unlock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count == 0) do { ; if (((dir_vnp)->count == 0) && ((dir_vnp)->malloc == 1)) { kfree((dir_vnp)); } (void *)(dir_vnp) = NULL; } while (0); } while (0);

        }
      }
      else
        if (dir_vnp)
                do { if ((dir_vnp)->malloc) { spin_lock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((dir_vnp)->nd)); path_release(l_n); ; ; } while (0); (dir_vnp)->count--; } if ((dir_vnp)->malloc) { spin_unlock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count == 0) do { ; if (((dir_vnp)->count == 0) && ((dir_vnp)->malloc == 1)) { kfree((dir_vnp)); } (void *)(dir_vnp) = NULL; } while (0); } while (0);
    }

    if (rc == 0) {
            if (vnp) {
                    *pp = d_path(((vnp)->nd.dentry),((vnp)->nd.mnt),(pbuf),(pbLen));;
            }
            else if (dir_vnp) {
                    *pp = d_path(((dir_vnp)->nd.dentry),((dir_vnp)->nd.mnt),(pbuf),(pbLen));;
                    if (saveLeaf){



                      char* postLeaf = kail_parseLeafFromInPath(inPath);
                      if (postLeaf) {
                          *pp = kail_appendLeafToEndOfPBuf(postLeaf, *pp, pbuf, pbLen);
                      }
                    }
            }
            else
                    rc = -1;
    }

    if (vnp) {
            do { if ((vnp)->malloc) { spin_lock(&((vnp)->lock)); }; if ((vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((vnp)->nd)); path_release(l_n); ; ; } while (0); (vnp)->count--; } if ((vnp)->malloc) { spin_unlock(&((vnp)->lock)); }; if ((vnp)->count == 0) do { ; if (((vnp)->count == 0) && ((vnp)->malloc == 1)) { kfree((vnp)); } (void *)(vnp) = NULL; } while (0); } while (0);
    }
    if (dir_vnp) {
            do { if ((dir_vnp)->malloc) { spin_lock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count > 0) { ; do { struct nameidata * const l_n = (&((dir_vnp)->nd)); path_release(l_n); ; ; } while (0); (dir_vnp)->count--; } if ((dir_vnp)->malloc) { spin_unlock(&((dir_vnp)->lock)); }; if ((dir_vnp)->count == 0) do { ; if (((dir_vnp)->count == 0) && ((dir_vnp)->malloc == 1)) { kfree((dir_vnp)); } (void *)(dir_vnp) = NULL; } while (0); } while (0);
    }

    return rc;
}
EXPORT_SYMBOL(kail_pathToFullPath);
asmlinkage char *
kail_readSymLink(char *slName, int *tlen)
{
    char *tname = NULL;
    int rc;
    struct nameidata nd;
    kail_vnodep_t vnp;

    do { ; if ((0)) { (vnp) = (kail_vnodep_t)kmalloc(sizeof(struct kail_vnode_t),GFP_KERNEL); (unlikely(!((vnp))) ? (printk("kail_assert: %s:%d\n","/project/oss600/build/oss600/src/oss/kazn/kail/kail_kernel_interface.c",3343), *((char *)0) = 0,0) : 0); (vnp)->malloc = 1; spin_lock_init(&((vnp)->lock));; } else { (vnp) = (kail_vnodep_t)__builtin_alloca (sizeof(struct kail_vnode_t)); (vnp)->malloc = 0; } (vnp)->nd.dentry = NULL; (vnp)->count = 0; ; } while (0);

    memset(&nd,0,sizeof(nd));


#ifdef LINUX_SLES9

    intent_init(&nd.intent, IT_LOOKUP);

#endif
    SET_LOOKUP_FLAG(&nd);
    rc = path_lookup(slName,LOOKUP_FOLLOW,&nd);
    CLEAR_LOOKUP_FLAG(&nd);





    vnp->nd = nd;

    ;

    ;


    if (!rc) {
      if (nd.dentry->d_inode != NULL) {


            char *cbuf;
            if ((cbuf = (char *)kmalloc(1000 +4,GFP_KERNEL))) {
                    char *tmp = d_path(((vnp)->nd.dentry),((vnp)->nd.mnt),(cbuf),(1000));;
                    if (tmp) {
                            const int len = strlen(tmp);
                            if ((tname = kail_pal_alloc(len + 1))) {
                                    memcpy(tname, tmp, len + 1);
                                    *tlen = len;
                            }
                    }
                    kfree(cbuf);
            }

            do { struct nameidata * const l_n = (&nd); path_release(l_n); ; ; } while (0);
      } else {
            ;

            do { struct nameidata * const l_n = (&nd); path_release(l_n); ; ; } while (0);
      }
    }

    do { ; if (((vnp)->count == 0) && ((vnp)->malloc == 1)) { kfree((vnp)); } (void *)(vnp) = NULL; } while (0);

    return tname;

}
EXPORT_SYMBOL(kail_readSymLink);
asmlinkage int
kail_unixDescToRawFid(
     int fd,
     kail_rawFid_t *rfp)
{
    int rc = 1;
    struct file *fp;
    kail_vnodep_t vnp;

    do { ; if ((0)) { (vnp) = (kail_vnodep_t)kmalloc(sizeof(struct kail_vnode_t),GFP_KERNEL); (unlikely(!((vnp))) ? (printk("kail_assert: %s:%d\n","/project/oss600/build/oss600/src/oss/kazn/kail/kail_kernel_interface.c",3420), *((char *)0) = 0,0) : 0); (vnp)->malloc = 1; spin_lock_init(&((vnp)->lock));; } else { (vnp) = (kail_vnodep_t)__builtin_alloca (sizeof(struct kail_vnode_t)); (vnp)->malloc = 0; } (vnp)->nd.dentry = NULL; (vnp)->count = 0; ; } while (0);

    if ((fp = fget(fd))) {
            if (fp->f_dentry) {

                    const kail_cred_t * const cp = NULL;
                    ((vnp)->nd.dentry) = fp->f_dentry;
                    ((vnp)->nd.mnt) = fp->f_vfsmnt;
                    rc = doFidAndAttrs(vnp,rfp,NULL,cp);
            } else {
                    rc = -1;
            }
            fput(fp);
    }
    do { ; if (((vnp)->count == 0) && ((vnp)->malloc == 1)) { kfree((vnp)); } (void *)(vnp) = NULL; } while (0);

    return ((rc)? -1: 0);
}
EXPORT_SYMBOL(kail_unixDescToRawFid);
void *
FASTCALL() kail_unixDescToVnode(int fd)
{
    struct file *fp;
    kail_vnodep_t vnp;

    do { ; if ((1)) { (vnp) = (kail_vnodep_t)kmalloc(sizeof(struct kail_vnode_t),GFP_KERNEL); (unlikely(!((vnp))) ? (printk("kail_assert: %s:%d\n","/project/oss600/build/oss600/src/oss/kazn/kail/kail_kernel_interface.c",3456), *((char *)0) = 0,0) : 0); (vnp)->malloc = 1; spin_lock_init(&((vnp)->lock));; } else { (vnp) = (kail_vnodep_t)__builtin_alloca (sizeof(struct kail_vnode_t)); (vnp)->malloc = 0; } (vnp)->nd.dentry = NULL; (vnp)->count = 0; ; } while (0);

    if ((fp = fget(fd))) {
            ((vnp)->nd.dentry) = fp->f_dentry;
            do { struct dentry * const l_d = (((vnp)->nd.dentry)); ; dget(l_d); ; } while (0);
            ((vnp)->nd.mnt) = fp->f_vfsmnt;
            do { struct vfsmount * const l_m = (((vnp)->nd.mnt)); ; mntget(l_m); ; } while (0);
            vnp->count = 1;
            fput(fp);
    }

    return (void *)(vnp);

}
EXPORT_SYMBOL(kail_unixDescToVnode);


int
FASTCALL() kail_fd_to_name(int fd, char **namep, int *len)
{
    struct file *fp;
    int rc = 0;

    if ((fp = fget(fd))) {
        if (fp->f_dentry) {
            struct dentry * const f_dentry = fp->f_dentry;
            const int l_len = f_dentry->d_name.len;

            if (l_len < PATH_MAX) {
                    char *l_namep = kail_pal_alloc(l_len);
                    if (l_namep) {
                            strcpy(l_namep, f_dentry->d_name.name);
                            *namep = l_namep;
                            *len = l_len;
                    }
                    else
                            rc = ENOMEM;
            } else {
                    rc = E2BIG;
            }
        } else {
            rc = ENOENT;
        }
        fput(fp);
    }
    return rc;
}
EXPORT_SYMBOL(kail_fd_to_name);
void
FASTCALL() kail_releVnode(void * vnp)
{
    do { if (((kail_vnodep_t) vnp)->malloc) { spin_lock(&(((kail_vnodep_t) vnp)->lock)); }; if (((kail_vnodep_t) vnp)->count > 0) { ; do { struct nameidata * const l_n = (&(((kail_vnodep_t) vnp)->nd)); path_release(l_n); ; ; } while (0); ((kail_vnodep_t) vnp)->count--; } if (((kail_vnodep_t) vnp)->malloc) { spin_unlock(&(((kail_vnodep_t) vnp)->lock)); }; if (((kail_vnodep_t) vnp)->count == 0) do { ; if ((((kail_vnodep_t) vnp)->count == 0) && (((kail_vnodep_t) vnp)->malloc == 1)) { kfree(((kail_vnodep_t) vnp)); } (void *)((kail_vnodep_t) vnp) = NULL; } while (0); } while (0);
    return;
}
EXPORT_SYMBOL(kail_releVnode);
void
FASTCALL() kail_holdVnode(void * vnp)
{
    (unlikely(!(((kail_vnodep_t)vnp)->count > 0)) ? (printk("kail_assert: %s:%d\n","/project/oss600/build/oss600/src/oss/kazn/kail/kail_kernel_interface.c",3531), *((char *)0) = 0,0) : 0);
    do { if (((kail_vnodep_t) vnp)->malloc) { spin_lock(&(((kail_vnodep_t) vnp)->lock)); }; ((kail_vnodep_t) vnp)->count++; ; do { struct dentry * const l_d = (((kail_vnodep_t) vnp)->nd.dentry); ; dget(l_d); ; } while (0); do { struct vfsmount * const l_m = (((kail_vnodep_t) vnp)->nd.mnt); ; mntget(l_m); ; } while (0); if (((kail_vnodep_t) vnp)->malloc) { spin_unlock(&(((kail_vnodep_t) vnp)->lock)); }; } while (0);
    return;
}
EXPORT_SYMBOL(kail_holdVnode);

int
FASTCALL() kail_fd_to_dev(int fd, dev_t *dev)
{
    struct file *fp;
    int rc = ENODEV;

    if ((fp = fget(fd))) {
        if (fp->f_dentry) {
                if (S_ISCHR(fp->f_dentry->d_inode->i_mode)) {
                        *dev = (dev_t)(fp->f_dentry->d_inode->i_rdev);
                        rc = 0;
                }
        }
        fput(fp);
    }
    return rc;
}
EXPORT_SYMBOL(kail_fd_to_dev);


int
FASTCALL() kail_fd_to_socket(int fd,void **sp)
{
    struct file *fp;
    int rc = EINVAL;

    if ((fp = fget(fd))) {
        if (fp->f_dentry && fp->f_dentry->d_inode && S_ISSOCK(fp->f_dentry->d_inode->i_mode)) {

            *sp = (void *)(SOCKET_I(fp->f_dentry->d_inode));



            rc = 0;
        }
        fput(fp);
    }

    return rc;
}
EXPORT_SYMBOL(kail_fd_to_socket);




#include <linux/ioctl32.h>






asmlinkage int
kail_register_chrdev(struct kail_register_chrdev_parameters *krcp, void **fops)
{
        struct file_operations * fopsp = (struct file_operations *)kmalloc(sizeof *fopsp,GFP_KERNEL);
        int rc = 0;

        if (unlikely(!fopsp))
                return -ENOMEM;

        memset(fopsp,0,sizeof *fopsp);


        fopsp->owner = krcp->ownerp;
        fopsp->read = krcp->readp;
        fopsp->write = krcp->writep;
        fopsp->ioctl = krcp->ioctlp;
        fopsp->open = krcp->openp;
        fopsp->release = krcp->releasep;





        rc = register_chrdev(krcp->dev_number,krcp->name,fopsp);

        if (unlikely(rc < 0)) {
                kfree(fopsp);
                fopsp = NULL;
        }


        else {
                unsigned int *ioctl_cmds = krcp->ioctl_cmds;
                unsigned int ioctl_cnt = krcp->ioctl_cnt;
                rc = 0;
                for (;ioctl_cnt >0;ioctl_cnt--) {
                        if (!rc)

                                rc = register_ioctl32_conversion(*(ioctl_cmds + ioctl_cnt - 1),NULL );







                }
                if (rc) {
                        printk("register_ioctl32_conversion failed! rc=%d\n",rc);
                        kfree(fopsp);
                        fopsp = NULL;
                }
        }


        *fops = (void *)fopsp;

        return rc;

}
EXPORT_SYMBOL(kail_register_chrdev);

asmlinkage int
kail_unregister_chrdev(struct kail_register_chrdev_parameters *krcp, void *fops)
{
        int rc = 0;


        {
                unsigned int *ioctl_cmds = krcp->ioctl_cmds;
                unsigned int ioctl_cnt = krcp->ioctl_cnt;
                rc = unregister_ioctl32_conversion(*(ioctl_cmds + 0));
                if (!rc) rc = unregister_ioctl32_conversion(*(ioctl_cmds + 1));
                if (!rc) rc = unregister_ioctl32_conversion(*(ioctl_cmds + 2));
                if (rc) {
                        printk("unregister_ioctl32_conversion failed! rc=%d\n",rc);
                }
        }

        rc = unregister_chrdev(krcp->dev_number,krcp->name);

        if (fops)
                kfree(fops);

        return rc;
}
EXPORT_SYMBOL(kail_unregister_chrdev);

int
FASTCALL() kail_minor(void *filep)
{
        return MINOR(((struct file *)filep)->f_dentry->d_inode->i_rdev);
}
EXPORT_SYMBOL(kail_minor);
void *
FASTCALL() kail_kernel_malloc(unsigned long size)
{
        void *rc;

        if (size < (65536UL - 64))
           {






                rc = kmalloc((size_t)size, GFP_KERNEL);
           }
        else
                rc = vmalloc(size);

        return rc;
}
EXPORT_SYMBOL(kail_kernel_malloc);

void
FASTCALL() kail_kernel_free(void *addr,unsigned long size)
{
        if (size < (65536UL - 64))
                kfree((const void *)addr);
        else
                vfree(addr);
        return;
}
EXPORT_SYMBOL(kail_kernel_free);
asmlinkage int
kail_copy_exec_argv(void *arg_info, char *arg_strp, int max_len)
{

    *arg_strp = '\0';

    if (!arg_info) {
        return 0;
    }


    {
        char *kaddr;
        struct page *page;
        struct linux_binprm *l_bprm = (struct linux_binprm *)arg_info;
        unsigned long l_p = l_bprm->p;
        int l_argc = l_bprm->argc;
        unsigned long offset = l_p % PAGE_SIZE;
        int len_copied = 0;
        char *apos = arg_strp;







        goto inside;

        while (l_argc) {
            while (l_p++, *(kaddr+offset++) && (len_copied < max_len)) {

                *apos = *(kaddr+offset-1);
                apos++; len_copied++;

                if (offset != PAGE_SIZE)
                   continue;


                offset = 0;
                kunmap_atomic(kaddr, KM_USER0);
inside:
                page = l_bprm->page[l_p/PAGE_SIZE];
                kaddr = kmap_atomic(page, KM_USER0);
            }
            if (*(kaddr+offset-1) == 0) {
                *apos = ' ';
                apos++; len_copied++;
            }
            l_argc--;
        }

        kunmap_atomic(kaddr, KM_USER0);
        *(apos - 1) = '\0';

        ;


        return (len_copied);
   }
}
EXPORT_SYMBOL(kail_copy_exec_argv);




asmlinkage void
kail_kernel_interface(void)
{

        kail_xtime = &xtime;


        kail_printk = &printk;
        kail_sprintf = &sprintf;


        memset(&palCred, 0, sizeof(palCred));
        palCredp = &palCred;


        pid_init();


        return;
}
EXPORT_SYMBOL(kail_kernel_interface);

asmlinkage void
kail_call_backs(kail_call_back_t *call_backs)
{
        kail_pal_alloc = call_backs->alloc;
        kail_pal_free = call_backs->free;
        kail_fcc_find = call_backs->fcc_find;
        kail_fcc_add = call_backs->fcc_add;

}
EXPORT_SYMBOL(kail_call_backs);

asmlinkage void
kail_kernel_interface_shutdown(void)
{

        pid_shutdown();





        return;
}
EXPORT_SYMBOL(kail_kernel_interface_shutdown);
