
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *
 * IBM Tivoli Access Manager for Operating Systems 6.0.0
 * 5698-PDO
 * Licensed Materials - Property of IBM
 * 
 * (C) Copyright IBM Corp. 2000,2006. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 *
*/

static char sccsid[] = "@(#)83       1.48  src/oss/kazn/kail/kail_syscall.c, oss.kazn.src, oss600, 071114c 11/29/07 11:42:53";
#include <linux/version.h>







#include <linux/module.h>

#include <linux/kernel.h>


#include <linux/types.h>

#include <linux/slab.h>

#include <linux/vmalloc.h>

#include <linux/smp_lock.h>

#include <linux/sched.h>

#include <linux/file.h>

#include <linux/fs.h>

#include <net/sock.h>

#include <asm/atomic.h>

#include <asm/semaphore.h>

#include <asm/current.h>

#include <asm/uaccess.h>

#include <asm/unistd.h>


#include <linux/nfs_fs.h>
typedef struct kail_vfs
{
    void *mnt;
    void *mnt_parent;
    char devname[64];
} kail_vfs_t;






typedef struct {
        long val[2];
} kail_fsid_t;

typedef struct kail_fid {
    uint32_t fid_ino;
    uint32_t fid_gen;
    uint16_t fid_flags;
    uint16_t fid_data_len;

    char fid_data[(sizeof(char) * 64)];
} kail_fid_t;

typedef mode_t kail_fmode_t;
typedef dev_t kail_dev_t;
typedef void * kail_vnodeH_t;
typedef struct _kail_rfid {
    uint32_t ctime;
    kail_fsid_t fsid;
    kail_fid_t fid;
} kail_rawFid_t;
typedef struct _kail_cred {

        uid_t uid,euid,suid,fsuid;
        gid_t gid,egid,sgid,fsgid;
        int ngroups;
        int cr_ref;
        gid_t groups[32 ];
} kail_cred_t;

typedef int64_t kail_authID_t;
enum kail_ftypes { KAIL_FTYPE_NONE, KAIL_FTYPE_FILE, KAIL_FTYPE_DIR,
             KAIL_FTYPE_BLKDEV, KAIL_FTYPE_CHARDEV, KAIL_FTYPE_LNK,
             KAIL_FTYPE_SOCK, KAIL_FTYPE_BAD, KAIL_FTYPE_FIFO,
             KAIL_FTYPE_MPC, KAIL_FTYPE_OTHER};
typedef enum kail_ftypes kail_ftypes_t;

typedef struct _kail_fattr {
    kail_authID_t uid;
    kail_authID_t gid;
    kail_ftypes_t ftype;
    kail_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    dev_t dev;
    kail_vfs_t check_vfsp;
} kail_fattr_t;




extern volatile struct timespec *kail_xtime;





extern asmlinkage int (*kail_printk)(const char *, ...);
extern asmlinkage int (*kail_sprintf)(char * buf, const char * fmt, ...);
extern asmlinkage int (*kail_do_fork)(unsigned long, unsigned long, struct pt_regs *, unsigned long);


extern asmlinkage int kail_kernel_thread(int (*)(void *), void *,unsigned long);
extern asmlinkage int kail_kill_proc(pid_t, int, int);
extern asmlinkage long kail_strncpy_from_user(char *, const char *, long);
extern asmlinkage long kail_strncpy_from_DND(char *, void *, long);
extern unsigned long FASTCALL(kail_copy_to_user(void *, const void *, unsigned long));
extern unsigned long FASTCALL(kail_copy_from_user(void *, const void *, unsigned long));

extern void FASTCALL(kail_kernel_free(void *,unsigned long));
extern void * FASTCALL(kail_kernel_malloc(unsigned long));





extern asmlinkage void kail_mutex_init(void **);
extern void FASTCALL(kail_mutex_lock(void **));
extern int FASTCALL(kail_mutex_trylock(void **));
extern void FASTCALL(kail_mutex_unlock(void **));
extern asmlinkage void kail_mutex_destroy(void **);

extern asmlinkage void kail_cond_init(void **);
extern void FASTCALL(kail_wake_up(void **));
extern void FASTCALL(kail_cond_wait(void **, void **));
extern int FASTCALL(kail_cond_wait_intr(void **, void **));
extern asmlinkage int kail_condTimedWait(void **, void **, int64_t, int);
extern asmlinkage void kail_cond_destroy(void **);

extern asmlinkage void kail_iclock_init(void **);
extern void FASTCALL(kail_iclock_lock(void **));
extern void FASTCALL(kail_iclock_unlock(void **));
extern int FASTCALL(kail_iclock_trylock(void **));
extern asmlinkage void kail_iclock_destroy(void **);

extern void FASTCALL(kail_iclock_cond_wait(void **,void **));

extern asmlinkage int kail_current_pid(void);
extern asmlinkage int kail_current_tid(void);
extern asmlinkage int kail_current_Ppid(void);
extern int FASTCALL(kail_tid_to_pid(int));
extern pid_t FASTCALL(kail_pid_get_epid(pid_t));
extern void FASTCALL(kail_pid_delete(pid_t));
extern void FASTCALL(kail_epid_delete(pid_t));
extern void FASTCALL(kail_pid_add(pid_t,pid_t));


extern asmlinkage int kail_current_uid(void);
extern asmlinkage int kail_current_euid(void);
extern asmlinkage int kail_current_suid(void);
extern asmlinkage int kail_current_gid(void);
extern asmlinkage int kail_current_egid(void);
extern int FASTCALL(kail_current_files_close_on_exec(int));

extern asmlinkage int kail_socket_protocol(void *);
extern asmlinkage int kail_socket_getname(void *,void *,int *,int);

extern int FASTCALL(kail_fd_to_dev(int, dev_t *));
extern int FASTCALL(kail_fd_to_name(int, char **, int *));
extern int FASTCALL(kail_fd_to_socket(int,void **));

extern int FASTCALL(kail_socket_shutdown(void *));




extern int FASTCALL(kail_check_pid(int));
extern int FASTCALL(kail_get_pid_pgrp(int,int *));
extern int FASTCALL(kail_get_pid_uid(int,int *,int *));
extern void FASTCALL(kail_scan_procs(void *));

extern asmlinkage void kail_daemonize(const char *);
extern asmlinkage int kail_total_ram_mb(void);
extern void FASTCALL(kail_atomic_add(int,void *));

extern asmlinkage int kail_kernel_address_mode(void);






extern asmlinkage int kail_decomposePath(char *, int, kail_rawFid_t *, int *, kail_rawFid_t *, int *, kail_fattr_t *, kail_vnodeH_t *);
extern asmlinkage int kail_LookupFidAndDir(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, int *);
extern asmlinkage int kail_lookupFidsAndInfo(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, kail_vnodeH_t *, kail_vnodeH_t *, int *);
extern asmlinkage int kail_dirFidToPathFids( kail_rawFid_t *, kail_rawFid_t **, int *);
extern asmlinkage int kail_unixDescToRawFid( int , kail_rawFid_t *);
extern asmlinkage int kail_vnodesToFids( kail_vnodeH_t, kail_vnodeH_t, kail_rawFid_t *, kail_rawFid_t *, kail_rawFid_t **, int *, kail_fattr_t *);
extern asmlinkage int kail_makeFidChain(void *, kail_rawFid_t *, int *, const kail_cred_t *, int );

extern asmlinkage int kail_copy_exec_argv(void *, char *, int);


struct group_info;
extern gid_t * FASTCALL(kail_groups_blocks(struct group_info *,int));
extern int FASTCALL(kail_groups_ngroups(struct group_info *));
extern int FASTCALL(kail_groups_nblocks(struct group_info *));







struct kail_register_chrdev_parameters {
        unsigned int dev_number;
        char *name;
        void *ownerp;
        void *readp;
        void *writep;
        void *ioctlp;



        void *openp;
        void *releasep;
        unsigned int ioctl_cnt;
        unsigned int *ioctl_cmds;
} ;

extern asmlinkage int kail_register_chrdev(struct kail_register_chrdev_parameters *, void **);
extern asmlinkage int kail_unregister_chrdev(struct kail_register_chrdev_parameters *, void *);
extern int FASTCALL(kail_minor(void *));

extern asmlinkage int kail_file_read(char *, kail_vnodeH_t *,char *, long, long);
extern asmlinkage void kail_write_log(const char *,const char *, int, int);
extern asmlinkage void kail_log_init(const char *);

extern asmlinkage int kail_pathToFullPath( char *, int , char **, char *,int);
extern void * FASTCALL(kail_unixDescToVnode(int));
extern void FASTCALL(kail_releVnode(void *));
extern void FASTCALL(kail_holdVnode(void *));
extern asmlinkage char * kail_readSymLink(char *, int *);



extern asmlinkage int kail_vfs_mounted(kail_vfs_t *);
extern asmlinkage int kail_vfs_check(kail_vfs_t *);


typedef struct {
        void *alloc;
        void *free;
        void *fcc_find;
        void *fcc_add;
} kail_call_back_t;

extern asmlinkage void kail_call_backs(kail_call_back_t *);
extern asmlinkage void kail_kernel_interface(void);
extern asmlinkage void kail_kernel_interface_shutdown(void);

typedef asmlinkage long (* sys_call_fn)();
struct kail_syscall_prepost {
        int call_index;
        sys_call_fn call_pre;
        sys_call_fn call_post;
};

extern int struct_cppath_size;

struct kail_lsmhooks {
        int lsmhook_index;
        sys_call_fn lsmhook_pre;
        sys_call_fn lsmhook_post;
};
extern asmlinkage int kail_trap_syscalls(struct kail_syscall_prepost *,struct kail_lsmhooks *);



extern asmlinkage void kail_restore_syscalls(void);

extern int change_KailPerm2ro(void);

struct nameidata;
struct kail_datanameidata {
        char cdata[4];
        char *path;
        struct nameidata *nd;
};
#define KAIL_LOOKUP_BIT 0x40000000
#if defined(LINUX_RHEL4) || defined(LINUX_SLES10) || defined(LINUX_RHEL5)
#define SET_LOOKUP_FLAG(n) (n)->intent.open.flags = KAIL_LOOKUP_BIT;
#define CLEAR_LOOKUP_FLAG(n) (n)->intent.open.flags &= ~KAIL_LOOKUP_BIT;
#define CHECK_LOOKUP_FLAG(n) ((n)->intent.open.flags == KAIL_LOOKUP_BIT)
#endif 
#ifdef LINUX_SLES9
#define SET_LOOKUP_FLAG(n)
#define CLEAR_LOOKUP_FLAG(n)
#define CHECK_LOOKUP_FLAG(n)
#endif 
struct syscall_glue_table {
        long syscall_index;
        sys_call_fn syscall_glue_pre;
        sys_call_fn syscall_glue_post;
        sys_call_fn syscall_glue_pre_post;

        sys_call_fn sys32call_glue_pre;
        sys_call_fn sys32call_glue_post;
        sys_call_fn sys32call_glue_pre_post;

};
extern struct syscall_glue_table kail_syscall_glue_list_x[];
extern struct syscall_glue_table * kail_syscall_glue_list;


struct syscall_table {
        sys_call_fn orig_syscall;
        sys_call_fn syscall_pre;
        sys_call_fn syscall_post;

        sys_call_fn orig_sys32call;

};
extern struct syscall_table kail_syscall_list[];
typedef unsigned int uid32_t;
typedef unsigned int gid32_t;
struct kail_lsmhooks_table {
        sys_call_fn lsmhooks_pre;
        sys_call_fn lsmhooks_post;
};
extern struct kail_lsmhooks_table kail_lsmhooks_list[];
extern asmlinkage long kail_kill_glue_pre (pid_t,int); extern asmlinkage long kail_kill_glue_post (pid_t,int); extern asmlinkage long kail_kill_glue_pre_post (pid_t,int);
extern asmlinkage long kail_tkill_glue_pre (pid_t,int); extern asmlinkage long kail_tkill_glue_post (pid_t,int); extern asmlinkage long kail_tkill_glue_pre_post (pid_t,int);
extern asmlinkage long kail_tgkill_glue_pre (pid_t,pid_t,int); extern asmlinkage long kail_tgkill_glue_post (pid_t,pid_t,int); extern asmlinkage long kail_tgkill_glue_pre_post (pid_t,pid_t,int);
extern asmlinkage long kail_umount_glue_pre (char *); extern asmlinkage long kail_umount_glue_post (char *); extern asmlinkage long kail_umount_glue_pre_post (char *);
extern asmlinkage long kail_umount2_glue_pre (char *,int); extern asmlinkage long kail_umount2_glue_post (char *,int); extern asmlinkage long kail_umount2_glue_pre_post (char *,int);
extern asmlinkage long kail_mount_glue_pre (char *,char *,char *,unsigned long,void *); extern asmlinkage long kail_mount_glue_post (char *,char *,char *,unsigned long,void *); extern asmlinkage long kail_mount_glue_pre_post (char *,char *,char *,unsigned long,void *);
 static long nullp = (long)NULL;







 extern asmlinkage long kail_kill_glue32_pre (pid_t,int); extern asmlinkage long kail_kill_glue32_post (pid_t,int); extern asmlinkage long kail_kill_glue32_pre_post (pid_t,int);
 extern asmlinkage long kail_tkill_glue32_pre (pid_t,int); extern asmlinkage long kail_tkill_glue32_post (pid_t,int); extern asmlinkage long kail_tkill_glue32_pre_post (pid_t,int);
 extern asmlinkage long kail_tgkill_glue32_pre (pid_t,pid_t,int); extern asmlinkage long kail_tgkill_glue32_post (pid_t,pid_t,int); extern asmlinkage long kail_tgkill_glue32_pre_post (pid_t,pid_t,int);
 extern asmlinkage long kail_umount_glue32_pre (char *); extern asmlinkage long kail_umount_glue32_post (char *); extern asmlinkage long kail_umount_glue32_pre_post (char *);
 extern asmlinkage long kail_umount2_glue32_pre (char *,int); extern asmlinkage long kail_umount2_glue32_post (char *,int); extern asmlinkage long kail_umount2_glue32_pre_post (char *,int);
struct syscall_glue_table * trampoline_glue_list = (struct syscall_glue_table *)0;
struct syscall_glue_table * kail_syscall_glue_list;

struct syscall_glue_table kail_syscall_glue_list_x[] = {






    { __NR_kill, (sys_call_fn)kail_kill_glue_pre, (sys_call_fn)kail_kill_glue_post, (sys_call_fn)kail_kill_glue_pre_post, (sys_call_fn)kail_kill_glue32_pre, (sys_call_fn)kail_kill_glue32_post, (sys_call_fn)kail_kill_glue32_pre_post },
    { __NR_tkill, (sys_call_fn)kail_tkill_glue_pre, (sys_call_fn)kail_tkill_glue_post, (sys_call_fn)kail_tkill_glue_pre_post, (sys_call_fn)kail_tkill_glue32_pre, (sys_call_fn)kail_tkill_glue32_post, (sys_call_fn)kail_tkill_glue32_pre_post },
    { __NR_tgkill, (sys_call_fn)kail_tgkill_glue_pre, (sys_call_fn)kail_tgkill_glue_post, (sys_call_fn)kail_tgkill_glue_pre_post, (sys_call_fn)kail_tgkill_glue32_pre, (sys_call_fn)kail_tgkill_glue32_post, (sys_call_fn)kail_tgkill_glue32_pre_post },






    { __NR_umount, (sys_call_fn)kail_umount_glue_pre, (sys_call_fn)kail_umount_glue_post, (sys_call_fn)kail_umount_glue_pre_post, (sys_call_fn)kail_umount_glue32_pre, (sys_call_fn)kail_umount_glue32_post, (sys_call_fn)kail_umount_glue32_pre_post },
    { __NR_umount2, (sys_call_fn)kail_umount2_glue_pre, (sys_call_fn)kail_umount2_glue_post, (sys_call_fn)kail_umount2_glue_pre_post, (sys_call_fn)kail_umount2_glue32_pre, (sys_call_fn)kail_umount2_glue32_post, (sys_call_fn)kail_umount2_glue32_pre_post },
    { __NR_mount, (sys_call_fn)kail_mount_glue_pre, (sys_call_fn)kail_mount_glue_post, (sys_call_fn)kail_mount_glue_pre_post, (sys_call_fn)kail_mount_glue_pre, (sys_call_fn)kail_mount_glue_post, (sys_call_fn)kail_mount_glue_pre_post },
    { -1, (sys_call_fn)(sys_call_fn)(&nullp), (sys_call_fn)(sys_call_fn)(&nullp), (sys_call_fn)(sys_call_fn)(&nullp), (sys_call_fn)(sys_call_fn)(&nullp), (sys_call_fn)(sys_call_fn)(&nullp), (sys_call_fn)(sys_call_fn)(&nullp) },
};


struct syscall_table kail_syscall_list[256];


 extern long *kail_sys_call_table;


  extern long *kail_sys_call_table32;
#include <linux/sys.h>
#include <linux/security.h>
    extern struct security_operations kail_sec_ops;
struct kail_lsmhooks_table kail_lsmhooks_list[30];
long lsmMemClobberCheck[1];
asmlinkage int

kail_trap_syscalls(struct kail_syscall_prepost *syscall_prepost,struct kail_lsmhooks *lsmhooks)



{
    struct kail_syscall_prepost * prepost_table;

    struct kail_lsmhooks * lsmhooks_table;







    unsigned int lsmhookEntryCount = 0;





    ;
    ;
    ;
    kail_syscall_glue_list = &kail_syscall_glue_list_x[0];
    int indexError = 0;
    ;
    ;

    ;




    ;
    if (kail_sys_call_table == 0L) {
       printk("WARNING: !!!! kail_syscall.c kail_sys_call_table is NULL\n");
       return 2;
    }

    if (((long *)(kail_sys_call_table[0])) == 0L) {
       printk("WARNING: !!!! kail_syscall.c table is NULL\n");
         return 2;
    }
    for (prepost_table = syscall_prepost;prepost_table->call_index != -1;prepost_table++) {
            const uint32_t index = prepost_table->call_index;
            struct syscall_table *sct = &(kail_syscall_list[index]);



            struct syscall_glue_table *sc_glue_t = kail_syscall_glue_list + index;

            ;



            const uint32_t syscall_index = sc_glue_t->syscall_index;
            long *sys_call = ((long *)&(((long *)(kail_sys_call_table[0]))[syscall_index]));
            const uint32_t syscall_index32 = sc_glue_t->syscall_index;
            long *sys_call32 = ((long *)&(((long *)(kail_sys_call_table32[0]))[syscall_index32]));
            memset(sct,0,sizeof(*sct));

           if (index == 62) {

             ;
           }
           if (index != 62) {

             if (sc_glue_t->syscall_glue_pre == 0L) {
                 printk(" kail_syscall.c WHAT !!!! sc_glue_t->syscall_glue_pre is NULL \n");
                 return 1;
             }
             if ((*((long *)(sc_glue_t->syscall_glue_pre)))) {
                ;



                ;

                ;
                ;


                sct->orig_syscall = (sys_call_fn)(*sys_call);
                if (prepost_table->call_pre) {
                        if (prepost_table->call_post) {
                                ;

                                *sys_call = (unsigned long)((*((long *)(sc_glue_t->syscall_glue_pre_post))));
                        } else {
                                ;


                                *sys_call = (unsigned long)((*((long *)(sc_glue_t->syscall_glue_pre))));
                        }
                } else {
                        if (prepost_table->call_post) {
                                ;

                                *sys_call = (unsigned long)((*((long *)(sc_glue_t->syscall_glue_post))));
                        } else {
                                ;

                        }
                }




               ;
               ;
             }
          } else {
              printk("Ignoring KAIL_socketcall32 index: %d\n", index);
          }



             if (sc_glue_t->sys32call_glue_pre == 0L) {
                 printk("kail_syscall.c WHAT !!!! sc_glue_t->sys32call_glue_pre is NULL \n");
                 return 2;
             }


            if ((*((long *)(sc_glue_t->sys32call_glue_pre)))) {
                ;



                ;

                ;
                ;


                if (index == 62) {

                   struct syscall_table *sct64 = &(kail_syscall_list[58]);
                   sct->orig_sys32call = sct64->orig_sys32call;
                   printk(" KAIL_socketcall32 index: %d sct64: %lX: orig sys32call: %lX\n",
                        index, (unsigned long)sct64, (unsigned long)sct64->orig_sys32call);

                } else {

                   sct->orig_sys32call = (sys_call_fn)(*sys_call32);
                   if (prepost_table->call_pre) {
                        if (prepost_table->call_post) {
                                ;

                                *sys_call32 = (long)((*((long *)(sc_glue_t->sys32call_glue_pre_post))));
                        } else {
                                ;

                                *sys_call32 = (long)((*((long *)(sc_glue_t->sys32call_glue_pre))));
                        }
                   } else {
                        if (prepost_table->call_post) {
                                ;

                                *sys_call32 = (long)((*((long *)(sc_glue_t->sys32call_glue_post))));
                        } else {
                                ;

                        }
                   }

                }

               ;
               ;
            }
            else {
               printk("JIMK kail_syscall.c  IGNORING GLUE_ADDERSS32_PRE\n");
            }



;
;
            sct->syscall_pre = prepost_table->call_pre;
            sct->syscall_post = prepost_table->call_post;
;
;
    }

    if (indexError != 0) {
       printk("TAMOS ERROR: (%ld) prepost table indexes TOO BIG \n", indexError);
       return 1;
    }
   ;


   printk("TAMOS INFO: setting up as a security module\n");

    for (lsmhooks_table = lsmhooks;lsmhooks_table->lsmhook_index != -1;lsmhooks_table++) {
        lsmhookEntryCount++;
            const uint32_t index = lsmhooks_table->lsmhook_index;
            struct kail_lsmhooks_table *lsmh = &(kail_lsmhooks_list[index]);
            if (index >= 30) {
               printk("ERROR lsmhook_index of (%ld) is BIGGER than(%ld)\n", (long)index, (long)30);
               return -1;
            }

            if ((unsigned long)&lsmh->lsmhooks_pre >= (unsigned long)&lsmMemClobberCheck[0]) {
               printk(" ERROR lsmhook_index of (%ld) max: %ld is clobbering lsmMemClobberCheck: %lX\n",
                            (long)index, (long)30, (unsigned long)&lsmMemClobberCheck[0]);
               return -1;
            }


;
;


            lsmh->lsmhooks_pre = lsmhooks_table->lsmhook_pre;
            lsmh->lsmhooks_post = lsmhooks_table->lsmhook_post;
;
;

    }

    ;



    if (current->security != NULL) {
        printk("selinux detected (current->security=%#X) -- aborting.\n",
                        current->security);
        return -1;
    }

    if (register_security(&kail_sec_ops)) {
        ;
        ;





        if (unregister_security(security_ops)) {
           printk("TAMOS INFO: unregister didnt work... return=1\n");
           ;

           return 1;
        } else {
           ;



           if (register_security(&kail_sec_ops)) {
                printk("--> ERROR! 2nd register_security didn't work; aborting\n");
                ;

                return 1;
           }
        }

    }



    printk("TAMOS INFO: kaznmod successfully inserted (%d) as a security framework.\n", lsmhookEntryCount);


    ;
   printk("TAMOS INFO: Initialization complete\n");
    return 0;
}
EXPORT_SYMBOL(kail_trap_syscalls);







asmlinkage void
kail_restore_syscalls(void)
{

    struct syscall_table *sct;
    struct syscall_glue_table *sc_glue_t;
 printk("restoring kail syscall\n");
 return;
    for (sct = kail_syscall_list,sc_glue_t = kail_syscall_glue_list;
          sc_glue_t->syscall_index != -1;
           sct++,sc_glue_t++) {
            const uint32_t syscall_index = sc_glue_t->syscall_index;
            long *sys_call = ((long *)&(((long *)(kail_sys_call_table[0]))[syscall_index]));
            const uint32_t syscall_index32 = sc_glue_t->syscall_index;
            long *sys_call32 = ((long *)&(((long *)(kail_sys_call_table32[0]))[syscall_index32]));
            printk ("Restoring syscall[%d]=0x%X, with 0x%lX\n", syscall_index, *sys_call, sct->orig_syscall);


            printk ("Restoring syscall32[%d]=0x%X, with 0x%lX\n", syscall_index32, *sys_call32, sct->orig_syscall);



;
;
            if (sct->orig_syscall)

                    *sys_call = (long)(sct->orig_syscall);
;



;
;
            if (sct->orig_sys32call)

                    *sys_call32 = (long)(sct->orig_sys32call);
;


    }




    if (security_ops == &kail_sec_ops) {
        ;



        if (unregister_security(&kail_sec_ops)) {
                printk("--> ERROR! unregister_security didn't work \n");
                return;
        }
        ;

    } else {
        ;

    }


}
EXPORT_SYMBOL(kail_restore_syscalls);
